/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;
static struct mrt_table_config *this_mrt_table_config;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c') && (t3->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst();
    rv->code = 'C';

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->code = P('m','l');
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}

/* Headers from ../../proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from ../../proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)


/* Line 371 of yacc.c  */
#line 715 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     NMA = 277,
     DEFINE = 278,
     ON = 279,
     OFF = 280,
     YES = 281,
     NO = 282,
     S = 283,
     MS = 284,
     US = 285,
     PORT = 286,
     LOG = 287,
     SYSLOG = 288,
     ALL = 289,
     DEBUG = 290,
     TRACE = 291,
     INFO = 292,
     REMOTE = 293,
     WARNING = 294,
     ERROR = 295,
     AUTH = 296,
     FATAL = 297,
     BUG = 298,
     STDERR = 299,
     SOFT = 300,
     TIMEFORMAT = 301,
     ISO = 302,
     OLD = 303,
     SHORT = 304,
     LONG = 305,
     BASE = 306,
     NAME = 307,
     CONFIRM = 308,
     UNDO = 309,
     CHECK = 310,
     TIMEOUT = 311,
     LATENCY = 312,
     LIMIT = 313,
     WATCHDOG = 314,
     CONFIGURE = 315,
     DOWN = 316,
     KERNEL = 317,
     PERSIST = 318,
     SCAN = 319,
     TIME = 320,
     LEARN = 321,
     DEVICE = 322,
     ROUTES = 323,
     GRACEFUL = 324,
     RESTART = 325,
     KRT_SOURCE = 326,
     KRT_METRIC = 327,
     MERGE = 328,
     PATHS = 329,
     TABLE = 330,
     METRIC = 331,
     KRT_PREFSRC = 332,
     KRT_REALM = 333,
     KRT_SCOPE = 334,
     KRT_MTU = 335,
     KRT_WINDOW = 336,
     KRT_RTT = 337,
     KRT_RTTVAR = 338,
     KRT_SSTRESH = 339,
     KRT_CWND = 340,
     KRT_ADVMSS = 341,
     KRT_REORDERING = 342,
     KRT_HOPLIMIT = 343,
     KRT_INITCWND = 344,
     KRT_RTO_MIN = 345,
     KRT_INITRWND = 346,
     KRT_QUICKACK = 347,
     KRT_LOCK_MTU = 348,
     KRT_LOCK_WINDOW = 349,
     KRT_LOCK_RTT = 350,
     KRT_LOCK_RTTVAR = 351,
     KRT_LOCK_SSTRESH = 352,
     KRT_LOCK_CWND = 353,
     KRT_LOCK_ADVMSS = 354,
     KRT_LOCK_REORDERING = 355,
     KRT_LOCK_HOPLIMIT = 356,
     KRT_LOCK_RTO_MIN = 357,
     KRT_FEATURE_ECN = 358,
     KRT_FEATURE_ALLFRAG = 359,
     ROUTER = 360,
     ID = 361,
     PROTOCOL = 362,
     TEMPLATE = 363,
     PREFERENCE = 364,
     DISABLED = 365,
     DIRECT = 366,
     INTERFACE = 367,
     IMPORT = 368,
     EXPORT = 369,
     FILTER = 370,
     NONE = 371,
     STATES = 372,
     FILTERS = 373,
     RECEIVE = 374,
     ACTION = 375,
     WARN = 376,
     BLOCK = 377,
     DISABLE = 378,
     KEEP = 379,
     FILTERED = 380,
     PASSWORD = 381,
     FROM = 382,
     PASSIVE = 383,
     TO = 384,
     EVENTS = 385,
     PACKETS = 386,
     PROTOCOLS = 387,
     INTERFACES = 388,
     ALGORITHM = 389,
     KEYED = 390,
     HMAC = 391,
     MD5 = 392,
     SHA1 = 393,
     SHA256 = 394,
     SHA384 = 395,
     SHA512 = 396,
     PRIMARY = 397,
     STATS = 398,
     COUNT = 399,
     FOR = 400,
     COMMANDS = 401,
     PREEXPORT = 402,
     NOEXPORT = 403,
     GENERATE = 404,
     ROA = 405,
     LISTEN = 406,
     BGP = 407,
     V6ONLY = 408,
     DUAL = 409,
     ADDRESS = 410,
     PASSWORDS = 411,
     DESCRIPTION = 412,
     SORTED = 413,
     RELOAD = 414,
     IN = 415,
     OUT = 416,
     MRTDUMP = 417,
     MESSAGES = 418,
     RESTRICT = 419,
     MEMORY = 420,
     IGP_METRIC = 421,
     CLASS = 422,
     DSCP = 423,
     WAIT = 424,
     MAX = 425,
     FLUSH = 426,
     AS = 427,
     PERIOD = 428,
     FILENAME = 429,
     SHOW = 430,
     STATUS = 431,
     SUMMARY = 432,
     ROUTE = 433,
     SYMBOLS = 434,
     ADD = 435,
     DELETE = 436,
     DUMP = 437,
     RESOURCES = 438,
     SOCKETS = 439,
     NEIGHBORS = 440,
     ATTRIBUTES = 441,
     EVAL = 442,
     ECHO = 443,
     ENABLE = 444,
     FUNCTION = 445,
     PRINT = 446,
     PRINTN = 447,
     UNSET = 448,
     RETURN = 449,
     ACCEPT = 450,
     REJECT = 451,
     QUITBIRD = 452,
     INT = 453,
     BOOL = 454,
     IP = 455,
     PREFIX = 456,
     PAIR = 457,
     QUAD = 458,
     EC = 459,
     LC = 460,
     SET = 461,
     STRING = 462,
     BGPMASK = 463,
     BGPPATH = 464,
     CLIST = 465,
     ECLIST = 466,
     LCLIST = 467,
     IF = 468,
     THEN = 469,
     ELSE = 470,
     CASE = 471,
     TRUE = 472,
     FALSE = 473,
     RT = 474,
     RO = 475,
     UNKNOWN = 476,
     GENERIC = 477,
     GW = 478,
     NET = 479,
     MASK = 480,
     PROTO = 481,
     SOURCE = 482,
     SCOPE = 483,
     CAST = 484,
     DEST = 485,
     IFNAME = 486,
     IFINDEX = 487,
     LEN = 488,
     DEFINED = 489,
     CONTAINS = 490,
     RESET = 491,
     PREPEND = 492,
     FIRST = 493,
     LAST = 494,
     LAST_NONAGGREGATED = 495,
     MATCH = 496,
     ROA_CHECK = 497,
     EMPTY = 498,
     WHERE = 499,
     BFD = 500,
     MIN = 501,
     IDLE = 502,
     RX = 503,
     TX = 504,
     INTERVAL = 505,
     MULTIPLIER = 506,
     MULTIHOP = 507,
     NEIGHBOR = 508,
     DEV = 509,
     LOCAL = 510,
     AUTHENTICATION = 511,
     SIMPLE = 512,
     METICULOUS = 513,
     SESSIONS = 514,
     HOLD = 515,
     CONNECT = 516,
     RETRY = 517,
     KEEPALIVE = 518,
     STARTUP = 519,
     VIA = 520,
     NEXT = 521,
     HOP = 522,
     SELF = 523,
     DEFAULT = 524,
     PATH = 525,
     START = 526,
     DELAY = 527,
     FORGET = 528,
     AFTER = 529,
     BGP_PATH = 530,
     BGP_LOCAL_PREF = 531,
     BGP_MED = 532,
     BGP_ORIGIN = 533,
     BGP_NEXT_HOP = 534,
     BGP_ATOMIC_AGGR = 535,
     BGP_AGGREGATOR = 536,
     BGP_COMMUNITY = 537,
     BGP_EXT_COMMUNITY = 538,
     RR = 539,
     RS = 540,
     CLIENT = 541,
     CLUSTER = 542,
     AS4 = 543,
     ADVERTISE = 544,
     IPV4 = 545,
     CAPABILITIES = 546,
     PREFER = 547,
     OLDER = 548,
     MISSING = 549,
     LLADDR = 550,
     DROP = 551,
     IGNORE = 552,
     REFRESH = 553,
     INTERPRET = 554,
     COMMUNITIES = 555,
     BGP_ORIGINATOR_ID = 556,
     BGP_CLUSTER_LIST = 557,
     IGP = 558,
     GATEWAY = 559,
     RECURSIVE = 560,
     MED = 561,
     TTL = 562,
     SECURITY = 563,
     DETERMINISTIC = 564,
     SECONDARY = 565,
     ALLOW = 566,
     AWARE = 567,
     LINK = 568,
     EXTENDED = 569,
     SETKEY = 570,
     BGP_LARGE_COMMUNITY = 571,
     OSPF = 572,
     AREA = 573,
     OSPF_METRIC1 = 574,
     OSPF_METRIC2 = 575,
     OSPF_TAG = 576,
     OSPF_ROUTER_ID = 577,
     RFC1583COMPAT = 578,
     STUB = 579,
     TICK = 580,
     COST = 581,
     COST2 = 582,
     RETRANSMIT = 583,
     HELLO = 584,
     TRANSMIT = 585,
     PRIORITY = 586,
     DEAD = 587,
     TYPE = 588,
     BROADCAST = 589,
     BCAST = 590,
     NONBROADCAST = 591,
     NBMA = 592,
     POINTOPOINT = 593,
     PTP = 594,
     POINTOMULTIPOINT = 595,
     PTMP = 596,
     STRICT = 597,
     CRYPTOGRAPHIC = 598,
     ELIGIBLE = 599,
     POLL = 600,
     NETWORKS = 601,
     HIDDEN = 602,
     VIRTUAL = 603,
     ONLY = 604,
     BUFFER = 605,
     LARGE = 606,
     NORMAL = 607,
     STUBNET = 608,
     TAG = 609,
     EXTERNAL = 610,
     LSADB = 611,
     ECMP = 612,
     WEIGHT = 613,
     NSSA = 614,
     TRANSLATOR = 615,
     STABILITY = 616,
     GLOBAL = 617,
     LSID = 618,
     INSTANCE = 619,
     REAL = 620,
     NETMASK = 621,
     LENGTH = 622,
     LSA = 623,
     SUPPRESSION = 624,
     TOPOLOGY = 625,
     STATE = 626,
     PIPE = 627,
     PEER = 628,
     MODE = 629,
     OPAQUE = 630,
     TRANSPARENT = 631,
     RADV = 632,
     RA = 633,
     MANAGED = 634,
     OTHER = 635,
     CONFIG = 636,
     MTU = 637,
     REACHABLE = 638,
     RETRANS = 639,
     TIMER = 640,
     CURRENT = 641,
     VALID = 642,
     PREFERRED = 643,
     MULT = 644,
     LIFETIME = 645,
     SKIP = 646,
     ONLINK = 647,
     AUTONOMOUS = 648,
     RDNSS = 649,
     DNSSL = 650,
     NS = 651,
     DOMAIN = 652,
     TRIGGER = 653,
     SENSITIVE = 654,
     LOW = 655,
     MEDIUM = 656,
     HIGH = 657,
     RIP = 658,
     INFINITY = 659,
     UPDATE = 660,
     GARBAGE = 661,
     MULTICAST = 662,
     VERSION = 663,
     SPLIT = 664,
     HORIZON = 665,
     POISON = 666,
     REVERSE = 667,
     ZERO = 668,
     PLAINTEXT = 669,
     RIP_METRIC = 670,
     RIP_TAG = 671,
     STATIC = 672,
     PROHIBIT = 673,
     MULTIPATH = 674,
     BLACKHOLE = 675,
     UNREACHABLE = 676,
     BABEL = 677,
     RXCOST = 678,
     WIRED = 679,
     WIRELESS = 680,
     BABEL_METRIC = 681,
     ENTRIES = 682
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 643 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 1213 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1241 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  74
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3549

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  449
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  327
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1087
/* YYNRULES -- Number of states.  */
#define YYNSTATES  2045

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   682

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     440,   441,    29,    27,   445,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   442,   439,
      23,    22,    24,   446,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   447,     2,   448,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   443,     2,   444,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    30,    33,    36,    38,    40,    42,    44,    46,    47,
      49,    51,    52,    55,    58,    60,    62,    65,    68,    70,
      72,    74,    76,    77,    82,    85,    86,    88,    91,    93,
      95,    99,   101,   105,   107,   109,   111,   113,   115,   117,
     119,   121,   123,   128,   132,   136,   138,   140,   142,   144,
     147,   152,   156,   160,   164,   168,   172,   176,   181,   185,
     189,   194,   200,   204,   208,   213,   216,   217,   219,   220,
     222,   225,   228,   229,   232,   235,   239,   242,   246,   250,
     255,   258,   262,   266,   270,   273,   278,   284,   286,   290,
     292,   294,   296,   301,   302,   305,   308,   311,   313,   315,
     321,   322,   324,   328,   332,   333,   342,   344,   349,   351,
     353,   354,   356,   359,   363,   364,   367,   370,   373,   376,
     379,   382,   386,   390,   394,   399,   402,   406,   409,   412,
     414,   416,   418,   419,   422,   425,   428,   431,   434,   436,
     438,   442,   446,   447,   449,   451,   454,   455,   457,   461,
     463,   467,   469,   470,   473,   476,   479,   482,   486,   490,
     494,   500,   501,   505,   507,   509,   513,   515,   519,   521,
     523,   525,   527,   529,   531,   533,   535,   539,   541,   545,
     547,   549,   550,   555,   558,   560,   563,   564,   567,   571,
     573,   575,   578,   581,   584,   586,   591,   593,   594,   598,
     603,   605,   608,   609,   615,   621,   627,   633,   638,   643,
     648,   653,   656,   659,   662,   665,   668,   671,   674,   677,
     680,   683,   687,   691,   696,   702,   704,   705,   709,   714,
     719,   720,   723,   727,   731,   735,   738,   741,   744,   747,
     751,   755,   758,   761,   763,   765,   767,   772,   773,   777,
     781,   785,   786,   788,   790,   795,   796,   799,   802,   805,
     808,   811,   814,   817,   818,   821,   831,   841,   846,   850,
     854,   858,   862,   866,   870,   874,   878,   882,   887,   889,
     891,   895,   896,   898,   902,   906,   910,   914,   919,   924,
     929,   934,   939,   942,   943,   945,   948,   951,   954,   956,
     959,   961,   963,   965,   967,   968,   970,   971,   976,   979,
     981,   983,   985,   987,   989,   991,   993,   995,   997,   999,
    1001,  1003,  1005,  1007,  1010,  1013,  1014,  1018,  1020,  1024,
    1026,  1028,  1030,  1033,  1037,  1040,  1045,  1046,  1052,  1053,
    1055,  1057,  1060,  1062,  1066,  1068,  1070,  1072,  1074,  1076,
    1080,  1082,  1084,  1088,  1090,  1092,  1094,  1096,  1102,  1110,
    1116,  1124,  1134,  1142,  1148,  1156,  1162,  1174,  1176,  1178,
    1181,  1183,  1191,  1201,  1209,  1217,  1227,  1235,  1245,  1253,
    1263,  1271,  1287,  1289,  1291,  1293,  1295,  1299,  1301,  1303,
    1305,  1307,  1311,  1313,  1317,  1319,  1323,  1327,  1329,  1332,
    1335,  1342,  1344,  1348,  1349,  1354,  1358,  1360,  1364,  1368,
    1372,  1375,  1380,  1383,  1386,  1389,  1390,  1393,  1396,  1397,
    1399,  1401,  1403,  1405,  1407,  1409,  1411,  1415,  1419,  1421,
    1423,  1429,  1437,  1445,  1446,  1451,  1453,  1455,  1457,  1459,
    1461,  1463,  1465,  1467,  1469,  1471,  1473,  1477,  1481,  1485,
    1489,  1493,  1497,  1501,  1505,  1509,  1513,  1517,  1521,  1525,
    1529,  1533,  1536,  1541,  1543,  1545,  1547,  1549,  1552,  1555,
    1559,  1563,  1570,  1574,  1578,  1582,  1586,  1590,  1596,  1604,
    1611,  1618,  1625,  1632,  1637,  1646,  1651,  1653,  1655,  1657,
    1659,  1661,  1663,  1665,  1666,  1668,  1672,  1674,  1678,  1679,
    1681,  1686,  1693,  1698,  1702,  1708,  1714,  1719,  1726,  1730,
    1733,  1739,  1745,  1754,  1763,  1772,  1781,  1784,  1786,  1789,
    1792,  1795,  1796,  1800,  1806,  1807,  1808,  1811,  1816,  1821,
    1826,  1829,  1832,  1835,  1837,  1839,  1841,  1844,  1847,  1851,
    1855,  1856,  1860,  1861,  1865,  1870,  1874,  1875,  1878,  1881,
    1882,  1885,  1886,  1889,  1894,  1900,  1903,  1904,  1908,  1912,
    1916,  1920,  1926,  1933,  1938,  1945,  1950,  1957,  1962,  1967,
    1973,  1980,  1984,  1988,  1993,  1999,  2005,  2011,  2017,  2023,
    2028,  2033,  2039,  2045,  2051,  2057,  2063,  2069,  2075,  2081,
    2088,  2095,  2102,  2108,  2115,  2124,  2131,  2138,  2144,  2151,
    2156,  2162,  2167,  2172,  2178,  2183,  2189,  2194,  2200,  2206,
    2212,  2218,  2225,  2231,  2237,  2244,  2250,  2256,  2262,  2267,
    2270,  2274,  2278,  2280,  2283,  2287,  2290,  2295,  2299,  2302,
    2306,  2308,  2311,  2316,  2317,  2321,  2324,  2326,  2329,  2333,
    2337,  2341,  2345,  2348,  2352,  2353,  2359,  2360,  2366,  2369,
    2372,  2374,  2379,  2381,  2383,  2384,  2388,  2391,  2394,  2397,
    2403,  2406,  2407,  2411,  2412,  2415,  2418,  2422,  2425,  2428,
    2432,  2435,  2438,  2441,  2443,  2447,  2450,  2453,  2456,  2459,
    2462,  2465,  2469,  2472,  2475,  2478,  2481,  2484,  2487,  2490,
    2493,  2497,  2501,  2505,  2508,  2512,  2515,  2519,  2523,  2528,
    2533,  2536,  2539,  2542,  2546,  2550,  2554,  2557,  2561,  2565,
    2569,  2574,  2577,  2580,  2582,  2583,  2586,  2590,  2592,  2593,
    2595,  2598,  2599,  2602,  2603,  2605,  2609,  2610,  2611,  2614,
    2615,  2619,  2620,  2624,  2625,  2629,  2633,  2635,  2636,  2641,
    2648,  2655,  2662,  2670,  2677,  2685,  2691,  2692,  2695,  2699,
    2702,  2706,  2710,  2713,  2717,  2720,  2723,  2727,  2731,  2737,
    2742,  2747,  2750,  2752,  2755,  2758,  2759,  2763,  2764,  2768,
    2771,  2772,  2776,  2782,  2783,  2788,  2793,  2797,  2800,  2804,
    2808,  2812,  2816,  2821,  2826,  2830,  2833,  2834,  2838,  2839,
    2843,  2847,  2851,  2853,  2855,  2857,  2858,  2859,  2863,  2864,
    2868,  2873,  2875,  2878,  2881,  2884,  2889,  2894,  2895,  2896,
    2900,  2901,  2905,  2909,  2911,  2912,  2913,  2916,  2919,  2920,
    2921,  2925,  2927,  2933,  2935,  2936,  2937,  2940,  2943,  2944,
    2945,  2949,  2951,  2957,  2959,  2962,  2963,  2966,  2969,  2971,
    2974,  2979,  2982,  2985,  2986,  2990,  2996,  2997,  2998,  3001,
    3004,  3007,  3010,  3013,  3016,  3019,  3023,  3027,  3031,  3035,
    3039,  3043,  3047,  3051,  3055,  3059,  3062,  3066,  3070,  3075,
    3079,  3082,  3085,  3087,  3089,  3091,  3093,  3095,  3096,  3100,
    3101,  3105,  3110,  3117,  3124,  3127,  3131,  3135,  3141,  3147,
    3152,  3155,  3159,  3163,  3167,  3169,  3172,  3177,  3181,  3185,
    3189,  3192,  3195,  3198,  3201,  3204,  3206,  3210,  3211,  3214,
    3215,  3219,  3224,  3227,  3229,  3232,  3233,  3237,  3243,  3244,
    3245,  3246,  3249,  3252,  3256,  3260,  3263,  3266,  3270,  3274,
    3277,  3281,  3285,  3286,  3290,  3291,  3295,  3300,  3307,  3314,
    3321,  3323,  3325,  3327,  3329,  3331,  3333,  3335,  3337,  3339,
    3341,  3343,  3345,  3347,  3349,  3351,  3353,  3355,  3357,  3359,
    3361,  3363,  3365,  3367,  3369,  3371,  3373,  3375,  3377,  3379,
    3381,  3383,  3385,  3387,  3389,  3391,  3393,  3395,  3397,  3399,
    3401,  3403,  3405,  3407,  3409,  3411,  3413,  3415,  3417,  3419,
    3421,  3423,  3425,  3427,  3429,  3431,  3433,  3435,  3437,  3439,
    3441,  3443,  3445,  3447,  3449,  3451,  3453,  3455,  3457,  3459,
    3462,  3465,  3468,  3470,  3473,  3476,  3479,  3481,  3483,  3486,
    3488,  3492,  3496,  3500,  3504,  3508,  3512,  3516,  3518,  3520,
    3522,  3524,  3526,  3528,  3530,  3532,  3534,  3536,  3538,  3540,
    3542,  3544,  3546,  3548,  3550,  3552,  3554,  3556,  3558,  3560,
    3562,  3564,  3566,  3568,  3570,  3572,  3574,  3576,  3578,  3580,
    3582,  3584,  3586,  3588,  3590,  3592,  3594,  3596,  3598,  3600,
    3602,  3604,  3606,  3608,  3610,  3612,  3614,  3616
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     450,     0,    -1,   451,     3,    -1,     4,   771,    -1,    -1,
     451,   770,    -1,    34,    19,    22,   628,   439,    -1,    15,
      -1,   440,   628,   441,    -1,    19,    -1,   453,    39,    -1,
     453,    40,    -1,   453,    41,    -1,   453,    -1,    35,    -1,
      37,    -1,    36,    -1,    38,    -1,    -1,    18,    -1,    19,
      -1,    -1,    31,    19,    -1,   456,   460,    -1,   458,    -1,
     456,    -1,    30,   453,    -1,   442,   456,    -1,    20,    -1,
      20,    -1,    19,    -1,    20,    -1,    -1,    43,   466,   467,
     439,    -1,    63,   462,    -1,    -1,   462,    -1,    44,   465,
      -1,    55,    -1,    45,    -1,   443,   468,   444,    -1,   469,
      -1,   468,   445,   469,    -1,    46,    -1,    47,    -1,    48,
      -1,    49,    -1,    50,    -1,    51,    -1,    52,    -1,    53,
      -1,    54,    -1,   173,   143,   524,   439,    -1,   173,    79,
     528,    -1,   173,   462,   439,    -1,   189,    -1,   118,    -1,
      62,    -1,    43,    -1,   471,    20,    -1,   471,    20,   453,
      20,    -1,   471,    58,    60,    -1,   471,    58,    61,    -1,
     471,    59,    60,    -1,   471,    59,    61,    -1,    57,   472,
     439,    -1,    46,    68,   455,    -1,    46,    68,    69,   454,
      -1,    70,    50,   454,    -1,    70,    67,   454,    -1,    71,
     481,   482,     3,    -1,    71,    56,   481,   482,     3,    -1,
      71,    64,     3,    -1,    71,    65,     3,    -1,    71,    66,
     481,     3,    -1,    72,     3,    -1,    -1,    20,    -1,    -1,
      67,    -1,    67,   453,    -1,   500,    73,    -1,    -1,    69,
     453,    -1,    74,   455,    -1,    75,    76,   453,    -1,    77,
     455,    -1,    78,    79,   455,    -1,    80,    81,   455,    -1,
      84,    85,   455,   484,    -1,   500,    78,    -1,    75,    76,
     453,    -1,   153,   463,   459,    -1,    73,    86,   453,    -1,
      87,   453,    -1,   116,   117,   490,   439,    -1,   116,   117,
     138,   515,   439,    -1,    15,    -1,   440,   628,   441,    -1,
      17,    -1,    18,    -1,    19,    -1,   162,   163,   492,   439,
      -1,    -1,   492,   493,    -1,   166,   456,    -1,    42,   453,
      -1,   164,    -1,   165,    -1,    80,    81,   180,   453,   439,
      -1,    -1,   169,    -1,    86,    19,   495,    -1,   161,    86,
      19,    -1,    -1,   498,   161,   458,   181,    15,   183,    15,
     439,    -1,   497,    -1,   497,   443,   498,   444,    -1,   118,
      -1,   119,    -1,    -1,    19,    -1,   138,    19,    -1,    19,
     138,    19,    -1,    -1,   120,   453,    -1,   121,   455,    -1,
      46,   521,    -1,   173,   524,    -1,   124,   503,    -1,   125,
     503,    -1,   130,    69,   505,    -1,   124,    69,   505,    -1,
     125,    69,   505,    -1,   124,   135,   136,   455,    -1,    86,
     506,    -1,   116,   117,   490,    -1,   168,   462,    -1,   126,
     593,    -1,   594,    -1,    45,    -1,   127,    -1,    -1,   131,
     132,    -1,   131,   133,    -1,   131,    81,    -1,   131,   134,
      -1,   453,   504,    -1,    36,    -1,    19,    -1,    46,   143,
     521,    -1,    46,   157,   453,    -1,    -1,    20,    -1,   459,
      -1,    20,   459,    -1,    -1,    28,    -1,   508,   510,   509,
      -1,   511,    -1,   512,   445,   511,    -1,   512,    -1,    -1,
     514,   512,    -1,   178,   453,    -1,   179,   453,    -1,   500,
     122,    -1,   517,   501,   443,    -1,   518,   502,   439,    -1,
     518,   520,   439,    -1,   518,    66,   324,   455,   439,    -1,
      -1,   123,   519,   512,    -1,    45,    -1,    36,    -1,   443,
     522,   444,    -1,   523,    -1,   522,   445,   523,    -1,   128,
      -1,    79,    -1,   129,    -1,   144,    -1,   141,    -1,   142,
      -1,    45,    -1,    36,    -1,   443,   525,   444,    -1,   526,
      -1,   525,   445,   526,    -1,   128,    -1,   174,    -1,    -1,
     443,   527,   530,   444,    -1,   527,   439,    -1,   594,    -1,
     126,   593,    -1,    -1,   532,   439,    -1,   530,   532,   439,
      -1,   506,    -1,    20,    -1,   184,   453,    -1,   185,   462,
      -1,    86,   531,    -1,   529,    -1,   167,   443,   534,   444,
      -1,   535,    -1,    -1,   535,   439,   534,    -1,   536,   443,
     537,   444,    -1,   536,    -1,   137,   462,    -1,    -1,   160,
     138,   461,   439,   537,    -1,   160,   140,   461,   439,   537,
      -1,   206,   138,   461,   439,   537,    -1,   206,   140,   461,
     439,   537,    -1,   138,   461,   439,   537,    -1,   140,   461,
     439,   537,    -1,   117,   453,   439,   537,    -1,   145,   538,
     439,   537,    -1,   146,   148,    -1,   146,   149,    -1,   146,
     150,    -1,   146,   151,    -1,   146,   152,    -1,   147,   148,
      -1,   147,   149,    -1,   147,   150,    -1,   147,   151,    -1,
     147,   152,    -1,   186,   187,     3,    -1,   186,   176,     3,
      -1,   186,   143,   584,     3,    -1,   186,   143,    45,   584,
       3,    -1,    19,    -1,    -1,   186,   144,     3,    -1,   186,
     144,   188,     3,    -1,   186,   189,   547,     3,    -1,    -1,
     547,   458,    -1,   547,   156,   459,    -1,   547,    86,    19,
      -1,   547,   126,   593,    -1,   547,   594,    -1,   547,    45,
      -1,   547,   153,    -1,   547,   136,    -1,   547,   548,    19,
      -1,   547,   118,    19,    -1,   547,   154,    -1,   547,   155,
      -1,   158,    -1,   125,    -1,   159,    -1,   186,   161,   550,
       3,    -1,    -1,   550,   551,   458,    -1,   550,   183,    15,
      -1,   550,    86,    19,    -1,    -1,   171,    -1,   156,    -1,
     186,   190,   553,     3,    -1,    -1,   553,    86,    -1,   553,
     201,    -1,   553,   126,    -1,   553,   118,    -1,   553,   119,
      -1,   553,   161,    -1,   553,    19,    -1,    -1,    86,    19,
      -1,   191,   161,   458,   181,    15,   183,    15,   554,     3,
      -1,   192,   161,   458,   181,    15,   183,    15,   554,     3,
      -1,   182,   161,   554,     3,    -1,   193,   194,     3,    -1,
     193,   195,     3,    -1,   193,   141,     3,    -1,   193,   144,
       3,    -1,   193,   196,     3,    -1,   193,   197,     3,    -1,
     193,    79,     3,    -1,   193,   143,     3,    -1,   198,   628,
       3,    -1,   199,   568,   569,     3,    -1,    45,    -1,    36,
      -1,   443,   468,   444,    -1,    -1,    15,    -1,   134,   583,
       3,    -1,   200,   583,     3,    -1,    81,   583,     3,    -1,
     170,   583,     3,    -1,   170,   171,   583,     3,    -1,   170,
     172,   583,     3,    -1,    46,   583,   521,     3,    -1,   173,
     583,   524,     3,    -1,   173,    79,   579,     3,    -1,   527,
     580,    -1,    -1,   581,    -1,   580,   581,    -1,    86,   531,
      -1,   140,   462,    -1,   529,    -1,   175,     3,    -1,    19,
      -1,    45,    -1,    20,    -1,    19,    -1,    -1,    20,    -1,
      -1,   126,    19,   586,   592,    -1,   198,   628,    -1,   209,
      -1,   210,    -1,   211,    -1,   212,    -1,   213,    -1,   214,
      -1,   215,    -1,   216,    -1,   218,    -1,   219,    -1,   220,
      -1,   221,    -1,   222,    -1,   223,    -1,   588,   217,    -1,
     588,    19,    -1,    -1,   589,   439,   590,    -1,   589,    -1,
     589,   439,   591,    -1,   596,    -1,    19,    -1,   592,    -1,
     255,   628,    -1,   440,   591,   441,    -1,   440,   441,    -1,
     590,   443,   599,   444,    -1,    -1,   201,    19,   598,   595,
     596,    -1,    -1,   600,    -1,   634,    -1,   600,   634,    -1,
     634,    -1,   443,   599,   444,    -1,    18,    -1,    15,    -1,
      17,    -1,   602,    -1,    16,    -1,   440,   628,   441,    -1,
      19,    -1,    15,    -1,   440,   628,   441,    -1,    17,    -1,
     602,    -1,    16,    -1,   628,    -1,   440,   605,   445,   605,
     441,    -1,   440,   605,   445,   605,     7,   605,   441,    -1,
     440,   605,   445,    29,   441,    -1,   440,   605,     7,   605,
     445,   605,   441,    -1,   440,   605,     7,   605,   445,   605,
       7,   605,   441,    -1,   440,   605,     7,   605,   445,    29,
     441,    -1,   440,    29,   445,   605,   441,    -1,   440,    29,
     445,   605,     7,   605,   441,    -1,   440,    29,   445,    29,
     441,    -1,   440,   605,   445,   605,   441,     7,   440,   605,
     445,   605,   441,    -1,   230,    -1,   231,    -1,   232,    15,
      -1,   233,    -1,   440,   607,   445,   605,   445,   605,   441,
      -1,   440,   607,   445,   605,   445,   605,     7,   605,   441,
      -1,   440,   607,   445,   605,   445,    29,   441,    -1,   440,
     605,   445,   605,   445,   605,   441,    -1,   440,   605,   445,
     605,   445,   605,     7,   605,   441,    -1,   440,   605,   445,
     605,   445,    29,   441,    -1,   440,   605,   445,   605,     7,
     605,   445,    29,   441,    -1,   440,   605,   445,    29,   445,
      29,   441,    -1,   440,   605,     7,   605,   445,    29,   445,
      29,   441,    -1,   440,    29,   445,    29,   445,    29,   441,
      -1,   440,   605,   445,   605,   445,   605,   441,     7,   440,
     605,   445,   605,   445,   605,   441,    -1,   606,    -1,   608,
      -1,   609,    -1,   603,    -1,   603,     7,   603,    -1,   606,
      -1,   608,    -1,   609,    -1,   604,    -1,   604,     7,   604,
      -1,   610,    -1,   612,   445,   610,    -1,   611,    -1,   613,
     445,   611,    -1,    18,    30,    15,    -1,   614,    -1,   614,
      27,    -1,   614,    28,    -1,   614,   443,    15,   445,    15,
     444,    -1,   615,    -1,   616,   445,   615,    -1,    -1,   617,
     613,   442,   599,    -1,   617,     6,   599,    -1,   626,    -1,
     440,   628,   441,    -1,    13,   620,    14,    -1,    30,   621,
      30,    -1,    15,   620,    -1,    15,     7,    15,   620,    -1,
      29,   620,    -1,   446,   620,    -1,   618,   620,    -1,    -1,
      15,   621,    -1,   446,   621,    -1,    -1,    15,    -1,   228,
      -1,   229,    -1,    20,    -1,   602,    -1,   614,    -1,    17,
      -1,   447,   612,   448,    -1,   447,   616,   448,    -1,    16,
      -1,   619,    -1,   440,   628,   445,   628,   441,    -1,   440,
     607,   445,   628,   445,   628,   441,    -1,   440,   628,   445,
     628,   445,   628,   441,    -1,    -1,    19,   440,   633,   441,
      -1,    19,    -1,   138,    -1,   234,    -1,   235,    -1,   237,
      -1,   238,    -1,   239,    -1,   240,    -1,   241,    -1,   242,
      -1,   243,    -1,   440,   628,   441,    -1,   628,    27,   628,
      -1,   628,    28,   628,    -1,   628,    29,   628,    -1,   628,
      30,   628,    -1,   628,    11,   628,    -1,   628,    12,   628,
      -1,   628,    22,   628,    -1,   628,    10,   628,    -1,   628,
      23,   628,    -1,   628,     9,   628,    -1,   628,    24,   628,
      -1,   628,     8,   628,    -1,   628,    25,   628,    -1,   628,
      26,   628,    -1,    32,   628,    -1,   245,   440,   628,   441,
      -1,   626,    -1,   622,    -1,   623,    -1,   120,    -1,   624,
     627,    -1,   624,   775,    -1,   628,    33,   211,    -1,   628,
      33,   244,    -1,   628,    33,   236,   440,   628,   441,    -1,
     628,    33,   249,    -1,   628,    33,   250,    -1,   628,    33,
     251,    -1,    27,   254,    27,    -1,    28,   254,    28,    -1,
      28,    28,   254,    28,    28,    -1,    28,    28,    28,   254,
      28,    28,    28,    -1,   248,   440,   628,   445,   628,   441,
      -1,   191,   440,   628,   445,   628,   441,    -1,   192,   440,
     628,   445,   628,   441,    -1,   126,   440,   628,   445,   628,
     441,    -1,   253,   440,    19,   441,    -1,   253,   440,    19,
     445,   628,   445,   628,   441,    -1,    19,   440,   633,   441,
      -1,   208,    -1,   206,    -1,   207,    -1,    51,    -1,   202,
      -1,   203,    -1,   628,    -1,    -1,   630,    -1,   630,   445,
     631,    -1,   628,    -1,   628,   445,   632,    -1,    -1,   632,
      -1,   224,   628,   225,   601,    -1,   224,   628,   225,   601,
     226,   601,    -1,    19,    22,   628,   439,    -1,   205,   628,
     439,    -1,   624,   775,    22,   628,   439,    -1,   624,   627,
      22,   628,   439,    -1,   120,    22,   628,   439,    -1,   204,
     440,   624,   775,   441,   439,    -1,   629,   631,   439,    -1,
     625,   439,    -1,   227,   628,   443,   617,   444,    -1,   624,
     775,    33,   254,   439,    -1,   624,   775,    33,   248,   440,
     628,   441,   439,    -1,   624,   775,    33,   191,   440,   628,
     441,   439,    -1,   624,   775,    33,   192,   440,   628,   441,
     439,    -1,   624,   775,    33,   126,   440,   628,   441,   439,
      -1,   500,   256,    -1,   502,    -1,   123,   645,    -1,   263,
     646,    -1,   264,   650,    -1,    -1,   637,   636,   439,    -1,
     635,   501,   443,   637,   444,    -1,    -1,    -1,   261,   454,
      -1,   257,   259,   261,   454,    -1,   257,   260,   261,   454,
      -1,   258,   260,   261,   454,    -1,   262,   453,    -1,   139,
     455,    -1,   267,   642,    -1,   533,    -1,   127,    -1,   268,
      -1,   146,   148,    -1,   146,   149,    -1,   269,   146,   148,
      -1,   269,   146,   149,    -1,    -1,   643,   641,   439,    -1,
      -1,   443,   643,   444,    -1,   639,   513,   644,   640,    -1,
     639,   644,   640,    -1,    -1,    31,    19,    -1,   265,   462,
      -1,    -1,   266,   456,    -1,    -1,   263,   455,    -1,   456,
     647,   648,   649,    -1,   186,   256,   270,   543,     3,    -1,
     500,   163,    -1,    -1,   653,    42,   453,    -1,   653,   183,
     453,    -1,   652,   501,   443,    -1,   654,   502,   439,    -1,
     654,   266,   183,   453,   439,    -1,   654,   266,   456,   183,
     453,   439,    -1,   654,   264,   653,   439,    -1,   654,   264,
     456,   457,   653,   439,    -1,   654,   123,    20,   439,    -1,
     654,   295,   298,   117,   490,   439,    -1,   654,   295,   297,
     439,    -1,   654,   296,   297,   439,    -1,   654,   271,    76,
     453,   439,    -1,   654,   275,   271,    76,   453,   439,    -1,
     654,   122,   439,    -1,   654,   263,   439,    -1,   654,   263,
     453,   439,    -1,   654,   277,   278,   279,   439,    -1,   654,
     277,   278,   135,   439,    -1,   654,   305,   306,   279,   439,
      -1,   654,   305,   306,   307,   439,    -1,   654,   305,   306,
     308,   439,    -1,   654,   315,   122,   439,    -1,   654,   315,
     316,   439,    -1,   654,   281,    87,   455,   439,    -1,   654,
     317,    87,   455,   439,    -1,   654,   314,    87,   455,   439,
      -1,   654,   303,   304,   455,   439,    -1,   654,   320,   317,
     455,   439,    -1,   654,   280,   288,   453,   439,    -1,   654,
     280,   287,   453,   439,    -1,   654,   238,   166,   456,   439,
      -1,   654,   282,   283,    76,   453,   439,    -1,   654,   272,
     283,    76,   453,   439,    -1,   654,   272,   273,    76,   453,
     439,    -1,   654,   274,    76,   453,   439,    -1,   654,    51,
     284,    76,   453,   439,    -1,   654,    51,   180,    76,   453,
     445,   453,   439,    -1,   654,   134,   285,    51,   455,   439,
      -1,   654,   200,   189,   309,   455,   439,    -1,   654,   200,
     299,   455,   439,    -1,   654,   200,   325,   174,   455,   439,
      -1,   654,   302,   455,   439,    -1,   654,   300,   301,   455,
     439,    -1,   654,   137,   462,   439,    -1,   654,   326,   455,
     439,    -1,   654,   189,    69,   453,   439,    -1,   654,   139,
     455,   439,    -1,   654,   310,   311,   455,   439,    -1,   654,
     321,   455,   439,    -1,   654,   191,    85,   259,   439,    -1,
     654,   191,    85,   260,   439,    -1,   654,   191,    85,   455,
     439,    -1,   654,   322,   266,   183,   439,    -1,   654,   322,
     266,   183,   453,   439,    -1,   654,    80,    81,   455,   439,
      -1,   654,    80,    81,   323,   439,    -1,   654,    80,    81,
      76,   453,   439,    -1,   654,   314,    86,   506,   439,    -1,
     654,   318,   319,   455,   439,    -1,   654,    66,   324,   455,
     439,    -1,   654,   256,   455,   439,    -1,   500,   328,    -1,
     655,   501,   443,    -1,   656,   657,   439,    -1,   502,    -1,
     334,   455,    -1,   335,   116,   455,    -1,   368,   455,    -1,
     368,   455,    69,   453,    -1,    84,   366,   455,    -1,   336,
     453,    -1,   375,   117,   453,    -1,   659,    -1,   329,   490,
      -1,   658,   443,   660,   444,    -1,    -1,   660,   661,   439,
      -1,   335,   455,    -1,   370,    -1,   188,   455,    -1,   280,
     370,   455,    -1,   280,   337,   453,    -1,   280,   338,   453,
      -1,   335,   337,   453,    -1,   371,   455,    -1,   371,   372,
     453,    -1,    -1,   357,   662,   443,   673,   444,    -1,    -1,
     366,   663,   443,   673,   444,    -1,   364,   664,    -1,   123,
     686,    -1,   668,    -1,   665,   443,   666,   444,    -1,   665,
      -1,   458,    -1,    -1,   666,   667,   439,    -1,   358,   455,
      -1,   188,   455,    -1,   337,   453,    -1,   671,   681,   443,
     669,   444,    -1,   671,   681,    -1,    -1,   669,   670,   439,
      -1,    -1,   340,   453,    -1,   339,   453,    -1,   341,   283,
     453,    -1,   180,   453,    -1,   343,   453,    -1,   343,   155,
     453,    -1,   267,   127,    -1,   267,   268,    -1,   267,   354,
      -1,   533,    -1,   359,   324,   490,    -1,   337,   453,    -1,
     340,   453,    -1,   356,   453,    -1,   339,   453,    -1,   180,
     453,    -1,   343,   453,    -1,   343,   155,   453,    -1,   344,
     345,    -1,   344,   346,    -1,   344,   347,    -1,   344,   348,
      -1,   344,   349,    -1,   344,   350,    -1,   344,   351,    -1,
     344,   352,    -1,   376,   345,   455,    -1,   350,   377,   455,
      -1,   341,   283,   453,    -1,   342,   453,    -1,   353,   347,
     455,    -1,   335,   455,    -1,    66,   324,   455,    -1,   368,
     369,   453,    -1,   324,   379,   380,   455,    -1,   196,   443,
     677,   444,    -1,   267,   127,    -1,   267,   268,    -1,   267,
     354,    -1,   259,   361,   363,    -1,   259,   361,   362,    -1,
     259,   361,   453,    -1,   260,   516,    -1,   260,   342,   453,
      -1,   260,   378,   453,    -1,   318,   319,   455,    -1,   318,
     319,   260,   360,    -1,   256,   455,    -1,   321,   455,    -1,
     533,    -1,    -1,   673,   674,    -1,   675,   676,   439,    -1,
     458,    -1,    -1,   358,    -1,   365,   453,    -1,    -1,   677,
     679,    -1,    -1,   355,    -1,   456,   678,   439,    -1,    -1,
      -1,   375,   453,    -1,    -1,   512,   683,   681,    -1,    -1,
     684,   672,   439,    -1,    -1,   443,   684,   444,    -1,   680,
     682,   685,    -1,    20,    -1,    -1,   186,   328,   543,     3,
      -1,   186,   328,   196,   543,   687,     3,    -1,   186,   328,
     123,   543,   687,     3,    -1,   186,   328,   381,   543,   687,
       3,    -1,   186,   328,   381,    45,   543,   687,     3,    -1,
     186,   328,   382,   543,   687,     3,    -1,   186,   328,   382,
      45,   543,   687,     3,    -1,   186,   328,   367,   696,     3,
      -1,    -1,   696,   373,    -1,   696,   329,   490,    -1,   696,
     324,    -1,   696,   344,    15,    -1,   696,   374,   490,    -1,
     696,   279,    -1,   696,   116,   490,    -1,   696,    19,    -1,
     500,   383,    -1,   697,   501,   443,    -1,   698,   502,   439,
      -1,   698,   384,    86,    19,   439,    -1,   698,   385,   386,
     439,    -1,   698,   385,   387,   439,    -1,   500,   388,    -1,
     502,    -1,   123,   713,    -1,   212,   719,    -1,    -1,   405,
     701,   725,    -1,    -1,   406,   702,   731,    -1,   409,   458,
      -1,    -1,   703,   700,   439,    -1,   699,   501,   443,   703,
     444,    -1,    -1,   257,   389,   261,   453,    -1,   181,   389,
     261,   453,    -1,   257,   283,   453,    -1,   390,   455,    -1,
     391,   392,   455,    -1,   324,   393,   453,    -1,   394,    76,
     453,    -1,   395,   396,   453,    -1,   397,   278,    69,   453,
      -1,   280,   401,   453,   733,    -1,   280,   120,   709,    -1,
     212,   719,    -1,    -1,   405,   707,   725,    -1,    -1,   406,
     708,   731,    -1,   405,   266,   455,    -1,   406,   266,   455,
      -1,   411,    -1,   412,    -1,   413,    -1,    -1,    -1,   711,
     706,   439,    -1,    -1,   443,   711,   444,    -1,   705,   513,
     712,   710,    -1,   458,    -1,   402,   455,    -1,   403,   455,
      -1,   404,   455,    -1,   398,   401,   453,   733,    -1,   399,
     401,   453,   733,    -1,    -1,    -1,   717,   715,   439,    -1,
      -1,   443,   717,   444,    -1,   714,   718,   716,    -1,   456,
      -1,    -1,    -1,   407,   720,    -1,   401,   732,    -1,    -1,
      -1,   724,   722,   439,    -1,   720,    -1,   443,   721,   724,
     444,   723,    -1,    20,    -1,    -1,    -1,   408,   726,    -1,
     401,   732,    -1,    -1,    -1,   730,   728,   439,    -1,   726,
      -1,   443,   727,   730,   444,   729,    -1,   453,    -1,   400,
     453,    -1,    -1,   410,   455,    -1,   500,   414,    -1,   502,
      -1,   368,   455,    -1,   368,   455,    69,   453,    -1,   415,
     453,    -1,   123,   744,    -1,    -1,   736,   735,   439,    -1,
     734,   501,   443,   736,   444,    -1,    -1,    -1,    87,   453,
      -1,   385,   418,    -1,   385,   345,    -1,   139,   455,    -1,
     166,   456,    -1,    42,   453,    -1,   419,   453,    -1,   419,
     360,   455,    -1,   420,   421,   455,    -1,   422,   423,   455,
      -1,    66,   424,   455,    -1,   416,    76,   453,    -1,    67,
      76,   453,    -1,   417,    76,   453,    -1,   368,   369,   453,
      -1,   259,   361,   453,    -1,   260,   378,   453,    -1,   260,
     516,    -1,   260,   342,   453,    -1,   318,   319,   455,    -1,
     318,   319,   260,   360,    -1,    66,   324,   455,    -1,   256,
     455,    -1,   267,   741,    -1,   533,    -1,   127,    -1,   425,
      -1,   354,    -1,   148,    -1,    -1,   742,   740,   439,    -1,
      -1,   443,   742,   444,    -1,   738,   513,   743,   739,    -1,
     186,   414,   144,   543,   687,     3,    -1,   186,   414,   196,
     543,   687,     3,    -1,   500,   428,    -1,   747,   501,   443,
      -1,   748,   502,   439,    -1,   748,    66,   324,   455,   439,
      -1,   748,   314,    86,   506,   439,    -1,   748,   752,   755,
     439,    -1,   189,   458,    -1,   276,   456,   457,    -1,   750,
     369,   453,    -1,   750,   256,   455,    -1,   750,    -1,   751,
     750,    -1,   749,   276,   456,   457,    -1,   749,   276,    20,
      -1,   749,   430,   751,    -1,   749,   316,   456,    -1,   749,
     307,    -1,   749,   207,    -1,   749,   431,    -1,   749,   432,
      -1,   749,   429,    -1,   634,    -1,   256,   455,   439,    -1,
      -1,   754,   753,    -1,    -1,   443,   754,   444,    -1,   186,
     428,   543,     3,    -1,   500,   433,    -1,   502,    -1,   123,
     766,    -1,    -1,   759,   758,   439,    -1,   757,   501,   443,
     759,   444,    -1,    -1,    -1,    -1,    42,   453,    -1,   434,
     453,    -1,   340,   261,   453,    -1,   416,   261,   453,    -1,
     344,   435,    -1,   344,   436,    -1,   259,   361,   453,    -1,
     260,   378,   453,    -1,   260,   516,    -1,   260,   342,   453,
      -1,    66,   324,   455,    -1,    -1,   764,   763,   439,    -1,
      -1,   443,   764,   444,    -1,   761,   513,   765,   762,    -1,
     186,   433,   144,   543,   687,     3,    -1,   186,   433,   196,
     543,   687,     3,    -1,   186,   433,   438,   543,   687,     3,
      -1,   439,    -1,   452,    -1,   464,    -1,   470,    -1,   473,
      -1,   474,    -1,   489,    -1,   491,    -1,   494,    -1,   496,
      -1,   499,    -1,   772,    -1,   507,    -1,   585,    -1,   587,
      -1,   597,    -1,   475,    -1,   476,    -1,   477,    -1,   478,
      -1,   479,    -1,   480,    -1,   539,    -1,   540,    -1,   541,
      -1,   542,    -1,   544,    -1,   545,    -1,   546,    -1,   549,
      -1,   552,    -1,   555,    -1,   556,    -1,   557,    -1,   558,
      -1,   559,    -1,   560,    -1,   561,    -1,   562,    -1,   563,
      -1,   564,    -1,   565,    -1,   566,    -1,   567,    -1,   570,
      -1,   571,    -1,   572,    -1,   573,    -1,   574,    -1,   575,
      -1,   576,    -1,   577,    -1,   578,    -1,   582,    -1,   651,
      -1,   688,    -1,   689,    -1,   690,    -1,   691,    -1,   692,
      -1,   693,    -1,   694,    -1,   695,    -1,   745,    -1,   746,
      -1,   756,    -1,   767,    -1,   768,    -1,   769,    -1,   773,
     444,    -1,   774,   444,    -1,   518,   444,    -1,   638,    -1,
     654,   444,    -1,   656,   444,    -1,   698,   444,    -1,   704,
      -1,   737,    -1,   748,   444,    -1,   760,    -1,   483,   501,
     443,    -1,   773,   502,   439,    -1,   773,   485,   439,    -1,
     773,   488,   439,    -1,   486,   501,   443,    -1,   774,   502,
     439,    -1,   774,   487,   439,    -1,    82,    -1,    83,    -1,
      88,    -1,    89,    -1,    90,    -1,    91,    -1,    92,    -1,
      93,    -1,    94,    -1,    95,    -1,    96,    -1,    97,    -1,
      98,    -1,    99,    -1,   100,    -1,   101,    -1,   102,    -1,
     103,    -1,   104,    -1,   105,    -1,   106,    -1,   107,    -1,
     108,    -1,   109,    -1,   110,    -1,   111,    -1,   112,    -1,
     113,    -1,   114,    -1,   115,    -1,   177,    -1,     5,    -1,
     289,    -1,   286,    -1,   290,    -1,   288,    -1,   287,    -1,
     291,    -1,   292,    -1,   293,    -1,   312,    -1,   313,    -1,
     294,    -1,   327,    -1,   330,    -1,   331,    -1,   332,    -1,
     333,    -1,   426,    -1,   427,    -1,   437,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   848,   848,   849,   852,   854,   862,   871,   872,   873,
     880,   881,   882,   890,   891,   892,   893,   894,   895,   901,
     902,   909,   910,   914,   921,   922,   926,   930,   937,   945,
     946,   953,   954,   960,   969,   970,   974,   979,   980,   984,
     985,   989,   990,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1008,  1009,  1010,  1019,  1020,  1021,  1022,  1025,
    1026,  1027,  1028,  1029,  1030,  1034,  1040,  1041,  1042,  1043,
    1051,  1054,  1061,  1064,  1067,  1070,  1074,  1075,  1079,  1080,
    1081,  1089,  1094,  1095,  1099,  1100,  1104,  1111,  1112,  1113,
    1125,  1130,  1134,  1148,  1149,  1163,  1164,  1168,  1169,  1170,
    1171,  1178,  1192,  1194,  1196,  1200,  1201,  1202,  1203,  1208,
    1214,  1215,  1219,  1227,  1231,  1233,  1239,  1240,  1247,  1248,
    1252,  1258,  1262,  1271,  1280,  1282,  1286,  1287,  1288,  1289,
    1290,  1291,  1292,  1293,  1294,  1295,  1296,  1297,  1301,  1302,
    1303,  1304,  1308,  1309,  1310,  1311,  1312,  1316,  1322,  1326,
    1334,  1335,  1343,  1351,  1352,  1353,  1357,  1358,  1362,  1367,
    1368,  1372,  1374,  1382,  1386,  1387,  1393,  1400,  1401,  1402,
    1403,  1407,  1415,  1421,  1422,  1423,  1427,  1428,  1432,  1433,
    1434,  1435,  1436,  1437,  1443,  1444,  1445,  1449,  1450,  1454,
    1455,  1461,  1467,  1468,  1472,  1477,  1484,  1486,  1487,  1491,
    1492,  1496,  1497,  1498,  1499,  1505,  1506,  1509,  1511,  1515,
    1516,  1520,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1552,  1553,  1554,  1555,  1556,  1557,  1558,  1559,  1560,
    1561,  1567,  1570,  1573,  1576,  1580,  1581,  1584,  1587,  1591,
    1595,  1600,  1606,  1613,  1618,  1623,  1628,  1632,  1636,  1640,
    1649,  1657,  1661,  1668,  1669,  1670,  1675,  1679,  1686,  1693,
    1697,  1705,  1706,  1707,  1712,  1716,  1719,  1720,  1721,  1722,
    1723,  1724,  1725,  1730,  1735,  1743,  1750,  1757,  1765,  1767,
    1769,  1771,  1773,  1775,  1777,  1779,  1782,  1786,  1792,  1793,
    1794,  1798,  1799,  1805,  1807,  1809,  1811,  1813,  1815,  1819,
    1823,  1827,  1835,  1838,  1840,  1841,  1845,  1846,  1847,  1850,
    1854,  1855,  1856,  1860,  1861,  1862,  1870,  1870,  1880,  1884,
    1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,
    1895,  1896,  1897,  1898,  1920,  1931,  1932,  1939,  1940,  1947,
    1956,  1960,  1964,  1988,  1989,  1993,  2006,  2006,  2022,  2023,
    2026,  2027,  2031,  2034,  2043,  2056,  2057,  2058,  2059,  2060,
    2064,  2072,  2073,  2074,  2075,  2076,  2080,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2097,  2098,  2099,
    2100,  2104,  2105,  2106,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2122,  2123,  2124,  2125,  2126,  2130,  2131,  2132,
    2133,  2134,  2138,  2139,  2143,  2144,  2148,  2155,  2156,  2157,
    2158,  2165,  2166,  2169,  2170,  2177,  2189,  2190,  2194,  2195,
    2199,  2200,  2201,  2202,  2203,  2204,  2208,  2209,  2210,  2214,
    2215,  2216,  2217,  2218,  2219,  2220,  2221,  2222,  2223,  2224,
    2228,  2229,  2230,  2240,  2244,  2267,  2281,  2282,  2283,  2284,
    2285,  2286,  2287,  2288,  2289,  2290,  2294,  2295,  2296,  2297,
    2298,  2299,  2300,  2301,  2302,  2303,  2304,  2305,  2306,  2307,
    2308,  2309,  2310,  2312,  2313,  2314,  2316,  2318,  2320,  2322,
    2323,  2324,  2325,  2326,  2327,  2337,  2338,  2339,  2340,  2341,
    2342,  2343,  2344,  2346,  2347,  2352,  2375,  2376,  2377,  2378,
    2379,  2380,  2384,  2387,  2388,  2389,  2397,  2404,  2413,  2414,
    2418,  2424,  2434,  2443,  2449,  2454,  2461,  2466,  2472,  2473,
    2474,  2482,  2483,  2484,  2485,  2486,  2492,  2504,  2505,  2506,
    2507,  2510,  2512,  2516,  2520,  2534,  2554,  2555,  2556,  2557,
    2558,  2559,  2560,  2561,  2565,  2566,  2567,  2568,  2569,  2570,
    2573,  2575,  2578,  2580,  2584,  2587,  2592,  2593,  2594,  2598,
    2599,  2603,  2604,  2607,  2626,  2632,  2657,  2659,  2660,  2664,
    2665,  2666,  2667,  2668,  2669,  2675,  2676,  2677,  2678,  2679,
    2680,  2681,  2682,  2683,  2684,  2685,  2686,  2687,  2688,  2689,
    2690,  2691,  2692,  2693,  2694,  2695,  2696,  2697,  2698,  2699,
    2700,  2701,  2702,  2703,  2704,  2705,  2706,  2707,  2708,  2709,
    2710,  2711,  2712,  2713,  2719,  2720,  2721,  2722,  2723,  2724,
    2725,  2726,  2727,  2728,  2729,  2730,  2731,  2732,  2733,  2744,
    2754,  2755,  2759,  2760,  2761,  2762,  2763,  2764,  2765,  2766,
    2767,  2770,  2785,  2788,  2790,  2794,  2795,  2796,  2797,  2798,
    2799,  2800,  2801,  2802,  2803,  2803,  2804,  2804,  2805,  2806,
    2807,  2811,  2812,  2816,  2824,  2826,  2830,  2831,  2832,  2836,
    2837,  2840,  2842,  2845,  2846,  2847,  2848,  2849,  2850,  2851,
    2852,  2853,  2854,  2855,  2858,  2878,  2879,  2880,  2881,  2882,
    2883,  2884,  2885,  2886,  2887,  2888,  2889,  2890,  2891,  2892,
    2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,  2901,  2902,
    2903,  2904,  2905,  2906,  2907,  2908,  2909,  2910,  2911,  2912,
    2913,  2914,  2915,  2916,  2919,  2921,  2924,  2926,  2935,  2937,
    2938,  2941,  2943,  2947,  2948,  2951,  2961,  2982,  2984,  2988,
    2988,  2991,  2993,  2996,  2998,  3002,  3006,  3007,  3012,  3015,
    3018,  3023,  3026,  3031,  3034,  3038,  3042,  3045,  3046,  3047,
    3048,  3049,  3050,  3051,  3052,  3058,  3065,  3066,  3067,  3072,
    3073,  3079,  3089,  3090,  3091,  3092,  3092,  3093,  3093,  3094,
    3101,  3103,  3107,  3111,  3129,  3130,  3131,  3132,  3133,  3134,
    3135,  3136,  3137,  3138,  3143,  3144,  3145,  3145,  3146,  3146,
    3147,  3148,  3152,  3153,  3154,  3157,  3175,  3177,  3180,  3182,
    3186,  3189,  3202,  3203,  3204,  3205,  3210,  3218,  3226,  3228,
    3231,  3233,  3237,  3241,  3251,  3256,  3257,  3258,  3262,  3274,
    3276,  3280,  3281,  3285,  3298,  3303,  3304,  3305,  3309,  3321,
    3323,  3327,  3328,  3333,  3334,  3338,  3339,  3345,  3358,  3359,
    3360,  3361,  3362,  3365,  3367,  3371,  3375,  3398,  3428,  3429,
    3430,  3431,  3432,  3433,  3434,  3438,  3439,  3440,  3441,  3442,
    3443,  3444,  3445,  3446,  3447,  3448,  3449,  3450,  3451,  3452,
    3453,  3454,  3455,  3459,  3460,  3461,  3462,  3465,  3467,  3470,
    3472,  3476,  3482,  3485,  3492,  3499,  3500,  3501,  3502,  3503,
    3506,  3516,  3525,  3529,  3535,  3536,  3540,  3545,  3551,  3554,
    3559,  3560,  3561,  3562,  3563,  3567,  3568,  3571,  3573,  3576,
    3578,  3582,  3588,  3595,  3596,  3599,  3601,  3605,  3609,  3622,
    3645,  3646,  3647,  3648,  3649,  3650,  3651,  3652,  3653,  3654,
    3655,  3656,  3659,  3661,  3664,  3666,  3671,  3676,  3679,  3682,
    3689,  3689,  3689,  3689,  3689,  3689,  3689,  3689,  3689,  3689,
    3689,  3689,  3689,  3689,  3689,  3689,  3690,  3690,  3690,  3690,
    3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,
    3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,
    3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,
    3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,
    3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,  3690,  3691,
    3691,  3691,  3691,  3691,  3691,  3691,  3691,  3691,  3691,  3691,
    3692,  3692,  3692,  3692,  3693,  3693,  3693,  3694,  3694,  3694,
    3694,  3694,  3694,  3694,  3694,  3694,  3694,  3694,  3694,  3694,
    3694,  3694,  3694,  3694,  3694,  3694,  3694,  3694,  3694,  3694,
    3694,  3694,  3694,  3694,  3694,  3694,  3694,  3694,  3695,  3695,
    3696,  3697,  3698,  3699,  3700,  3701,  3702,  3703,  3704,  3705,
    3706,  3707,  3707,  3707,  3707,  3707,  3707,  3707
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES", "FILTERS",
  "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1", "SHA256",
  "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN", "BGP", "V6ONLY",
  "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN",
  "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC",
  "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "PERIOD", "FILENAME",
  "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST",
  "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH",
  "ROA_CHECK", "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX",
  "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT",
  "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT",
  "PATH", "START", "DELAY", "FORGET", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "AWARE", "LINK",
  "EXTENDED", "SETKEY", "BGP_LARGE_COMMUNITY", "OSPF", "AREA",
  "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2", "RETRANSMIT", "HELLO",
  "TRANSMIT", "PRIORITY", "DEAD", "TYPE", "BROADCAST", "BCAST",
  "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP",
  "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN",
  "VIRTUAL", "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "LSA",
  "SUPPRESSION", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE",
  "TRANSPARENT", "RADV", "RA", "MANAGED", "OTHER", "CONFIG", "MTU",
  "REACHABLE", "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT",
  "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS",
  "DOMAIN", "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "RIP",
  "INFINITY", "UPDATE", "GARBAGE", "MULTICAST", "VERSION", "SPLIT",
  "HORIZON", "POISON", "REVERSE", "ZERO", "PLAINTEXT", "RIP_METRIC",
  "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE",
  "BABEL", "RXCOST", "WIRED", "WIRELESS", "BABEL_METRIC", "ENTRIES", "';'",
  "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "definition", "expr", "expr_us", "bool", "ipa",
  "ipa_scope", "prefix", "prefix_or_ipa", "pxlen", "datetime", "text",
  "text_or_none", "log_config", "syslog_name", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "timeformat_which",
  "timeformat_spec", "timeformat_base", "debug_unix", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO",
  "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_mp_limit", "kern_item", "kif_proto_start",
  "kif_item", "kern_sys_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "gr_opts", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "mrtdump_table_config_init", "mrtdump_table_config",
  "mrtdump_table_filter_option", "mrtdump_table_config_list",
  "mrtdump_table_config_table_option", "mrtdump_table_config_option",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "export_mode",
  "cmd_SHOW_ROA", "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args",
  "roa_table_arg", "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_MRTDUMP_ROUTES", "mrtdump_table_cli_config",
  "mrtdump_table_cli_config_list", "mrtdump_table_cli_config_option",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "switch_atom", "cnum", "pair_item", "ec_kind", "ec_item", "lc_item",
  "set_item", "switch_item", "set_items", "switch_items", "fprefix_s",
  "fprefix", "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_finish", "bfd_iface_item", "bfd_auth_type",
  "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface", "bfd_multihop",
  "bfd_neigh_iface", "bfd_neigh_local", "bfd_neigh_multihop",
  "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start",
  "bgp_nbr_opts", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@6", "$@7", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@8", "$@9", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_proto_start", "rip_proto_item", "rip_proto_opts", "rip_proto",
  "rip_iface_start", "rip_iface_finish", "rip_iface_item", "rip_auth",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "stat_route_item", "stat_route_opts",
  "stat_route_opt_list", "cmd_SHOW_STATIC", "babel_proto_start",
  "babel_proto_item", "babel_proto_opts", "babel_proto",
  "babel_iface_start", "babel_iface_finish", "babel_iface_item",
  "babel_iface_opts", "babel_iface_opt_list", "babel_iface",
  "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "conf", "cli_cmd", "proto", "kern_proto",
  "kif_proto", "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,    59,
      40,    41,    58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   449,   450,   450,   451,   451,   452,   453,   453,   453,
     454,   454,   454,   455,   455,   455,   455,   455,   455,   456,
     456,   457,   457,   458,   459,   459,   460,   460,   461,   462,
     462,   463,   463,   464,   465,   465,   466,   466,   466,   467,
     467,   468,   468,   469,   469,   469,   469,   469,   469,   469,
     469,   469,   470,   470,   470,   471,   471,   471,   471,   472,
     472,   472,   472,   472,   472,   473,   474,   474,   474,   474,
     475,   476,   477,   478,   479,   480,   481,   481,   482,   482,
     482,   483,   484,   484,   485,   485,   485,   485,   485,   485,
     486,   487,   487,   488,   488,   489,   489,   490,   490,   490,
     490,   490,   491,   492,   492,   493,   493,   493,   493,   494,
     495,   495,   496,   497,   498,   498,   499,   499,   500,   500,
     501,   501,   501,   501,   502,   502,   502,   502,   502,   502,
     502,   502,   502,   502,   502,   502,   502,   502,   503,   503,
     503,   503,   504,   504,   504,   504,   504,   505,   505,   506,
     507,   507,   508,   509,   509,   509,   510,   510,   511,   512,
     512,   513,   514,   515,   516,   516,   517,   518,   518,   518,
     518,   519,   520,   521,   521,   521,   522,   522,   523,   523,
     523,   523,   523,   523,   524,   524,   524,   525,   525,   526,
     526,   527,   528,   528,   529,   529,   530,   530,   530,   531,
     531,   532,   532,   532,   532,   533,   533,   534,   534,   535,
     535,   536,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   538,   538,   538,   538,   538,   538,   538,   538,   538,
     538,   539,   540,   541,   542,   543,   543,   544,   545,   546,
     547,   547,   547,   547,   547,   547,   547,   547,   547,   547,
     547,   547,   547,   548,   548,   548,   549,   550,   550,   550,
     550,   551,   551,   551,   552,   553,   553,   553,   553,   553,
     553,   553,   553,   554,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   568,
     568,   569,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   580,   580,   581,   581,   581,   582,
     583,   583,   583,   584,   584,   584,   586,   585,   587,   588,
     588,   588,   588,   588,   588,   588,   588,   588,   588,   588,
     588,   588,   588,   588,   589,   590,   590,   591,   591,   592,
     593,   593,   594,   595,   595,   596,   598,   597,   599,   599,
     600,   600,   601,   601,   602,   603,   603,   603,   603,   603,
     603,   604,   604,   604,   604,   604,   605,   606,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   607,   607,   607,
     607,   608,   608,   608,   609,   609,   609,   609,   609,   609,
     609,   609,   610,   610,   610,   610,   610,   611,   611,   611,
     611,   611,   612,   612,   613,   613,   614,   615,   615,   615,
     615,   616,   616,   617,   617,   617,   618,   618,   619,   619,
     620,   620,   620,   620,   620,   620,   621,   621,   621,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     623,   623,   623,   624,   625,   626,   627,   627,   627,   627,
     627,   627,   627,   627,   627,   627,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   629,   629,   629,   629,
     629,   629,   630,   631,   631,   631,   632,   632,   633,   633,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   635,   636,   636,   636,
     636,   637,   637,   638,   639,   640,   641,   641,   641,   641,
     641,   641,   641,   641,   642,   642,   642,   642,   642,   642,
     643,   643,   644,   644,   645,   646,   647,   647,   647,   648,
     648,   649,   649,   650,   651,   652,   653,   653,   653,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   655,
     656,   656,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   658,   659,   660,   660,   661,   661,   661,   661,   661,
     661,   661,   661,   661,   662,   661,   663,   661,   661,   661,
     661,   664,   664,   665,   666,   666,   667,   667,   667,   668,
     668,   669,   669,   670,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   671,   672,   672,   672,   672,   672,
     672,   672,   672,   672,   672,   672,   672,   672,   672,   672,
     672,   672,   672,   672,   672,   672,   672,   672,   672,   672,
     672,   672,   672,   672,   672,   672,   672,   672,   672,   672,
     672,   672,   672,   672,   673,   673,   674,   675,   676,   676,
     676,   677,   677,   678,   678,   679,   680,   681,   681,   683,
     682,   684,   684,   685,   685,   686,   687,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   696,   696,   696,
     696,   696,   696,   696,   696,   697,   698,   698,   698,   698,
     698,   699,   700,   700,   700,   701,   700,   702,   700,   700,
     703,   703,   704,   705,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   707,   706,   708,   706,
     706,   706,   709,   709,   709,   710,   711,   711,   712,   712,
     713,   714,   715,   715,   715,   715,   715,   716,   717,   717,
     718,   718,   719,   720,   721,   722,   722,   722,   723,   724,
     724,   725,   725,   726,   727,   728,   728,   728,   729,   730,
     730,   731,   731,   732,   732,   733,   733,   734,   735,   735,
     735,   735,   735,   736,   736,   737,   738,   739,   740,   740,
     740,   740,   740,   740,   740,   740,   740,   740,   740,   740,
     740,   740,   740,   740,   740,   740,   740,   740,   740,   740,
     740,   740,   740,   741,   741,   741,   741,   742,   742,   743,
     743,   744,   745,   746,   747,   748,   748,   748,   748,   748,
     749,   750,   750,   750,   751,   751,   752,   752,   752,   752,
     752,   752,   752,   752,   752,   753,   753,   754,   754,   755,
     755,   756,   757,   758,   758,   759,   759,   760,   761,   762,
     763,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   763,   764,   764,   765,   765,   766,   767,   768,   769,
     770,   770,   770,   770,   770,   770,   770,   770,   770,   770,
     770,   770,   770,   770,   770,   770,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   772,
     772,   772,   772,   772,   772,   772,   772,   772,   772,   772,
     773,   773,   773,   773,   774,   774,   774,   775,   775,   775,
     775,   775,   775,   775,   775,   775,   775,   775,   775,   775,
     775,   775,   775,   775,   775,   775,   775,   775,   775,   775,
     775,   775,   775,   775,   775,   775,   775,   775,   775,   775,
     775,   775,   775,   775,   775,   775,   775,   775,   775,   775,
     775,   775,   775,   775,   775,   775,   775,   775
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     4,     2,     0,     1,     2,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     3,     1,     1,     1,     1,     2,
       4,     3,     3,     3,     3,     3,     3,     4,     3,     3,
       4,     5,     3,     3,     4,     2,     0,     1,     0,     1,
       2,     2,     0,     2,     2,     3,     2,     3,     3,     4,
       2,     3,     3,     3,     2,     4,     5,     1,     3,     1,
       1,     1,     4,     0,     2,     2,     2,     1,     1,     5,
       0,     1,     3,     3,     0,     8,     1,     4,     1,     1,
       0,     1,     2,     3,     0,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     4,     2,     3,     2,     2,     1,
       1,     1,     0,     2,     2,     2,     2,     2,     1,     1,
       3,     3,     0,     1,     1,     2,     0,     1,     3,     1,
       3,     1,     0,     2,     2,     2,     2,     3,     3,     3,
       5,     0,     3,     1,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     3,     1,
       1,     0,     4,     2,     1,     2,     0,     2,     3,     1,
       1,     2,     2,     2,     1,     4,     1,     0,     3,     4,
       1,     2,     0,     5,     5,     5,     5,     4,     4,     4,
       4,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     3,     3,     4,     5,     1,     0,     3,     4,     4,
       0,     2,     3,     3,     3,     2,     2,     2,     2,     3,
       3,     2,     2,     1,     1,     1,     4,     0,     3,     3,
       3,     0,     1,     1,     4,     0,     2,     2,     2,     2,
       2,     2,     2,     0,     2,     9,     9,     4,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     4,     1,     1,
       3,     0,     1,     3,     3,     3,     3,     4,     4,     4,
       4,     4,     2,     0,     1,     2,     2,     2,     1,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     3,     1,     3,     1,
       1,     1,     2,     3,     2,     4,     0,     5,     0,     1,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     1,     3,     1,     1,     1,     1,     5,     7,     5,
       7,     9,     7,     5,     7,     5,    11,     1,     1,     2,
       1,     7,     9,     7,     7,     9,     7,     9,     7,     9,
       7,    15,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     4,     2,     2,     2,     0,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     1,
       5,     7,     7,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     4,     1,     1,     1,     1,     2,     2,     3,
       3,     6,     3,     3,     3,     3,     3,     5,     7,     6,
       6,     6,     6,     4,     8,     4,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     1,     3,     0,     1,
       4,     6,     4,     3,     5,     5,     4,     6,     3,     2,
       5,     5,     8,     8,     8,     8,     2,     1,     2,     2,
       2,     0,     3,     5,     0,     0,     2,     4,     4,     4,
       2,     2,     2,     1,     1,     1,     2,     2,     3,     3,
       0,     3,     0,     3,     4,     3,     0,     2,     2,     0,
       2,     0,     2,     4,     5,     2,     0,     3,     3,     3,
       3,     5,     6,     4,     6,     4,     6,     4,     4,     5,
       6,     3,     3,     4,     5,     5,     5,     5,     5,     4,
       4,     5,     5,     5,     5,     5,     5,     5,     5,     6,
       6,     6,     5,     6,     8,     6,     6,     5,     6,     4,
       5,     4,     4,     5,     4,     5,     4,     5,     5,     5,
       5,     6,     5,     5,     6,     5,     5,     5,     4,     2,
       3,     3,     1,     2,     3,     2,     4,     3,     2,     3,
       1,     2,     4,     0,     3,     2,     1,     2,     3,     3,
       3,     3,     2,     3,     0,     5,     0,     5,     2,     2,
       1,     4,     1,     1,     0,     3,     2,     2,     2,     5,
       2,     0,     3,     0,     2,     2,     3,     2,     2,     3,
       2,     2,     2,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     2,     3,     2,     3,     3,     4,     4,
       2,     2,     2,     3,     3,     3,     2,     3,     3,     3,
       4,     2,     2,     1,     0,     2,     3,     1,     0,     1,
       2,     0,     2,     0,     1,     3,     0,     0,     2,     0,
       3,     0,     3,     0,     3,     3,     1,     0,     4,     6,
       6,     6,     7,     6,     7,     5,     0,     2,     3,     2,
       3,     3,     2,     3,     2,     2,     3,     3,     5,     4,
       4,     2,     1,     2,     2,     0,     3,     0,     3,     2,
       0,     3,     5,     0,     4,     4,     3,     2,     3,     3,
       3,     3,     4,     4,     3,     2,     0,     3,     0,     3,
       3,     3,     1,     1,     1,     0,     0,     3,     0,     3,
       4,     1,     2,     2,     2,     4,     4,     0,     0,     3,
       0,     3,     3,     1,     0,     0,     2,     2,     0,     0,
       3,     1,     5,     1,     0,     0,     2,     2,     0,     0,
       3,     1,     5,     1,     2,     0,     2,     2,     1,     2,
       4,     2,     2,     0,     3,     5,     0,     0,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     4,     3,
       2,     2,     1,     1,     1,     1,     1,     0,     3,     0,
       3,     4,     6,     6,     2,     3,     3,     5,     5,     4,
       2,     3,     3,     3,     1,     2,     4,     3,     3,     3,
       2,     2,     2,     2,     2,     1,     3,     0,     2,     0,
       3,     4,     2,     1,     2,     0,     3,     5,     0,     0,
       0,     2,     2,     3,     3,     2,     2,     3,     3,     2,
       3,     3,     0,     3,     0,     3,     4,     6,     6,     6,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     1,     2,     2,     2,     1,     1,     2,     1,
       3,     3,     3,     3,     3,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    76,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   443,     0,     0,
     966,   967,   968,   969,   970,   971,   972,   973,   974,   975,
     976,   977,   978,   979,   980,   981,   982,   983,   984,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,
    1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,
    1016,  1017,  1018,     3,     1,     2,     0,     0,     0,     0,
       0,     0,     0,     0,   118,   119,     0,     0,     0,     0,
     443,     0,   950,   951,   952,   953,   954,   955,   120,   120,
     956,   957,   958,   959,   116,   960,     0,   962,   120,   124,
     963,   964,   965,   120,  1022,   120,   124,   120,   124,   120,
     124,   120,  1026,   120,  1027,   120,   124,   120,  1029,     5,
     961,   124,   124,   310,   312,   311,     0,    77,    76,     0,
       0,    76,    78,    75,     0,     0,     0,     0,     0,   191,
       0,   309,   273,   314,     0,   257,     0,     0,   240,   265,
       0,   236,     0,   236,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   425,   429,   438,   435,   354,
     445,   432,     0,     0,   428,   443,   476,     0,     0,     0,
     430,   431,     0,     0,     0,   443,     0,   433,   434,   439,
     474,   475,     0,   473,     0,   289,   288,     0,   291,     0,
       0,    30,    29,    35,    38,    36,     0,    18,     0,     0,
      58,    57,    56,    55,     0,     0,     0,     0,     0,   110,
       0,   316,     0,   103,   191,     0,     0,   318,   346,   121,
       0,     0,     0,   114,    81,    90,   166,   565,   526,   629,
     765,   771,   847,   894,   922,     0,     0,     0,     0,     0,
       0,    18,   171,     0,     0,     0,     0,     0,  1021,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,    18,     0,   566,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,     0,     0,     0,     0,    18,
       0,    18,  1023,     0,     0,     0,     0,    18,     0,     0,
      18,     0,  1024,   632,     0,     0,   640,     0,     0,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,  1028,     0,
       0,   919,     0,     0,    18,     0,    18,     0,     0,     0,
       0,  1019,     0,     0,     0,     0,    32,  1020,     0,     0,
     174,   173,     0,     0,    78,    72,    73,     0,    79,     0,
     295,   293,     0,     0,   296,   303,     0,   185,   184,     0,
       0,     0,     0,   313,   315,   314,     0,   237,     0,   261,
     232,   231,     0,     0,   236,   235,   236,   236,   756,   236,
     236,     0,   236,   236,     0,   236,   236,   236,    19,    20,
       0,     0,     0,   284,   280,   285,   281,   278,   279,   282,
     283,   425,   445,   425,   443,   425,   425,     0,   416,     0,
     443,     0,     0,     0,   428,   428,     0,   471,   443,   443,
     443,   443,   443,     0,   377,   378,     0,   380,     0,     0,
     355,   358,   356,   360,   443,   357,   395,   392,   393,   394,
     402,     0,   407,   411,     0,  1068,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,   446,  1067,   447,   448,
     449,   450,   451,   452,   453,   454,   455,  1070,  1073,  1072,
    1069,  1071,  1074,  1075,  1076,  1079,  1077,  1078,  1080,  1081,
    1082,  1083,  1084,  1085,  1086,  1087,   477,   478,   286,   443,
     443,   443,   443,   443,   443,   443,   443,   443,   443,   443,
     443,   443,   443,     0,    43,    44,    45,    46,    47,    48,
      49,    50,    51,     0,    41,   292,     0,   294,   443,     0,
      37,    39,     0,     0,     7,     9,    14,    16,    15,    17,
       0,   443,    13,    66,   150,   151,    59,     0,     0,    65,
       0,    68,    69,     0,   111,   112,    97,    99,   100,   101,
     162,   443,     0,   335,   113,     0,   191,     0,    53,     0,
      54,     0,     0,   122,  1030,  1034,     0,   167,   127,    18,
     149,   135,     0,   125,   126,   152,   140,     0,   335,   141,
       0,   443,   129,   139,     0,   130,     0,   137,   128,   168,
     169,   531,   569,     0,     0,    18,    18,   581,     0,     0,
       0,     0,     0,    18,     0,    18,     0,     0,     0,   582,
       0,    21,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,    18,     0,
      18,     0,    18,     0,    18,     0,     0,    18,    18,    18,
       0,     0,     0,   570,   630,    18,   641,   633,    18,   638,
     635,     0,   631,   643,   766,     0,     0,     0,   767,   780,
     853,   895,    18,   900,     0,   896,   911,     0,   910,     0,
     914,     0,   912,   913,   917,     0,   925,     0,    84,     0,
      86,    18,    18,    18,    94,  1032,  1033,  1031,     0,    31,
       0,  1036,  1035,   179,   178,   180,   182,   183,   181,     0,
     176,   299,     0,    74,    80,    70,   297,   298,     0,   335,
       0,   308,   302,   304,   194,   301,   189,   190,     0,   187,
     300,   274,   277,     0,   233,   238,   256,     0,   263,   262,
       0,     0,   239,   246,     0,     0,   254,   335,   248,   247,
     251,   252,     0,   253,   255,   241,     0,   245,   264,   272,
     266,   269,   270,   268,   271,   267,     0,   747,   747,     0,
     236,   747,   236,   747,   748,   747,   747,   921,   747,   747,
     747,     0,     0,    23,     0,     0,     0,   420,   422,     0,
     423,   424,   418,   406,   506,   509,     0,   485,     0,     0,
     486,   426,   427,   419,     0,     0,     0,     0,     0,     0,
     379,   443,   456,   443,     0,     0,     0,   366,     0,     0,
     436,   408,   409,     0,     0,   437,   468,   466,   464,   461,
     462,   463,   465,   467,   469,   470,   457,   458,   459,   460,
     479,     0,   480,   482,   483,   484,   290,     0,   287,     0,
      34,     0,    33,    67,     0,     0,    61,    62,    63,    64,
      10,    11,    12,     0,   152,     0,     0,    95,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,     0,     0,     0,   317,   339,     0,   107,   108,
       0,   102,   104,   196,   193,    52,     0,   335,   123,     0,
     117,     0,   136,   156,   159,   172,   148,   142,   132,   340,
     341,   138,    18,   342,   133,   131,   124,     0,     0,     0,
       0,     0,     0,   575,    18,   611,   614,     0,     0,     0,
       0,    18,     0,    18,     0,   628,   583,     0,   566,     0,
       0,   573,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   577,     0,   578,     0,   609,
       0,     0,     0,     0,     0,     0,     0,   589,   590,     0,
       0,     0,   616,     0,   612,   637,   634,     0,   639,     0,
       0,   769,   770,   124,   124,     0,     0,   907,    21,   909,
       0,   904,   908,   443,   899,   124,    93,    85,    87,    88,
      82,    91,    25,    24,    92,   175,     0,    71,   200,   199,
     306,   195,   307,   305,   186,     0,   234,   260,   259,   258,
     243,   250,   244,   242,   249,   564,   746,     0,     0,   755,
     764,     0,   762,   759,     0,     0,   757,     0,   747,     0,
     747,     0,     0,     0,     0,     0,     0,    26,    27,     0,
       0,   425,   417,   443,   495,     0,     0,   443,   443,   443,
     472,   443,   493,   443,     0,     0,   443,   443,   443,   443,
     359,   354,   443,   396,   403,     0,     0,   412,   443,    42,
       6,    40,     8,    60,   109,   163,    96,    98,   334,   333,
     335,   443,   106,   105,     0,     0,     0,   204,     0,     0,
     344,   337,     0,   347,     0,   170,   157,     0,   152,     0,
     147,   134,   534,   534,     0,   533,   527,     0,     0,     0,
     627,     0,   623,   622,     0,   613,   617,   618,   619,     0,
     607,     0,   598,    22,     0,   567,   568,   571,     0,   579,
       0,     0,   602,     0,   585,   584,   597,   596,   591,     0,
       0,   610,   594,   586,   587,   588,   615,   625,   593,   592,
     626,   595,   620,     0,   636,   736,    18,     0,    18,   654,
       0,     0,   656,   646,    18,   642,     0,   660,   737,   768,
     783,     0,   775,   777,     0,   782,   772,     0,   856,    18,
       0,   855,   848,     0,   897,   898,   906,    21,    18,     0,
     905,     0,   499,     0,   500,   501,     0,   443,   497,   498,
     496,   443,   443,    18,   920,     0,     0,   443,   915,   918,
     928,   927,   923,     0,     0,    89,   177,   188,   750,   749,
     763,   758,   760,   761,     0,   751,     0,   753,   892,   893,
     947,   948,   949,     0,     0,   421,   507,     0,   487,     0,
       0,     0,     0,     0,   443,   440,   443,     0,     0,   366,
       0,     0,     0,     0,     0,     0,     0,   336,     0,   443,
     350,   203,   201,   202,   192,     0,   197,     0,   343,     0,
     153,   154,   158,   160,   145,   143,   144,   146,   152,   528,
     552,   529,   556,   530,   532,     0,   603,   624,   605,   606,
     608,   574,   572,   601,   600,   580,   599,   576,   621,   152,
     659,   647,     0,     0,    18,     0,   645,     0,     0,   663,
     658,   662,     0,     0,   652,   644,     0,   670,   152,   773,
     811,   820,   774,     0,     0,   779,   781,   152,   852,   849,
     851,   854,   901,   903,   902,   443,   443,   443,   443,     0,
       0,     0,     0,     0,     0,   519,   502,   504,     0,   152,
     924,   926,    83,   752,   754,   273,   273,     0,   492,   490,
     491,   489,   443,     0,     0,   375,     0,   443,   373,   443,
     369,     0,   443,   367,   443,   443,     0,   481,   345,   351,
     198,   338,     0,   155,   161,   552,   550,   535,     0,     0,
     559,     0,   739,   743,   649,   650,   648,   651,   724,   684,
     664,   724,   653,   738,   671,   808,   818,   817,   824,   823,
     831,   776,   833,   834,   841,   778,   889,     0,     0,     0,
       0,     0,   513,   443,   413,   916,   443,   443,     0,   443,
     518,   944,     0,     0,   488,     0,   441,   442,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   410,
       0,   535,     0,   555,   557,   558,     0,   561,   604,   737,
     741,   745,     0,     0,     0,   673,   806,   805,     0,   822,
     829,   839,   887,   857,   850,   512,   444,   516,     0,   443,
     510,   352,     0,     0,     0,     0,     0,     0,     0,     0,
     505,   942,   929,   275,   276,   494,   390,   374,   372,     0,
     443,   370,   388,   368,     0,   443,   386,   443,   384,   383,
     443,   381,     0,   554,     0,    18,     0,     0,     0,     0,
       0,     0,   553,   543,   206,   210,     0,   560,    18,   563,
     740,     0,   655,   727,   725,   728,    18,     0,    18,   661,
       0,   657,     0,     0,     0,     0,     0,     0,   669,   683,
       0,     0,   810,     0,     0,    18,    18,    18,   821,     0,
     825,   835,     0,   891,     0,     0,   443,   443,   361,   365,
     363,   443,   520,   364,   400,   397,   398,   399,   404,     0,
     515,   514,   443,   443,   443,   443,   521,   930,   946,     0,
       0,     0,     0,     0,     0,     0,   115,   211,   541,   207,
       0,     0,     0,   536,   540,   544,     0,   545,     0,   542,
     212,   551,   562,     0,     0,     0,    18,     0,     0,     0,
       0,    18,     0,    18,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   744,   723,     0,   729,
       0,     0,   667,   668,   666,   665,   677,   680,   681,   682,
     675,   674,     0,     0,   678,   672,     0,     0,     0,     0,
       0,    18,     0,     0,     0,     0,   796,   798,   809,     0,
       0,     0,   812,   813,   814,   819,     0,     0,   828,     0,
       0,     0,   838,     0,     0,     0,     0,     0,    18,     0,
      18,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   890,   882,     0,   517,   353,   511,   415,   366,
       0,   443,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   945,     0,   389,   371,   387,
     443,   385,   443,   382,     0,     0,     0,     0,     0,   546,
     547,     0,     0,     0,     0,     0,     0,     0,     0,    18,
     689,   731,   721,     0,     0,     0,     0,     0,   716,   710,
     711,   712,    18,   722,     0,   705,   685,   688,   686,     0,
     703,     0,   690,   692,   693,   694,   695,   696,   697,   698,
     699,    18,    18,   687,     0,    18,   742,   730,   726,   676,
     679,     0,   795,     0,     0,     0,     0,     0,   787,    18,
       0,     0,     0,    18,     0,    18,     0,   807,   845,   845,
       0,   843,   827,   826,   832,   830,   837,   836,   842,   840,
     863,    18,    18,     0,   858,   861,   862,   880,     0,     0,
       0,   875,   883,   886,   885,   884,   881,    18,     0,   860,
     859,     0,     0,    18,   864,    18,    18,   888,   362,   443,
     401,   414,   405,     0,     0,     0,     0,   931,    18,     0,
       0,     0,   939,     0,   935,   936,     0,   932,   943,     0,
       0,   205,   207,   537,   538,   539,   548,   549,     0,    28,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   209,
     706,     0,   714,   713,   715,   164,   165,   717,   718,     0,
     719,    18,   702,   691,   701,   704,   707,   700,     0,   786,
       0,   802,   803,   804,   794,   845,   789,   788,   790,   791,
       0,   800,   797,   801,   799,    18,   815,   816,   844,   879,
     868,   870,   873,   876,   874,     0,   877,   872,   869,   871,
     865,   866,   867,     0,   525,   523,   524,   522,   941,   937,
     940,   938,   933,   934,   376,   443,   208,   212,   212,   212,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     212,     0,     0,     0,     0,   709,   733,   732,   720,   708,
     785,   784,   793,   792,   846,   878,     0,   219,   217,   218,
     220,   212,   212,   212,   212,   734,     0,   443,   213,   214,
     215,   216,   735,     0,   391
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    93,   572,   581,   573,   410,   968,  1033,
    1034,   813,  1920,   215,   730,    94,   560,   216,   563,   553,
     554,    95,   224,   225,    96,    97,    20,    21,    22,    23,
      24,    25,   142,   369,    98,  1255,   352,    99,   358,   353,
     100,   592,   101,   595,   922,   102,   585,   103,   104,   606,
     105,   106,   241,   269,   622,  1140,   938,  1039,   107,   933,
    1312,  1137,   934,  1424,  1425,   894,   895,  1798,   108,   109,
     615,   270,   363,   739,   740,   380,   758,   759,   375,   598,
     751,  1128,  1040,  1129,  1563,  1774,  1564,  1565,  1788,  1924,
      26,    27,    28,    29,   401,    30,    31,    32,   392,   786,
      33,   389,   771,    34,   393,   382,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,   208,
     556,    48,    49,    50,    51,    52,    53,    54,    55,    56,
     376,   752,   753,    57,   136,   386,   110,   593,   111,   912,
     913,   914,  1132,   940,   941,   754,   927,   916,   112,   601,
    1298,  1299,  1520,   197,   456,  1614,   845,   457,   846,   458,
     459,   460,  1618,   461,  1619,   198,   463,   464,  1522,   426,
     199,   427,   436,   200,   201,   202,  1246,   203,   526,  1289,
    1247,  1387,  1388,   825,   826,  1300,   113,  1147,   946,   114,
    1318,  1493,  1566,  1649,  1492,  1427,  1319,  1321,  1430,  1497,
    1569,  1323,    58,   115,   652,   116,   117,   118,   324,   325,
     326,  1009,  1206,  1347,  1352,  1350,  1351,  1503,  1580,  1207,
    1505,  1590,  1208,  1678,  1502,  1574,  1575,  1681,  1931,  2036,
    2017,  1339,  1357,  1433,  1499,  1571,  1501,  1340,  1057,    59,
      60,    61,    62,    63,    64,    65,    66,   799,   119,   120,
     121,  1217,  1363,  1364,  1013,   122,  1358,  1709,  1844,  1846,
    1954,  1592,  1591,  1507,  1359,  1361,  1599,  1509,  1508,  1447,
    1362,  1450,  1510,  1719,  1854,  1600,  1451,  1454,  1511,  1723,
    1858,  1601,  1455,  1852,  1966,   123,  1223,  1014,   124,  1367,
    1603,  1744,  1876,  1602,  1513,  1368,    67,    68,   125,   126,
     340,  1021,  1022,   341,  1249,  1023,   715,    69,   127,  1253,
    1025,   128,  1389,  1628,  1766,  1627,  1532,  1390,    70,    71,
      72,   129,    73,   130,   131,   132,   527
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1661
static const yytype_int16 yypact[] =
{
      90,  3247,   158,   831,   879,   803,   140,   879,   879,   552,
     901,   282,    59,  2392,   150,   188,  1208,  2030,   143,   879,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661,   284,   920,   549,   848,
     461,   324,   421,   369, -1661, -1661,   436,   471,   422,   862,
    2030,   571, -1661, -1661, -1661, -1661, -1661, -1661,   184,   184,
   -1661, -1661, -1661, -1661,   180, -1661,  1053, -1661,   184,  2953,
   -1661, -1661, -1661,   184, -1661,   184,  2843,   184,  2888,   184,
    3064,   184, -1661,   184, -1661,   184,  1467,   184, -1661, -1661,
   -1661,  2868,  2732, -1661, -1661, -1661,   269, -1661,   614,   652,
     693,   614,   640, -1661,   708,   722,   879,   879,   760, -1661,
     316, -1661,   664,   934,    94, -1661,   776,   782, -1661, -1661,
     527,   195,    87,   788,   -24,   524,   524,   807,   810,   812,
     818,   824,   832,   835,   843,    42, -1661, -1661, -1661,   828,
     420, -1661,   610,   111,    13,  2030, -1661,   426,   444,   449,
   -1661, -1661,   482,   485,   489,  1138,   135, -1661, -1661, -1661,
   -1661, -1661,  2418, -1661,  3447, -1661, -1661,  1741,   918,   942,
     921, -1661, -1661,   885, -1661, -1661,    -4,   340,   269,   341,
   -1661, -1661, -1661, -1661,   511,   513,   341,   341,   780,   794,
     166, -1661,   946, -1661,   525,   316,   533,  3474, -1661,   847,
     955,   551,   588, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661,   597,   269,   729,  1045,   956,
     341,   637, -1661,   553,   869,  1006,   836,   316, -1661,   645,
     649,   661,   668,    70,   789,  1038,   682,  1114,   853,   836,
     637,  1059,  1067,    75,   983,   637,    25,   524,   380,  1093,
     153,  1095,   903,   906,   599,  1100,   910,   639,   904,   908,
     637,   909,   912,   899,   937,    18,  1125,   907,   911,   637,
     957,   637, -1661,   793,   784,   874,   223,   637,  1126,   341,
     637,  1127, -1661, -1661,   804,   809, -1661,   813,  1173,   569,
   -1661,   822,   820,   823,   825,   941,   524,  1185, -1661,   833,
     596,   842,   860,  1189,   637,  1200,   637,  1207,  1227,  1225,
     341, -1661,   872,   873,   876,  1238,  1296, -1661,   884,   886,
   -1661, -1661,  1044,  1325,   640, -1661, -1661,  1328,   341,  1329,
   -1661, -1661,  1332,  1333, -1661,   696,  1334, -1661, -1661,    77,
    1336,  1307,  1338, -1661, -1661,   987,  1343, -1661,  1347,   744,
   -1661, -1661,  3251,  2698,   788, -1661,   788,   788, -1661,   487,
     528,  1350,   788,   788,  1359,   788,   788,   788, -1661, -1661,
      28,  1182,  1183, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661,    23, -1661,    42,  2030,    42,    42,  1351, -1661,  1357,
    1187,  1346,   149,  1348,    13,    13,  1344,  1342,  2030,  2030,
    2030,  2030,  2030,  1358, -1661, -1661,  1365, -1661,   944,    58,
   -1661, -1661, -1661, -1661,   877, -1661,  1375, -1661, -1661, -1661,
   -1661,   173,    62, -1661,   310, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,  2030,
    2030,  2030,  2030,  2030,  2030,  2030,  2030,  2030,  2030,  2030,
    2030,  2030,  2030,  1323, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661,   590, -1661, -1661,  1384, -1661,  2030,   836,
   -1661, -1661,  1741,   951, -1661, -1661, -1661, -1661, -1661, -1661,
     341,  2030, -1661, -1661, -1661, -1661,   341,   990,  1001, -1661,
     949, -1661, -1661,   341, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661,  2030,   958,  3326, -1661,   279, -1661,   959, -1661,   960,
   -1661,   952,  1381, -1661, -1661, -1661,   -54, -1661, -1661,   637,
   -1661, -1661,   223, -1661, -1661, -1661, -1661,   154,  3063, -1661,
    1258,  2030, -1661, -1661,   154, -1661,   154, -1661, -1661, -1661,
   -1661, -1661, -1661,  1330,  1331,   637,   161, -1661,   962,  1360,
     973,   978,   341,   156,  1110,   637,  1248,   524,   988, -1661,
     991,  1395,    51,   341,  1250,   341,  1355,  1363,   341,  1366,
       1,   341,   341,   637,  1369,  1005,  1339,  1012,   637,  1014,
     637,   402,   637,  1045,   637,  1018,  1025,   637,   637,   637,
    1026,  1285,  1030, -1661, -1661,   637, -1661, -1661,   637, -1661,
    1413,   341, -1661, -1661, -1661,  1466,  1055,  1057, -1661, -1661,
   -1661, -1661,   637, -1661,  1045, -1661, -1661,   980, -1661,   524,
   -1661,  1223, -1661, -1661, -1661,  1068, -1661,   341, -1661,   341,
   -1661,   637,   637,   637, -1661, -1661, -1661, -1661,   341, -1661,
     524, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,   642,
   -1661, -1661,  1503, -1661, -1661, -1661, -1661, -1661,  1082,  3063,
     836, -1661,   696, -1661, -1661, -1661, -1661, -1661,   688, -1661,
   -1661, -1661, -1661,  1509, -1661, -1661, -1661,  1495, -1661, -1661,
    1502,   524, -1661, -1661,  1500,  1504, -1661,  3063, -1661, -1661,
   -1661, -1661,   524, -1661, -1661, -1661,  1506, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661,  1523,  1511,  1511,  1064,
     788,  1511,   788,  1511, -1661,  1511,  1511, -1661,  1511,  1511,
    1511,   341,   524, -1661,  1517,  1522,  1524, -1661, -1661,  1070,
   -1661, -1661, -1661, -1661,   137, -1661,  1097, -1661,  1286,  1515,
   -1661, -1661, -1661, -1661,   199,   315,   359,  1272,   603,   142,
   -1661,  2030, -1661,  2030,  1099,     9,  1103,  1450,   200,   230,
   -1661, -1661, -1661,  1530,  1531, -1661,  2804,  2804,  2804,  3501,
    3501,  2804,  2804,  2804,  2804,  2804,   953,   953,  1342,  1342,
   -1661,  1111, -1661, -1661, -1661, -1661, -1661,  1741, -1661,  2537,
   -1661,   692, -1661, -1661,  1699,  1534, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661,  1119, -1661,  1122,  1819, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661,   102,  1123,  1107, -1661, -1661,   341, -1661, -1661,
     524, -1661, -1661,   747, -1661, -1661,  1469,  3326, -1661,   524,
   -1661,  1129, -1661,  1541, -1661,  1132, -1661,  1440, -1661, -1661,
   -1661, -1661,   637,  3474, -1661, -1661,   755,   341,   341,  1142,
     341,  1143,  1145, -1661,   637, -1661, -1661,  1147,  1150,  1151,
    1156,   637,  1157,   637,  1159, -1661, -1661,  1560, -1661,   341,
     341, -1661,  1160,   341,  1162,   341,   341,  1163,   341,  1164,
    1165,  1170,  1171,  1176,   341, -1661,   223, -1661,  1177, -1661,
    1178,  1180,  1184,  1197,  1198,  1199,  1202, -1661, -1661,  1203,
    1205,  1220, -1661,   331, -1661, -1661, -1661,   341, -1661,  1884,
    1222, -1661, -1661,  1368,  2929,  1224,  1228, -1661,  1395, -1661,
     524,  -115,  1223,   940, -1661,  3076, -1661, -1661, -1661, -1661,
    1551, -1661,    28, -1661, -1661, -1661,  1044, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661,    77, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661,  1618,  1619, -1661,
   -1661,   223, -1661, -1661,   223,  1609, -1661,   223,  1511,  1623,
    1511,  1636,  1643,  1659,  1661,  1663,  1665, -1661, -1661,  1487,
    1488,    42, -1661,  2030, -1661,  1646,  1647,  2030,  2030,  2030,
   -1661,  2030, -1661,  2030,   675,   105,  1218,  2030,  1730,  2030,
   -1661, -1661,  2030, -1661, -1661,  1249,   828, -1661,  2030, -1661,
   -1661, -1661, -1661, -1661, -1661,  1132, -1661, -1661, -1661, -1661,
    3326,   537, -1661, -1661,  1082,   341,   836, -1661,   325,  1254,
   -1661,  1256,  1255, -1661,  1516, -1661, -1661,   997, -1661,   587,
   -1661, -1661, -1661, -1661,   524, -1661, -1661,  1259,  1257,  1261,
   -1661,  1262, -1661, -1661,  1264, -1661, -1661, -1661, -1661,  1273,
   -1661,  1276, -1661, -1661,    53, -1661, -1661, -1661,  1277, -1661,
    1280,  1281, -1661,  1291, -1661, -1661, -1661, -1661, -1661,  1292,
    1294, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661,  1295, -1661, -1661,   637,   352,   224, -1661,
    1414,   524, -1661, -1661,   530, -1661,  1301, -1661,  1376, -1661,
   -1661,   524, -1661, -1661,   524, -1661, -1661,  1302, -1661,   637,
     341, -1661, -1661,  1305, -1661, -1661, -1661,  1395,   637,   341,
    -115,     7, -1661,  1731, -1661, -1661,  1312,  2030, -1661, -1661,
   -1661,  2030,  2030,   637, -1661,  2418,  1315,  1748, -1661, -1661,
   -1661, -1661, -1661,  1316,   341, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661,  1753, -1661,  1766, -1661, -1661, -1661,
   -1661, -1661, -1661,  1755,  1756, -1661, -1661,  1744, -1661,  1876,
    1962,  2056,  2103,   705,  2030, -1661,  2030,   194,    26,  3474,
    1337,   307,    38,  1340,  1450,  1764,  2181, -1661,  1353,    86,
   -1661, -1661, -1661, -1661, -1661,  1361, -1661,  3326, -1661,  1768,
     524, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
    1356, -1661,    12, -1661, -1661,   341, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661,   341,   341,   637,   341, -1661,  1367,   223, -1661,
   -1661,  1371,  1389,   341, -1661, -1661,   341,  1394, -1661, -1661,
   -1661,  1396, -1661,   138,    14, -1661, -1661, -1661, -1661,  1729,
   -1661, -1661, -1661, -1661, -1661,  2030,  1187,  2030, -1661,  2564,
    3280,   765,  1372,  1780,   567, -1661,  3474,  1364,  1374, -1661,
   -1661, -1661, -1661, -1661, -1661,   664,   664,  1812, -1661, -1661,
   -1661, -1661,  2030,  2262,  2296, -1661,  1822,  2030, -1661,  1788,
   -1661,  1824,  2030,  1848,  1806,  1918,  1415, -1661, -1661, -1661,
   -1661, -1661,  1674, -1661,  1132,  1356, -1661, -1661,  1839,   836,
    1594,  1422,  1132,  1419, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661,  1420, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661,  1421,   341,  2590,  1424,
    2616,  2580, -1661,   806, -1661, -1661,  2030,  2030,  1003,  1748,
   -1661,  1423,  1866,  1867, -1661,  2322, -1661, -1661,  1430,  1432,
     387,    39,  1435,   403,  1438,  1439,    40,  1441,    46, -1661,
    1864, -1661,  1167, -1661, -1661, -1661,   524,  1620, -1661,  1376,
   -1661, -1661,    41,    91,    56,  1181, -1661, -1661,   875, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,  1448,   537,
    1655, -1661,    33,  2744,  2771,  1452,  1453,  1457,  1472,  1451,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,  1878,
    2030, -1661, -1661, -1661,  1886,  2030, -1661,  2030,  1906, -1661,
    2030, -1661,  1477, -1661,   836,   637,  1474,   881,  1658,   341,
     341,   283, -1661, -1661, -1661,  1476,  1481, -1661,   637, -1661,
   -1661,  2999, -1661, -1661, -1661,   171,   637,   341,   637, -1661,
    1484, -1661,   341,   204,   341,   341,  1641,   297, -1661, -1661,
    1486,  2956, -1661,  1526,  1527,   637,   637,   637, -1661,  1490,
     355,    30,  2672, -1661,  1491,  1497,   806,    93, -1661, -1661,
   -1661,   877, -1661, -1661,  1935, -1661, -1661, -1661, -1661,   220,
   -1661, -1661,  2030,  2030,  2030,  2030, -1661,   795, -1661,  1508,
    1510,  1512,  1498,  1513,  1521,  1525, -1661, -1661, -1661,  1807,
    1691,  1695,  1696, -1661, -1661, -1661,  1011, -1661,  1817, -1661,
    1370, -1661, -1661,  1640,   341,  1538,   637,  1604,   217,   266,
    1648,   637,  1589,   637,   341,   341,   341,  1686,   341,   338,
    1303,  1605,  1652,   341,  1625,  1657, -1661, -1661,  1564, -1661,
     341,  1566, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661,   341,   341, -1661, -1661,  1617,   524,   -82,   -22,
    1615,   637,  1622,  1933,  1614,  1733,  1746,  1749, -1661,  1580,
     341,   341, -1661, -1661, -1661, -1661,   237,   524, -1661,  1582,
     237,  2003, -1661,  1586,   341,    78,  1955,   341,   637,   524,
     637,  1676,   263,   253,  1720,  1671,  -112,  1966,  1976,   389,
    1632,  1633, -1661, -1661,  1616, -1661, -1661, -1661, -1661,  2351,
      61,    93,   108,  2382,  2408,  2434,  2463,   341,  1737,  1702,
     424,  1808,   727,  1809,   341, -1661,  1634, -1661, -1661, -1661,
    2030, -1661,  2030, -1661,  1627,  1635,   341,   341,   341, -1661,
   -1661,  1028,   341,  2055,  2055,  1036,   280,   294,  1649,   637,
   -1661, -1661, -1661,   332,   341,   341,   341,   341, -1661, -1661,
   -1661, -1661,   623, -1661,  1697, -1661, -1661, -1661, -1661,   341,
   -1661,   341, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661,   637,   637, -1661,   341,   637, -1661, -1661, -1661, -1661,
   -1661,  1815, -1661,   341,  1826,   646,   341,   341, -1661,   637,
     341,   341,  2021,   637,   138,   637,    14, -1661,  1681,  1681,
     341, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661,   637,   637,   341, -1661, -1661, -1661, -1661,   341,   341,
     341, -1661, -1661, -1661, -1661, -1661, -1661,   781,   341, -1661,
   -1661,   341,   341,   637, -1661,   637,   637, -1661, -1661,  2030,
   -1661, -1661, -1661,  1653,  1656,  1660,  1664, -1661,   637,   341,
     341,   341, -1661,   341, -1661, -1661,   341, -1661, -1661,  1666,
    1651, -1661,  1807, -1661, -1661, -1661, -1661, -1661,  1667, -1661,
    1669,  1677,   895,  1140,  1678,  2055,  2055,  2055,  2055, -1661,
   -1661,   100, -1661, -1661, -1661, -1661, -1661, -1661, -1661,  1734,
   -1661,   637, -1661, -1661, -1661, -1661, -1661, -1661,   341, -1661,
     341, -1661, -1661, -1661, -1661,  1681, -1661, -1661, -1661, -1661,
     341, -1661, -1661, -1661, -1661,   637, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661,  1738, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661,  2351, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661,  2030, -1661,  1370,  1370,  1370,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
    1370,  1679,  1680,  1683,  1684, -1661,  1742, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661,  1689, -1661, -1661, -1661,
   -1661,  1370,  1370,  1370,  1370, -1661,  1698,  2030, -1661, -1661,
   -1661, -1661, -1661,  1694, -1661
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1661, -1661, -1661, -1661,  -164,  -212,   299,  -274,  -954,  -162,
    -771, -1661, -1277,   -84, -1661, -1661, -1661, -1661, -1661,  1540,
    1266, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661,   627,  1736, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661,  -310, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661,  1905,   -95,  1840, -1661,  -262,  -246, -1661, -1661,
   -1661, -1661,   967,  -613,  -527, -1661, -1661, -1660, -1661, -1661,
   -1661, -1661,   322, -1661,  1105,     0, -1661,  1094,  -199, -1661,
    -734, -1661,  1021,  1020, -1293,   239, -1583, -1661,  -677, -1661,
   -1661, -1661, -1661, -1661,  -131, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661,  -205, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661,  1397, -1661,  1108,  1767, -1661, -1661, -1661, -1661,
    -861,  1033,   850,  1561,  -462,   232, -1661,  1231, -1661, -1661,
   -1275, -1661,   556,  -195,  1311,   405, -1079, -1380,  1970, -1335,
   -1322,  1318,   416, -1661, -1661,  -187,  1319, -1661, -1661, -1661,
   -1661,  -399,   763, -1661, -1661, -1015, -1661,  -168,   924,   -17,
   -1661, -1661,   703,  1091,   799, -1013, -1661, -1661, -1661, -1661,
    1035,   689, -1661, -1661, -1661,   754, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661,  1213, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661,   742, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661,   687, -1661, -1661, -1661, -1661, -1661,    44, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
     497,   479, -1661, -1661, -1661, -1661,   354,   478, -1661, -1661,
   -1661, -1661,   356,   480, -1647, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661,  1179, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661, -1661,
   -1661, -1661, -1661, -1661, -1661, -1661, -1191
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -509
static const yytype_int16 yytable[] =
{
     204,   455,   935,   411,   412,   236,   686,   428,  1245,   462,
    1248,  1053,   611,   651,   654,   582,  1097,  1288,  1290,  1292,
    1293,   313,   817,   323,   818,   331,   820,   821,   434,  1375,
     816,   339,   404,  1407,  1452,   597,   354,   359,   421,  1607,
     564,   561,   422,  1428,   565,  1412,  1540,  1547,  1608,  1609,
    1610,  1101,   423,  1550,  1384,   575,  1775,   421,   811,   408,
     409,   422,   580,   580,  1226,  1131,   529,   530,   531,   532,
     533,   423,  1871,   237,   408,   409,  1608,  1609,  1610,  1101,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   851,
     852,   543,  -349,   969,     1,   969,   613,   387,  1835,  -348,
    1902,  -349,  -349,  -349,  -349,  1231,  1245,   929,  -348,  -348,
    -348,  -348,  1231,   529,   530,   531,   532,   533,   408,   409,
     405,  1118,   650,  1608,  1609,  1610,  1101,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   979,  1232,   543,   432,
     675,  1228,  1615,   143,  1232,   529,   530,   531,   532,   533,
     450,   451,   452,   179,   453,   689,   408,   409,    74,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   437,   564,
     543,   564,   406,   565,   703,   565,   564,   828,   449,   205,
     565,   586,   627,   587,   588,   589,   724,  1616,   206,  1127,
     936,   566,   567,   568,   569,   640,   566,   567,   568,   569,
    1617,  1833,  1967,   239,   744,   756,  1233,   529,   530,   531,
     532,   533,  1589,  1233,   395,   450,   451,   452,  1101,   453,
     152,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     785,   402,   543,  1879,   970,   599,   970,   950,   586,   564,
     587,   588,   589,   565,  1605,   450,   451,   452,  1101,   453,
     633,   757,   564,   428,  1229,   428,   565,   428,   428,   566,
     567,   568,   569,   796,   644,   797,   798,   628,   801,   803,
    1518,   805,   806,  1372,   808,   809,   810,  1429,  1677,  1576,
     980,  1115,   388,   403,  1245,   151,  1419,  1041,  1234,  1235,
    1236,  1237,  1238,  1239,  1240,  1234,  1235,  1236,  1237,  1238,
    1239,  1240,   932,   210,   590,   360,  1880,  1834,  2022,  1743,
    1241,   165,   564,  1242,   361,  1052,   565,  1241,   396,  1119,
    1242,   917,   240,   529,   530,   531,   532,   533,  1479,  1775,
    1481,  1687,  1748,  1483,   676,  1486,  1488,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   564,   564,   543,   166,
     565,   565,   377,   564,   634,   564,   564,   565,   883,   565,
     565,   378,   944,  1461,   945,   433,  1311,   529,   530,   531,
     532,   533,  1615,   964,   645,   566,   567,   568,   569,  1836,
    1872,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     930,   397,   543,  1799,  1127,  1794,  1795,   923,   408,   409,
     646,  1873,  1861,   829,   564,   228,   580,   819,   565,   570,
    1645,  1124,   885,   824,   407,   958,   959,  1616,  1925,   893,
    1926,   834,   835,   836,   837,   838,   656,   995,  1577,  1646,
    1617,  1720,  1927,  1018,  1928,  1019,   657,   847,  1721,   562,
     229,  1794,  1795,   918,   919,   920,  1131,  1376,  1245,  1578,
    1521,   749,  1693,   937,  1098,   231,  1032,  1453,  1016,   435,
     937,  1630,   937,   424,   649,   571,  1632,  1408,  1633,   425,
     812,  1635,  1688,  1611,  1722,   880,  1891,  1612,   957,  1413,
    1541,  1548,   424,  1414,   951,  1572,   230,  1551,   425,   972,
     971,   974,  1331,  1811,   977,   623,   623,   981,   982,   842,
    1581,  1889,  1862,   843,  1245,   853,   395,  1921,  1032,  1125,
    1126,   226,   856,   857,   858,   859,   860,   861,   862,   863,
     864,   865,   866,   867,   868,   869,  -349,  1008,   227,  1679,
    -349,   576,   800,  -348,  1800,  1579,  1680,  -348,  1078,  1423,
     574,   879,   408,   409,  2015,   564,  1285,   395,  1611,   565,
    1286,  1647,  1648,  1026,   884,  1027,  1231,   232,  1689,  1796,
     614,  1345,   398,   653,  1031,   566,   567,   568,   569,   577,
     578,   133,   134,   802,   896,   454,   399,   400,   608,   641,
     621,  1448,  1083,  1092,   648,   233,   207,  1093,  1232,  1467,
     238,  1245,  1245,  1521,   571,  1797,   571,   135,   616,   669,
    1468,   571,  1794,  1795,   943,  1869,   591,  1874,   680,  1049,
     682,   529,   530,   531,   532,   533,   687,   217,   849,   690,
    1801,   850,   617,   243,   787,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   137,  1405,   543,  1850,   564,  1406,
    1102,  1870,   565,   718,  1087,   720,  1123,  1077,  2011,  2012,
    2013,  2014,   564,   455,   455,   365,   565,  1233,   566,   567,
     568,   569,  1751,   591,   571,  1752,  1042,   462,  1314,  1068,
     454,  1070,   566,   567,   568,   569,  1180,   571,  1875,   618,
     619,   991,  1275,   529,   530,   531,   532,   533,   620,  1342,
    1343,  1909,   218,  1910,  1932,  1933,   366,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   219,   368,   543,   992,
     993,   370,   362,   529,   530,   531,   532,   533,   921,  1315,
    1316,  1317,  1344,   146,   147,   371,  1432,   534,   535,   536,
     537,   538,   539,   540,   541,   542,  1245,   571,   543,  1234,
    1235,  1236,  1237,  1238,  1239,  1240,  1227,   766,  1410,  1883,
     381,  1260,  1411,  1122,  1261,   854,  1716,  1263,   855,   379,
    1088,  1241,  1717,   374,  1242,   364,  1900,  1134,   367,  1304,
    1192,   571,   571,   529,   530,   531,   532,   533,   571,   390,
     571,   571,   748,  1148,  1149,   391,  1151,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   564,   394,   543,  1718,
     565,   256,  1901,   706,  1089,  1165,  1166,   395,   621,  1168,
     413,  1170,  1171,   414,  1173,   415,   566,   567,   568,   569,
    1179,   416,   749,   137,  1094,  1231,  1095,   417,  1538,   571,
     767,  1445,  1539,  1124,    75,   418,   750,  1757,   419,  1193,
    1456,   258,  1058,  1194,  1543,  1069,   420,  1071,  1544,  1072,
    1073,  1146,  1074,  1075,  1076,   211,   212,  1232,   429,   138,
     430,  1758,  1471,  1032,   431,    76,   438,   139,   140,   141,
    1322,   259,   707,   749,    77,   260,   261,    78,  1142,   263,
     264,   211,   212,  1939,   439,   265,   661,   662,    79,   440,
     175,   220,   176,   177,   178,   179,   180,   181,   133,   134,
     768,    80,  1353,   708,   182,   183,   844,   184,   931,   185,
     221,    81,   709,   428,   616,   769,  2026,    82,  1216,  1222,
     133,   134,   441,   266,   135,   442,  1233,   770,   267,   443,
    1252,  1125,  1126,   555,   949,   952,   665,   666,   624,   211,
     212,   234,   960,   558,   962,   557,   135,    83,   559,    84,
      85,   621,   579,   383,   384,   696,   697,    86,  2043,  1231,
     583,  1302,   983,   584,   213,   594,   222,   988,   596,   990,
     571,   994,   600,   996,   603,   214,   999,  1000,  1001,   385,
     149,  -348,   541,   542,  1005,   602,   543,  1006,   890,   891,
     892,  1232,    87,    88,   604,   618,   619,   186,   408,   409,
    1017,  1015,   621,   187,    89,   235,   383,   384,  1234,  1235,
    1236,  1237,  1238,  1239,  1240,   408,   409,  1310,  1143,  1144,
    1028,  1029,  1030,   673,   674,   710,   711,   712,   713,    90,
    1241,   605,    91,  1242,   876,   877,  1032,   223,  1439,  1349,
     607,  1975,  1303,  2000,  2001,  2002,  2003,  2004,  1091,  1360,
     886,   887,  1365,   609,  1759,  1760,  1370,  1951,  1952,  1953,
    1233,   888,   889,   571,   610,  1374,   824,  1059,   188,   189,
    1279,  1280,  1281,   612,  1282,   626,  1283,   571,   529,   530,
     531,   532,   533,  1060,   629,  1294,  1035,  1036,   630,  1449,
    1392,  1296,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   610,  1038,   543,   631,   190,   191,   444,   445,   446,
     447,   632,  1264,   635,  1266,   144,   145,   148,   150,   636,
    1284,   637,   192,   733,   621,   193,   244,   209,   642,  1525,
     194,   245,  1044,  1045,   638,  1761,  1111,   877,   639,  1762,
    1640,  1641,  1234,  1235,  1236,  1237,  1238,  1239,  1240,   647,
    1402,   175,   643,   176,   177,   178,   179,   180,   181,  1779,
    1780,  1431,  1904,  1905,  1241,   182,   183,  1242,   184,   655,
     185,   658,   734,   735,   659,   246,  1916,  1917,  1434,  1435,
    1061,  1437,  1922,  1923,   660,   736,   737,   663,   738,  1442,
    1472,  1473,  1443,   664,  1526,  1527,  1243,   831,   832,  1145,
     175,   667,   176,   177,   178,   179,   180,   181,  1464,   668,
     672,  1763,   677,   670,   182,   183,   247,   184,   671,   185,
    1379,   571,  1567,   681,  1380,  1381,   678,   684,   679,  1764,
    1386,   175,   683,   176,   177,   178,   179,   180,   181,  1765,
     685,  1141,   688,   692,   691,   182,   183,  1287,   184,  1519,
     185,  1528,   693,  1154,   372,   373,   694,  1529,   186,   695,
    1159,   698,  1161,   699,   187,   702,   700,  1403,   701,  1404,
      92,   704,   705,  1593,  1594,   717,   719,  1595,  1596,  1597,
     529,   530,   531,   532,   533,   714,   721,   167,  2005,  2006,
    2007,  2008,  2009,  1514,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   716,  1554,   543,  1555,   186,   722,   248,
     723,   725,   726,   187,   728,   727,   729,   195,  1554,  1598,
    2027,  2028,  2029,   731,   196,   732,   761,  1613,   741,   188,
     189,   743,   745,  2030,  1556,   746,   747,   755,   186,   760,
    1573,   762,  1573,  1062,   187,  1495,   764,  1643,  1556,   168,
     765,   169,   170,   804,  2038,  2039,  2040,  2041,  1458,   824,
    1460,  1582,   807,   814,   815,   822,   190,   191,   444,   445,
     446,   447,   823,   827,   833,   543,   830,   839,   188,   189,
     840,   249,   848,   192,  1244,  1475,   193,   878,  1063,   841,
     882,   194,   926,  1064,   942,   580,  1644,   897,   924,   925,
     928,   953,   171,   172,   173,   174,   947,   948,  1065,   188,
     189,   954,   955,  1683,   256,   190,   191,   956,  1686,   961,
    1690,  1691,   963,  1694,  1557,  1558,   967,   965,  1559,  1560,
     966,   975,   192,   973,  1561,   193,   250,  1066,  1067,   976,
     194,   251,   978,  1449,   985,   984,   190,   191,  1583,  1523,
    1524,   987,  1386,   989,   258,  1866,   986,   997,   529,   530,
     531,   532,   533,   192,   998,  1002,   193,   252,  1003,  1004,
    1637,   194,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   253,  1007,   543,   259,  1010,   254,  1782,   260,   261,
    1790,  1210,   263,   264,  1011,  1341,  1012,  1346,   265,  1020,
    1806,  1807,  1808,  1354,  1810,  1812,  1037,  1024,  1783,  1823,
    1784,  1082,  1046,   256,  1047,  1785,  1827,  1048,  1369,  1050,
    1584,  1585,  1586,  1051,  1587,  1054,  1055,  1373,  1829,  1830,
    1786,  1056,  1079,   335,   870,  1360,   266,  1080,  1084,  1081,
    1085,   267,  1382,  1086,  1096,  1105,  1848,  1849,  1099,  1106,
    1121,  1108,  1851,   258,  1113,  1613,  1851,  1613,  1114,   871,
    1860,  1116,  1120,  1864,  1913,  1914,  1915,   872,  1135,  1136,
    1449,  1139,   873,   874,   875,  1884,  1787,  1138,   195,  1163,
    1211,  1150,  1152,   259,  1153,   196,  1155,   260,   261,  1156,
    1157,   263,   264,  1897,  1749,  1158,  1160,   265,  1162,  1167,
    1907,  1169,  1172,  1174,  1175,  1753,  1754,  1755,  1756,  1176,
    1177,  1562,   580,   580,   580,  1178,  1181,  1182,  1918,  1183,
    1254,  1258,  1259,  1184,  1262,  1588,  1265,   195,  -508,  1934,
    1935,  1936,  1937,  1938,   196,   266,  1185,  1186,  1187,  1267,
     267,  1188,  1189,  1436,  1190,  1942,  1268,  1943,  1813,  1814,
    1815,  1816,  1817,  1818,  1819,  1820,   336,  2016,   195,  1191,
    1946,  1209,  1269,  1224,  1270,   196,  1271,  1225,  1272,  1949,
    1273,  1274,  1955,  1956,  1277,  1278,  1958,  1959,   898,   899,
     900,   901,   902,   903,   904,   905,  1968,   906,   907,   908,
     909,   910,   911,  1306,  1295,  1307,  1308,  1309,  1324,  1971,
    1326,  1327,  1325,  1328,  1972,  1973,  1974,   529,   530,   531,
     532,   533,  1329,  1090,  1977,  1330,  1332,  1978,  1979,  1333,
    1334,   534,   535,   536,   537,   538,   539,   540,   541,   542,
    1335,  1336,   543,  1337,  1338,  1989,  1990,  1991,  1348,  1992,
    1355,  1366,  1993,   175,  1371,   176,   177,   178,   179,   180,
     181,  1356,  1378,  1377,  1385,  1391,  1393,   182,   183,  1291,
     184,   175,   185,   176,   177,   178,   179,   180,   181,  1394,
    1395,  1396,  1397,  1212,  1213,   182,   183,  1214,   184,  1416,
     185,   337,  1409,  1422,  2020,  1415,  2021,   544,   545,   546,
     547,   548,   549,   550,   551,   552,  2023,  1418,  1457,  1426,
    1420,   175,  1466,   176,   177,   178,   179,   180,   181,  1469,
    1438,  1465,  1215,  1470,  1440,   182,   183,  1480,   184,   175,
     185,   176,   177,   178,   179,   180,   181,   529,   530,   531,
     532,   533,  1441,   182,   183,  1485,   184,  1444,   185,  1446,
    1474,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     186,  1478,   543,  1482,  1638,  1484,   187,  1490,  1494,  1489,
    1496,  1498,  1500,  1506,  1512,  1516,  1531,  1652,   186,  1533,
    1534,  1536,  1983,  1537,   187,  1682,  1542,  1684,  1545,  1552,
    1546,  1606,  1549,  1568,   529,   530,   531,   532,   533,  1604,
    1626,  1100,  1622,  1623,  1712,  1713,  1714,  1624,   534,   535,
     536,   537,   538,   539,   540,   541,   542,  1629,   186,   543,
    1130,   338,  1625,  1634,   187,  1631,  1636,  1639,  1642,  1650,
    1651,   188,   189,  1685,  1692,  1695,   186,  1710,  1711,  1715,
    1745,   175,   187,   176,   177,   178,   179,   180,   181,   188,
     189,  1746,  1750,  1770,  1554,   182,   183,  1487,   184,  1767,
     185,  1768,  1776,  1769,  1771,  1792,  1777,  1778,   190,   191,
    1803,  1772,  1805,  1781,  1789,  1793,  1773,  1802,  1804,  1809,
     529,   530,   531,   532,   533,   192,   190,   191,   193,   188,
     189,  1791,  1821,   194,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   192,  1824,   543,   193,   188,   189,  1822,
    1838,   194,  1825,  1826,   242,  1828,  1831,  1195,  1837,  1840,
    1841,  1842,  1843,   255,  1839,  1845,   190,   191,   271,  1847,
     272,  1855,   314,  1452,   327,  1859,   332,  1865,   333,  1867,
     334,  1863,   342,   192,   190,   191,   193,  1868,   186,  1877,
    1878,   194,  1881,   175,   187,   176,   177,   178,   179,   180,
     181,   192,  1882,  1885,   193,  1887,  1886,   182,   183,   194,
     184,  1898,   185,  1899,   529,   530,   531,   532,   533,  1903,
    1906,  1911,  1196,  1908,  1912,  1919,  1948,  1941,   534,   535,
     536,   537,   538,   539,   540,   541,   542,  1950,  1930,   543,
    1960,  1965,  1984,  1929,  2018,  1985,  1995,  2035,  2025,  1986,
     742,  1940,   881,  1987,   625,  1313,  1997,  1994,  1998,   188,
     189,   529,   530,   531,   532,   533,  1999,  2010,  2031,  2032,
    1944,  1945,  2033,  2034,  1947,   534,   535,   536,   537,   538,
     539,   540,   541,   542,  2037,  2044,   543,  2042,  1957,  1257,
    1112,  1256,  1961,  1109,  1963,  1301,   190,   191,  1305,  1043,
     186,  1996,   763,  1297,   915,  1890,   187,  1421,  1133,  1103,
    1969,  1970,  1747,   192,  1197,   448,   193,  1104,  1892,  1383,
     195,   194,  1530,  1107,  1276,  1459,  1976,   196,  1320,  1491,
    1553,  1164,  1980,  1504,  1981,  1982,  1570,  -503,   195,   529,
     530,   531,   532,   533,  1832,   196,  1853,  1988,  1962,  1857,
    1856,  1230,  1964,   534,   535,   536,   537,   538,   539,   540,
     541,   542,     0,     0,   543,     0,     0,     0,     0,  1198,
       0,   188,   189,     0,     0,     0,     0,     0,   195,     0,
       0,     0,     0,     0,     0,   196,     0,     0,     0,     0,
    2019,  1199,     0,  1200,     0,     0,   195,     0,  1201,     0,
    1202,     0,     0,   196,  1203,  1204,     0,     0,   190,   191,
    1117,     0,     0,     0,  2024,     0,     0,     0,     0,     0,
     529,   530,   531,   532,   533,   192,     0,     0,   193,     0,
       0,     0,     0,   194,   534,   535,   536,   537,   538,   539,
     540,   541,   542,     0,     0,   543,     0,     0,     0,     0,
       0,     0,     0,     0,   529,   530,   531,   532,   533,     0,
       0,     0,     0,     0,     0,     0,     0,  1398,   534,   535,
     536,   537,   538,   539,   540,   541,   542,     0,  1205,   543,
     529,   530,   531,   532,   533,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   534,   535,   536,   537,   538,   539,
     540,   541,   542,     0,     0,   543,     0,     0,   195,   529,
     530,   531,   532,   533,     0,   196,     0,     0,     0,     0,
       0,     0,     0,   534,   535,   536,   537,   538,   539,   540,
     541,   542,     0,     0,   543,     0,     0,     0,     0,     0,
     529,   530,   531,   532,   533,     0,     0,     0,     0,     0,
       0,     0,     0,  1399,   534,   535,   536,   537,   538,   539,
     540,   541,   542,     0,     0,   543,   529,   530,   531,   532,
     533,     0,     0,   465,     0,     0,     0,     0,     0,     0,
     534,   535,   536,   537,   538,   539,   540,   541,   542,     0,
       0,   543,   529,   530,   531,   532,   533,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   534,   535,   536,   537,
     538,   539,   540,   541,   542,     0,     0,   543,     0,     0,
     195,   529,   530,   531,   532,   533,     0,   196,     0,     0,
       0,     0,     0,     0,     0,   534,   535,   536,   537,   538,
     539,   540,   541,   542,     0,     0,   543,  1400,     0,     0,
     466,   467,     0,     0,     0,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,   153,   154,     0,     0,     0,
       0,     0,     0,     0,  1401,   529,   530,   531,   532,   533,
       0,     0,     0,   155,     0,     0,   496,     0,     0,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   156,     0,
     543,     0,   529,   530,   531,   532,   533,     0,     0,   157,
       0,   158,   159,     0,     0,   465,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   497,     0,   543,   529,   530,
     531,   532,   533,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   534,   535,   536,   537,   538,   539,   540,   541,
     542,     0,  1417,   543,   529,   530,   531,   532,   533,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   534,   535,
     536,   537,   538,   539,   540,   541,   542,     0,   160,   543,
       0,     0,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,   466,   467,     0,     0,     0,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,     0,     0,     0,
       0,   788,     0,  1476,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,  1724,     0,     0,   789,     0,     0,
     161,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     516,   517,     0,     0,     0,     0,     0,  1477,  1725,  1726,
       0,     0,     0,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   529,   530,   531,   532,   533,   497,     0,  1727,
       0,     0,     0,  1535,     0,     0,   534,   535,   536,   537,
     538,   539,   540,   541,   542,     0,     0,   543,   256,   529,
     530,   531,   532,   533,   790,     0,     0,     0,     0,     0,
       0,     0,  1888,   534,   535,   536,   537,   538,   539,   540,
     541,   542,     0,     0,   543,     0,   162,   355,     0,  1554,
       0,  1728,  -509,  -509,  -509,     0,   791,   792,   258,     0,
     163,     0,     0,  1893,   793,   164,  -509,  -509,  -509,  -509,
    -509,   539,   540,   541,   542,     0,     0,   543,  1729,  1556,
       0,     0,     0,     0,   523,   524,     0,     0,   259,  1894,
       0,     0,   260,   261,     0,   525,   263,   264,     0,   794,
       0,     0,   265,     0,     0,     0,   507,   508,   509,   510,
     511,   512,   513,   514,   515,  1895,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   356,     0,     0,     0,   256,
       0,     0,   516,   517,   273,     0,     0,     0,     0,   795,
     266,     0,     0,     0,  1896,   267,     0,   518,     0,   274,
     519,   520,   521,   522,   256,     0,     0,     0,     0,     0,
       0,     0,     0,   275,     0,     0,     0,     0,  1730,   258,
       0,  1731,  1732,     0,   256,     0,     0,     0,     0,  1733,
       0,   343,   344,   345,     0,   346,   347,     0,   348,     0,
       0,     0,   349,     0,   258,   350,     0,     0,     0,   259,
       0,     0,     0,   260,   261,   276,   277,   263,   264,     0,
       0,     0,   315,   265,   258,   256,  1110,   278,     0,     0,
     279,     0,   280,     0,   259,     0,     0,     0,   260,   261,
    1734,     0,   263,   264,     0,     0,     0,     0,   265,   256,
       0,     0,     0,  1462,   259,     0,   523,   524,   260,   261,
       0,   266,   263,   264,     0,   258,   267,   525,   265,   257,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1515,
       0,     0,   281,     0,   282,     0,   266,     0,     0,   258,
    1735,   267,     0,   283,     0,   259,     0,     0,     0,   260,
     261,     0,  1218,   263,   264,  1517,   266,  1736,     0,   265,
       0,   267,     0,     0,     0,  1653,     0,     0,     0,   259,
       0,     0,     0,   260,   261,     0,   262,   263,   264,     0,
       0,   284,   939,   265,     0,     0,     0,     0,  1737,  1738,
       0,  1739,  1740,     0,  1741,     0,     0,   266,     0,   285,
       0,     0,   267,     0,     0,     0,   286,   287,     0,   288,
     256,     0,     0,     0,   289,   290,  1742,   291,   292,     0,
     293,   266,   256,   294,   295,   296,   267,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1554,  1696,   297,   298,
       0,     0,     0,   299,     0,   300,   301,     0,   302,     0,
     258,     0,     0,   303,     0,     0,     0,   304,   305,     0,
     306,   307,   258,   308,   309,   310,  1556,     0,  1697,   311,
       0,     0,     0,     0,     0,     0,   357,     0,     0,  1654,
     259,     0,     0,  1620,   260,   261,     0,     0,   263,   264,
       0,     0,   259,     0,   265,  1655,   260,   261,     0,  1250,
     263,   264,     0,     0,     0,     0,   265,     0,     0,     0,
    1621,     0,     0,  1698,     0,     0,     0,   316,     0,     0,
       0,     0,   317,   318,   319,     0,     0,     0,     0,     0,
       0,     0,   266,     0,     0,     0,  1699,   267,     0,     0,
       0,     0,     0,     0,   266,     0,     0,     0,     0,   267,
       0,     0,     0,     0,   772,  1656,   320,     0,  1657,  1658,
       0,     0,     0,   321,     0,     0,  1659,     0,     0,   408,
     409,     0,   898,   899,   900,   901,   902,   903,   904,   905,
    1700,   906,   907,   908,   909,   910,   911,   312,   529,   530,
     531,   532,   533,     4,     0,     0,   773,  1219,     0,     0,
       0,     0,   534,   535,   536,   537,   538,   539,   540,   541,
     542,     0,   351,   543,     0,     0,     0,  1660,     5,     6,
    1661,     0,     0,  1662,     0,     0,     0,     0,     7,     0,
       0,     0,   322,     0,  1663,     0,  1664,   774,  1665,  1666,
    1667,  1668,  1669,  1670,  1220,     0,  1701,  1702,     0,  1671,
    1703,  1704,  1672,  1705,     0,  1673,     0,     0,     0,     0,
       0,  1706,  1707,     0,     0,     0,     0,  1674,     0,   775,
       0,     0,     0,  1221,     0,  1675,   776,   777,     0,     0,
       0,     8,     0,     0,     0,     0,     0,   778,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   268,     0,     0,
    1708,     0,     0,     0,   779,   780,   781,   782,     0,   783,
     784,     0,     0,     0,     0,     0,     0,     9,     0,     0,
      10,     0,    11,     0,     0,     0,     0,     0,     0,    12,
       0,     0,     0,    13,     0,     0,     0,     0,    14,    15,
      16,     0,     0,  1676,     0,    17,    18,    19,   328,   329,
     528,     0,     0,     0,     0,   529,   530,   531,   532,   533,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   534,
     535,   536,   537,   538,   539,   540,   541,   542,     0,     0,
     543,     0,   529,   530,   531,   532,   533,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   534,   535,   536,   537,
     538,   539,   540,   541,   542,  1463,   621,   543,   330,   529,
     530,   531,     0,     0,     0,     0,     0,     0,     0,     0,
    1251,     0,     0,   534,   535,   536,   537,   538,   539,   540,
     541,   542,     0,     0,   543,   898,   899,   900,   901,   902,
     903,   904,   905,     0,   906,   907,   908,   909,   910,   911
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1661)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-509)))

static const yytype_int16 yycheck[] =
{
      17,   196,   615,   165,   166,    89,   316,   175,  1023,   196,
    1023,   782,   258,   287,   288,   227,     7,  1096,  1097,  1098,
    1099,   116,   421,   118,   423,   120,   425,   426,    15,    22,
       7,   126,   163,     7,    20,   234,   131,   132,    15,     6,
      15,    45,    19,    31,    19,     7,     7,     7,    15,    16,
      17,    18,    29,     7,  1245,   219,  1639,    15,    30,    18,
      19,    19,   226,   227,  1018,   926,     8,     9,    10,    11,
      12,    29,  1732,    90,    18,    19,    15,    16,    17,    18,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    27,
      28,    33,     6,    42,     4,    42,   260,     3,   120,     6,
    1760,    15,    16,    17,    18,    19,  1121,   161,    15,    16,
      17,    18,    19,     8,     9,    10,    11,    12,    18,    19,
     144,    19,   286,    15,    16,    17,    18,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   135,    51,    33,    28,
     122,   256,  1522,     3,    51,     8,     9,    10,    11,    12,
      15,    16,    17,    18,    19,   319,    18,    19,     0,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   185,    15,
      33,    15,   196,    19,   336,    19,    15,    28,   195,    36,
      19,    15,   266,    17,    18,    19,   350,  1522,    45,   923,
      36,    35,    36,    37,    38,   279,    35,    36,    37,    38,
    1522,   283,  1849,    19,   368,   128,   120,     8,     9,    10,
      11,    12,  1505,   120,    19,    15,    16,    17,    18,    19,
     161,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     392,   144,    33,   345,   183,   235,   183,    76,    15,    15,
      17,    18,    19,    19,  1519,    15,    16,    17,    18,    19,
     180,   174,    15,   421,   369,   423,    19,   425,   426,    35,
      36,    37,    38,   394,   189,   396,   397,   267,   399,   400,
    1461,   402,   403,  1227,   405,   406,   407,   265,  1571,   188,
     279,   894,   188,   196,  1299,     3,  1299,   749,   202,   203,
     204,   205,   206,   207,   208,   202,   203,   204,   205,   206,
     207,   208,   612,    19,   138,    36,   418,   389,  1955,  1602,
     224,   161,    15,   227,    45,   777,    19,   224,   123,   217,
     227,    42,   138,     8,     9,    10,    11,    12,  1407,  1912,
    1409,   127,  1607,  1412,   316,  1414,  1415,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    15,    15,    33,   161,
      19,    19,    36,    15,   284,    15,    15,    19,   570,    19,
      19,    45,   624,  1378,   626,   254,  1137,     8,     9,    10,
      11,    12,  1752,   647,   299,    35,    36,    37,    38,   401,
     127,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     444,   196,    33,   127,  1128,   178,   179,   596,    18,    19,
     325,   148,   324,   254,    15,    81,   570,   424,    19,    69,
     127,    86,   576,   430,   438,   259,   260,  1752,   138,   583,
     140,   438,   439,   440,   441,   442,   273,   673,   337,   146,
    1752,   401,   138,   707,   140,   709,   283,   454,   408,   443,
      19,   178,   179,   164,   165,   166,  1307,   440,  1463,   358,
    1463,   126,   155,   617,   445,    19,   730,   443,   704,   446,
     624,  1540,   626,   440,   439,   440,  1545,   441,  1547,   446,
     442,  1550,   268,   440,   444,   559,  1751,   444,   642,   441,
     441,   441,   440,   445,   323,   444,   117,   441,   446,   653,
     439,   655,   439,   155,   658,   263,   264,   661,   662,   441,
     444,   440,   424,   445,  1519,   443,    19,  1784,   782,   184,
     185,    50,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   440,   691,    67,   358,
     444,    20,    45,   440,   268,   444,   365,   444,   812,  1310,
     218,   558,    18,    19,   444,    15,   441,    19,   440,    19,
     445,   268,   269,   717,   571,   719,    19,    86,   354,   342,
     261,   337,   367,   183,   728,    35,    36,    37,    38,    58,
      59,    19,    20,    45,   591,   440,   381,   382,   256,   280,
     255,   443,   445,   441,   285,   163,   443,   445,    51,    22,
      19,  1606,  1607,  1606,   440,   378,   440,    45,    45,   300,
      33,   440,   178,   179,   621,   342,   440,   354,   309,   771,
     311,     8,     9,    10,    11,    12,   317,    68,   445,   320,
     354,   448,    69,   443,   392,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    20,   441,    33,   400,    15,   445,
     440,   378,    19,   344,   445,   346,   920,   811,  1925,  1926,
    1927,  1928,    15,   848,   849,     3,    19,   120,    35,    36,
      37,    38,   442,   440,   440,   445,   750,   854,    81,   800,
     440,   802,    35,    36,    37,    38,   986,   440,   425,   126,
     127,   279,  1081,     8,     9,    10,    11,    12,   135,   337,
     338,  1770,   143,  1772,   362,   363,     3,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   157,    67,    33,   307,
     308,     3,   443,     8,     9,    10,    11,    12,   439,   132,
     133,   134,   370,   171,   172,     3,  1339,    22,    23,    24,
      25,    26,    27,    28,    29,    30,  1751,   440,    33,   202,
     203,   204,   205,   206,   207,   208,  1020,     3,   441,   360,
      86,  1061,   445,   917,  1064,   445,   401,  1067,   448,   443,
     445,   224,   407,     3,   227,   138,   342,   929,   141,   444,
     439,   440,   440,     8,     9,    10,    11,    12,   440,     3,
     440,   440,    86,   947,   948,     3,   950,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    15,   270,    33,   444,
      19,    46,   378,   207,   445,   969,   970,    19,   255,   973,
       3,   975,   976,     3,   978,     3,    35,    36,    37,    38,
     984,     3,   126,    20,   841,    19,   843,     3,   441,   440,
      86,  1358,   445,    86,     3,     3,   140,    42,     3,  1003,
    1367,    86,   798,  1007,   441,   801,     3,   803,   445,   805,
     806,   946,   808,   809,   810,    19,    20,    51,    30,    56,
     440,    66,  1389,  1137,   254,    34,   440,    64,    65,    66,
    1144,   116,   276,   126,    43,   120,   121,    46,   123,   124,
     125,    19,    20,   260,   440,   130,   287,   288,    57,   440,
      13,    43,    15,    16,    17,    18,    19,    20,    19,    20,
     156,    70,   372,   307,    27,    28,    29,    30,   609,    32,
      62,    80,   316,  1081,    45,   171,  1995,    86,  1013,  1014,
      19,    20,   440,   168,    45,   440,   120,   183,   173,   440,
    1025,   184,   185,    15,   635,   636,   297,   298,    69,    19,
      20,    79,   643,    22,   645,     3,    45,   116,    63,   118,
     119,   255,   439,    19,    20,   386,   387,   126,  2037,    19,
     180,  1125,   663,   169,    44,    19,   118,   668,   443,   670,
     440,   672,   439,   674,    19,    55,   677,   678,   679,    45,
      79,   444,    29,    30,   685,   138,    33,   688,    39,    40,
      41,    51,   161,   162,   443,   126,   127,   120,    18,    19,
      20,   702,   255,   126,   173,   143,    19,    20,   202,   203,
     204,   205,   206,   207,   208,    18,    19,    20,   263,   264,
     721,   722,   723,    86,    87,   429,   430,   431,   432,   198,
     224,   443,   201,   227,   444,   445,  1310,   189,  1348,  1201,
     443,   260,  1126,   148,   149,   150,   151,   152,   445,  1211,
      60,    61,  1214,   324,   259,   260,  1220,   411,   412,   413,
     120,    60,    61,   440,    19,  1229,  1083,     3,   191,   192,
    1087,  1088,  1089,   117,  1091,    69,  1093,   440,     8,     9,
      10,    11,    12,    19,   439,  1102,   444,   445,   439,  1363,
    1254,  1108,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    19,    20,    33,   443,   228,   229,   230,   231,   232,
     233,   443,  1068,   324,  1070,     7,     8,     9,    10,    81,
     445,   439,   245,    79,   255,   248,    73,    19,    69,   126,
     253,    78,   444,   445,    20,   340,   444,   445,   285,   344,
     259,   260,   202,   203,   204,   205,   206,   207,   208,   166,
     445,    13,    85,    15,    16,    17,    18,    19,    20,   148,
     149,  1325,   435,   436,   224,    27,    28,   227,    30,    76,
      32,    76,   128,   129,   271,   122,   148,   149,  1342,  1343,
     116,  1345,   146,   147,   278,   141,   142,    87,   144,  1353,
    1395,  1396,  1356,   283,   191,   192,   256,   434,   435,   444,
      13,   297,    15,    16,    17,    18,    19,    20,   443,   301,
     311,   416,    87,   304,    27,    28,   163,    30,   306,    32,
    1237,   440,  1496,   266,  1241,  1242,   319,   443,   317,   434,
    1247,    13,   439,    15,    16,    17,    18,    19,    20,   444,
     366,   942,   116,   439,   117,    27,    28,    29,    30,   443,
      32,   248,   443,   954,   146,   147,   443,   254,   120,    86,
     961,   439,   963,   443,   126,   324,   443,  1284,   443,  1286,
     439,    86,   439,   398,   399,    86,    76,   402,   403,   404,
       8,     9,    10,    11,    12,   443,    79,    79,   148,   149,
     150,   151,   152,  1457,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   443,   137,    33,   139,   120,    81,   256,
      85,   439,   439,   126,    76,   439,    20,   440,   137,   444,
    1997,  1998,  1999,   439,   447,   439,    19,  1522,     3,   191,
     192,     3,     3,  2010,   167,     3,     3,     3,   120,     3,
    1502,     3,  1504,   279,   126,  1429,     3,  1559,   167,   141,
       3,   143,   144,     3,  2031,  2032,  2033,  2034,  1375,  1376,
    1377,   180,     3,   181,   181,    14,   228,   229,   230,   231,
     232,   233,    15,    27,    30,    33,    28,    19,   191,   192,
      15,   328,     7,   245,   444,  1402,   248,     3,   324,   445,
     439,   253,   440,   329,   136,  1559,  1560,   439,   439,   439,
      19,   439,   194,   195,   196,   197,    76,    76,   344,   191,
     192,    51,   439,  1577,    46,   228,   229,   439,  1582,   309,
    1584,  1585,   174,  1587,   257,   258,    31,   439,   261,   262,
     439,    76,   245,   183,   267,   248,   383,   373,   374,    76,
     253,   388,    76,  1717,   439,    76,   228,   229,   267,  1466,
    1467,   439,  1469,   439,    86,  1729,   117,   439,     8,     9,
      10,    11,    12,   245,   439,   439,   248,   414,   183,   439,
    1554,   253,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   428,    69,    33,   116,    19,   433,   117,   120,   121,
    1654,   123,   124,   125,   439,  1196,   439,  1198,   130,   276,
    1664,  1665,  1666,  1204,  1668,  1669,     3,   439,   138,  1673,
     140,   441,     3,    46,    19,   145,  1680,    15,  1219,    19,
     339,   340,   341,    19,   343,    19,     3,  1228,  1692,  1693,
     160,    20,    15,    66,   211,  1697,   168,    15,   441,    15,
     254,   173,  1243,    28,   445,    15,  1710,  1711,   445,    18,
     443,   440,  1716,    86,    20,  1750,  1720,  1752,   439,   236,
    1724,   439,   439,  1727,  1776,  1777,  1778,   244,   439,    28,
    1844,   131,   249,   250,   251,  1739,   206,   445,   440,    19,
     212,   439,   439,   116,   439,   447,   439,   120,   121,   439,
     439,   124,   125,  1757,  1611,   439,   439,   130,   439,   439,
    1764,   439,   439,   439,   439,  1622,  1623,  1624,  1625,   439,
     439,   444,  1776,  1777,  1778,   439,   439,   439,  1782,   439,
      69,     3,     3,   439,    15,   444,     3,   440,   441,  1793,
    1794,  1795,  1796,  1797,   447,   168,   439,   439,   439,     3,
     173,   439,   439,  1344,   439,  1809,     3,  1811,   345,   346,
     347,   348,   349,   350,   351,   352,   189,  1931,   440,   439,
    1824,   439,     3,   439,     3,   447,     3,   439,     3,  1833,
     183,   183,  1836,  1837,    28,    28,  1840,  1841,   209,   210,
     211,   212,   213,   214,   215,   216,  1850,   218,   219,   220,
     221,   222,   223,   439,   445,   439,   441,   181,   439,  1863,
     439,   439,   445,   439,  1868,  1869,  1870,     8,     9,    10,
      11,    12,   439,   441,  1878,   439,   439,  1881,  1882,   439,
     439,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     439,   439,    33,   439,   439,  1899,  1900,  1901,   324,  1903,
     439,   439,  1906,    13,   439,    15,    16,    17,    18,    19,
      20,   375,   440,    22,   439,   439,     3,    27,    28,    29,
      30,    13,    32,    15,    16,    17,    18,    19,    20,     3,
      15,    15,    28,   405,   406,    27,    28,   409,    30,    15,
      32,   314,   445,    15,  1948,   445,  1950,    46,    47,    48,
      49,    50,    51,    52,    53,    54,  1960,   444,    69,   443,
     439,    13,    22,    15,    16,    17,    18,    19,    20,   445,
     443,   439,   444,   439,   443,    27,    28,    29,    30,    13,
      32,    15,    16,    17,    18,    19,    20,     8,     9,    10,
      11,    12,   443,    27,    28,    29,    30,   443,    32,   443,
      28,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     120,    29,    33,    29,  1555,     7,   126,   183,    19,   444,
     266,   439,   443,   443,   443,   441,   443,  1568,   120,     3,
       3,   441,  1889,   441,   126,  1576,   441,  1578,   440,    15,
     441,   226,   441,   263,     8,     9,    10,    11,    12,   441,
     439,   441,   440,   440,  1595,  1596,  1597,   440,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    29,   120,    33,
     441,   444,   440,     7,   126,    29,   439,   443,   260,   443,
     439,   191,   192,   439,   283,   439,   120,   401,   401,   439,
     439,    13,   126,    15,    16,    17,    18,    19,    20,   191,
     192,   444,     7,   445,   137,    27,    28,    29,    30,   441,
      32,   441,   261,   441,   441,  1656,   261,   261,   228,   229,
    1661,   440,  1663,   146,   324,   361,   441,   319,   379,   283,
       8,     9,    10,    11,    12,   245,   228,   229,   248,   191,
     192,   443,   377,   253,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   245,   369,    33,   248,   191,   192,   347,
    1701,   253,   345,   439,    99,   439,   389,   123,   393,    76,
     396,   278,   266,   108,   392,   266,   228,   229,   113,   439,
     115,   439,   117,    20,   119,   439,   121,  1728,   123,  1730,
     125,    76,   127,   245,   228,   229,   248,   361,   120,   319,
     369,   253,    76,    13,   126,    15,    16,    17,    18,    19,
      20,   245,    76,   421,   248,   439,   423,    27,    28,   253,
      30,   324,    32,   361,     8,     9,    10,    11,    12,   261,
     261,   444,   188,   439,   439,    20,   261,   380,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   261,  1789,    33,
      69,   410,   439,   444,   360,   439,   445,   355,   360,   439,
     364,  1802,   562,   439,   264,  1138,   439,   441,   439,   191,
     192,     8,     9,    10,    11,    12,   439,   439,   439,   439,
    1821,  1822,   439,   439,  1825,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   445,   441,    33,   439,  1839,  1045,
     441,  1036,  1843,   877,  1845,  1124,   228,   229,  1128,   752,
     120,  1912,   385,  1120,   593,  1750,   126,  1307,   927,   848,
    1861,  1862,  1606,   245,   280,   195,   248,   849,  1752,  1245,
     440,   253,  1469,   854,  1083,  1376,  1877,   447,  1143,  1425,
    1491,   968,  1883,  1441,  1885,  1886,  1499,   439,   440,     8,
       9,    10,    11,    12,  1697,   447,  1717,  1898,  1844,  1721,
    1720,  1022,  1846,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,    -1,    -1,    -1,    -1,   335,
      -1,   191,   192,    -1,    -1,    -1,    -1,    -1,   440,    -1,
      -1,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,    -1,
    1941,   357,    -1,   359,    -1,    -1,   440,    -1,   364,    -1,
     366,    -1,    -1,   447,   370,   371,    -1,    -1,   228,   229,
     441,    -1,    -1,    -1,  1965,    -1,    -1,    -1,    -1,    -1,
       8,     9,    10,    11,    12,   245,    -1,    -1,   248,    -1,
      -1,    -1,    -1,   253,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   441,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,   444,    33,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,    -1,    -1,   440,     8,
       9,    10,    11,    12,    -1,   447,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   441,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,     8,     9,    10,    11,
      12,    -1,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,
     440,     8,     9,    10,    11,    12,    -1,   447,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,   441,    -1,    -1,
      82,    83,    -1,    -1,    -1,    -1,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,    -1,   143,   144,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   441,     8,     9,    10,    11,    12,
      -1,    -1,    -1,   161,    -1,    -1,   138,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   176,    -1,
      33,    -1,     8,     9,    10,    11,    12,    -1,    -1,   187,
      -1,   189,   190,    -1,    -1,     5,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   177,    -1,    33,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,   441,    33,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,   256,    33,
      -1,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
     242,   243,    82,    83,    -1,    -1,    -1,    -1,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,    -1,    -1,    -1,    -1,
      -1,     3,    -1,   441,   286,   287,   288,   289,   290,   291,
     292,   293,   294,    -1,    42,    -1,    -1,    19,    -1,    -1,
     328,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     312,   313,    -1,    -1,    -1,    -1,    -1,   441,    66,    67,
      -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,   330,   331,
     332,   333,     8,     9,    10,    11,    12,   177,    -1,    87,
      -1,    -1,    -1,   441,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    46,     8,
       9,    10,    11,    12,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   441,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,    -1,   414,    75,    -1,   137,
      -1,   139,     8,     9,    10,    -1,   118,   119,    86,    -1,
     428,    -1,    -1,   441,   126,   433,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,   166,   167,
      -1,    -1,    -1,    -1,   426,   427,    -1,    -1,   116,   441,
      -1,    -1,   120,   121,    -1,   437,   124,   125,    -1,   161,
      -1,    -1,   130,    -1,    -1,    -1,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   441,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,    46,
      -1,    -1,   312,   313,    51,    -1,    -1,    -1,    -1,   201,
     168,    -1,    -1,    -1,   441,   173,    -1,   327,    -1,    66,
     330,   331,   332,   333,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,   256,    86,
      -1,   259,   260,    -1,    46,    -1,    -1,    -1,    -1,   267,
      -1,    73,    74,    75,    -1,    77,    78,    -1,    80,    -1,
      -1,    -1,    84,    -1,    86,    87,    -1,    -1,    -1,   116,
      -1,    -1,    -1,   120,   121,   122,   123,   124,   125,    -1,
      -1,    -1,    84,   130,    86,    46,   439,   134,    -1,    -1,
     137,    -1,   139,    -1,   116,    -1,    -1,    -1,   120,   121,
     318,    -1,   124,   125,    -1,    -1,    -1,    -1,   130,    46,
      -1,    -1,    -1,   439,   116,    -1,   426,   427,   120,   121,
      -1,   168,   124,   125,    -1,    86,   173,   437,   130,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   439,
      -1,    -1,   189,    -1,   191,    -1,   168,    -1,    -1,    86,
     368,   173,    -1,   200,    -1,   116,    -1,    -1,    -1,   120,
     121,    -1,   123,   124,   125,   439,   168,   385,    -1,   130,
      -1,   173,    -1,    -1,    -1,    66,    -1,    -1,    -1,   116,
      -1,    -1,    -1,   120,   121,    -1,   123,   124,   125,    -1,
      -1,   238,    19,   130,    -1,    -1,    -1,    -1,   416,   417,
      -1,   419,   420,    -1,   422,    -1,    -1,   168,    -1,   256,
      -1,    -1,   173,    -1,    -1,    -1,   263,   264,    -1,   266,
      46,    -1,    -1,    -1,   271,   272,   444,   274,   275,    -1,
     277,   168,    46,   280,   281,   282,   173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   137,   181,   295,   296,
      -1,    -1,    -1,   300,    -1,   302,   303,    -1,   305,    -1,
      86,    -1,    -1,   310,    -1,    -1,    -1,   314,   315,    -1,
     317,   318,    86,   320,   321,   322,   167,    -1,   212,   326,
      -1,    -1,    -1,    -1,    -1,    -1,   444,    -1,    -1,   180,
     116,    -1,    -1,   439,   120,   121,    -1,    -1,   124,   125,
      -1,    -1,   116,    -1,   130,   196,   120,   121,    -1,   123,
     124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
     439,    -1,    -1,   257,    -1,    -1,    -1,   329,    -1,    -1,
      -1,    -1,   334,   335,   336,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   280,   173,    -1,    -1,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,   173,
      -1,    -1,    -1,    -1,     3,   256,   368,    -1,   259,   260,
      -1,    -1,    -1,   375,    -1,    -1,   267,    -1,    -1,    18,
      19,    -1,   209,   210,   211,   212,   213,   214,   215,   216,
     324,   218,   219,   220,   221,   222,   223,   444,     8,     9,
      10,    11,    12,    46,    -1,    -1,    45,   368,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,   444,    33,    -1,    -1,    -1,   318,    71,    72,
     321,    -1,    -1,   324,    -1,    -1,    -1,    -1,    81,    -1,
      -1,    -1,   444,    -1,   335,    -1,   337,    86,   339,   340,
     341,   342,   343,   344,   415,    -1,   390,   391,    -1,   350,
     394,   395,   353,   397,    -1,   356,    -1,    -1,    -1,    -1,
      -1,   405,   406,    -1,    -1,    -1,    -1,   368,    -1,   118,
      -1,    -1,    -1,   444,    -1,   376,   125,   126,    -1,    -1,
      -1,   134,    -1,    -1,    -1,    -1,    -1,   136,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   444,    -1,    -1,
     444,    -1,    -1,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,
     173,    -1,   175,    -1,    -1,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,    -1,   191,   192,
     193,    -1,    -1,   444,    -1,   198,   199,   200,   384,   385,
       3,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   225,   255,    33,   444,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     444,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,   219,   220,   221,   222,   223
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   450,   451,    46,    71,    72,    81,   134,   170,
     173,   175,   182,   186,   191,   192,   193,   198,   199,   200,
     475,   476,   477,   478,   479,   480,   539,   540,   541,   542,
     544,   545,   546,   549,   552,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   582,   651,   688,
     689,   690,   691,   692,   693,   694,   695,   745,   746,   756,
     767,   768,   769,   771,     0,     3,    34,    43,    46,    57,
      70,    80,    86,   116,   118,   119,   126,   161,   162,   173,
     198,   201,   439,   452,   464,   470,   473,   474,   483,   486,
     489,   491,   494,   496,   497,   499,   500,   507,   517,   518,
     585,   587,   597,   635,   638,   652,   654,   655,   656,   697,
     698,   699,   704,   734,   737,   747,   748,   757,   760,   770,
     772,   773,   774,    19,    20,    45,   583,    20,    56,    64,
      65,    66,   481,     3,   583,   583,   171,   172,   583,    79,
     583,     3,   161,   143,   144,   161,   176,   187,   189,   190,
     256,   328,   414,   428,   433,   161,   161,    79,   141,   143,
     144,   194,   195,   196,   197,    13,    15,    16,    17,    18,
      19,    20,    27,    28,    30,    32,   120,   126,   191,   192,
     228,   229,   245,   248,   253,   440,   447,   602,   614,   619,
     622,   623,   624,   626,   628,    36,    45,   443,   568,   583,
      19,    19,    20,    44,    55,   462,   466,    68,   143,   157,
      43,    62,   118,   189,   471,   472,    50,    67,    81,    19,
     117,    19,    86,   163,    79,   143,   462,   628,    19,    19,
     138,   501,   501,   443,    73,    78,   122,   163,   256,   328,
     383,   388,   414,   428,   433,   501,    46,    66,    86,   116,
     120,   121,   123,   124,   125,   130,   168,   173,   444,   502,
     520,   501,   501,    51,    66,    80,   122,   123,   134,   137,
     139,   189,   191,   200,   238,   256,   263,   264,   266,   271,
     272,   274,   275,   277,   280,   281,   282,   295,   296,   300,
     302,   303,   305,   310,   314,   315,   317,   318,   320,   321,
     322,   326,   444,   502,   501,    84,   329,   334,   335,   336,
     368,   375,   444,   502,   657,   658,   659,   501,   384,   385,
     444,   502,   501,   501,   501,    66,   189,   314,   444,   502,
     749,   752,   501,    73,    74,    75,    77,    78,    80,    84,
      87,   444,   485,   488,   502,    75,   153,   444,   487,   502,
      36,    45,   443,   521,   481,     3,     3,   481,    67,   482,
       3,     3,   583,   583,     3,   527,   579,    36,    45,   443,
     524,    86,   554,    19,    20,    45,   584,     3,   188,   550,
       3,     3,   547,   553,   270,    19,   123,   196,   367,   381,
     382,   543,   144,   196,   543,   144,   196,   438,    18,    19,
     456,   458,   458,     3,     3,     3,     3,     3,     3,     3,
       3,    15,    19,    29,   440,   446,   618,   620,   626,    30,
     440,   254,    28,   254,    15,   446,   621,   628,   440,   440,
     440,   440,   440,   440,   230,   231,   232,   233,   607,   628,
      15,    16,    17,    19,   440,   602,   603,   606,   608,   609,
     610,   612,   614,   615,   616,     5,    82,    83,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   138,   177,   234,   235,
     237,   238,   239,   240,   241,   242,   243,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   312,   313,   327,   330,
     331,   332,   333,   426,   427,   437,   627,   775,     3,     8,
       9,    10,    11,    12,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    33,    46,    47,    48,    49,    50,    51,
      52,    53,    54,   468,   469,    15,   569,     3,    22,    63,
     465,    45,   443,   467,    15,    19,    35,    36,    37,    38,
      69,   440,   453,   455,   521,   453,    20,    58,    59,   439,
     453,   454,   454,   180,   169,   495,    15,    17,    18,    19,
     138,   440,   490,   586,    19,   492,   443,   527,   528,   524,
     439,   598,   138,    19,   443,   443,   498,   443,   521,   324,
      19,   506,   117,   453,   455,   519,    45,    69,   126,   127,
     135,   255,   503,   594,    69,   503,    69,   462,   524,   439,
     439,   443,   443,   180,   284,   324,    81,   439,    20,   285,
     462,   455,    69,    85,   189,   299,   325,   166,   455,   439,
     453,   456,   653,   183,   456,    76,   273,   283,    76,   271,
     278,   287,   288,    87,   283,   297,   298,   297,   301,   455,
     304,   306,   311,    86,    87,   122,   316,    87,   319,   317,
     455,   266,   455,   439,   443,   366,   490,   455,   116,   453,
     455,   117,   439,   443,   443,    86,   386,   387,   439,   443,
     443,   443,   324,   458,    86,   439,   207,   276,   307,   316,
     429,   430,   431,   432,   443,   755,   443,    86,   455,    76,
     455,    79,    81,    85,   453,   439,   439,   439,    76,    20,
     463,   439,   439,    79,   128,   129,   141,   142,   144,   522,
     523,     3,   482,     3,   453,     3,     3,     3,    86,   126,
     140,   529,   580,   581,   594,     3,   128,   174,   525,   526,
       3,    19,     3,   584,     3,     3,     3,    86,   156,   171,
     183,   551,     3,    45,    86,   118,   125,   126,   136,   153,
     154,   155,   156,   158,   159,   458,   548,   594,     3,    19,
      86,   118,   119,   126,   161,   201,   543,   543,   543,   696,
      45,   543,    45,   543,     3,   543,   543,     3,   543,   543,
     543,    30,   442,   460,   181,   181,     7,   620,   620,   628,
     620,   620,    14,    15,   628,   632,   633,    27,    28,   254,
      28,   621,   621,    30,   628,   628,   628,   628,   628,    19,
      15,   445,   441,   445,    29,   605,   607,   628,     7,   445,
     448,    27,    28,   443,   445,   448,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     211,   236,   244,   249,   250,   251,   444,   445,     3,   628,
     462,   468,   439,   454,   628,   453,    60,    61,    60,    61,
      39,    40,    41,   453,   514,   515,   628,   439,   209,   210,
     211,   212,   213,   214,   215,   216,   218,   219,   220,   221,
     222,   223,   588,   589,   590,   592,   596,    42,   164,   165,
     166,   439,   493,   527,   439,   439,   440,   595,    19,   161,
     444,   455,   490,   508,   511,   512,    36,   453,   505,    19,
     592,   593,   136,   628,   505,   505,   637,    76,    76,   455,
      76,   323,   455,   439,    51,   439,   439,   453,   259,   260,
     455,   309,   455,   174,   456,   439,   439,    31,   457,    42,
     183,   439,   453,   183,   453,    76,    76,   453,    76,   135,
     279,   453,   453,   455,    76,   439,   117,   439,   455,   439,
     455,   279,   307,   308,   455,   506,   455,   439,   439,   455,
     455,   455,   439,   183,   439,   455,   455,    69,   453,   660,
      19,   439,   439,   703,   736,   455,   506,    20,   456,   456,
     276,   750,   751,   754,   439,   759,   453,   453,   455,   455,
     455,   453,   456,   458,   459,   444,   445,     3,    20,   506,
     531,   593,   462,   581,   444,   445,     3,    19,    15,   458,
      19,    19,   593,   459,    19,     3,    20,   687,   687,     3,
      19,   116,   279,   324,   329,   344,   373,   374,   543,   687,
     543,   687,   687,   687,   687,   687,   687,   453,   456,    15,
      15,    15,   441,   445,   441,   254,    28,   445,   445,   445,
     441,   445,   441,   445,   628,   628,   445,     7,   445,   445,
     441,    18,   440,   603,   610,    15,    18,   615,   440,   469,
     439,   444,   441,    20,   439,   512,   439,   441,    19,   217,
     439,   443,   453,   456,    86,   184,   185,   529,   530,   532,
     441,   589,   591,   596,   458,   439,    28,   510,   445,   131,
     504,   455,   123,   263,   264,   444,   502,   636,   453,   453,
     439,   453,   439,   439,   455,   439,   439,   439,   439,   455,
     439,   455,   439,    19,   653,   453,   453,   439,   453,   439,
     453,   453,   439,   453,   439,   439,   439,   439,   439,   453,
     490,   439,   439,   439,   439,   439,   439,   439,   439,   439,
     439,   439,   439,   453,   453,   123,   188,   280,   335,   357,
     359,   364,   366,   370,   371,   444,   661,   668,   671,   439,
     123,   212,   405,   406,   409,   444,   502,   700,   123,   368,
     415,   444,   502,   735,   439,   439,   457,   456,   256,   369,
     750,    19,    51,   120,   202,   203,   204,   205,   206,   207,
     208,   224,   227,   256,   444,   624,   625,   629,   634,   753,
     123,   444,   502,   758,    69,   484,   523,   526,     3,     3,
     490,   490,    15,   490,   687,     3,   687,     3,     3,     3,
       3,     3,     3,   183,   183,   620,   632,    28,    28,   628,
     628,   628,   628,   628,   445,   441,   445,    29,   605,   628,
     605,    29,   605,   605,   628,   445,   628,   590,   599,   600,
     634,   531,   453,   462,   444,   532,   439,   439,   441,   181,
      20,   459,   509,   511,    81,   132,   133,   134,   639,   645,
     639,   646,   456,   650,   439,   445,   439,   439,   439,   439,
     439,   439,   439,   439,   439,   439,   439,   439,   439,   680,
     686,   455,   337,   338,   370,   337,   455,   662,   324,   458,
     664,   665,   663,   372,   455,   439,   375,   681,   705,   713,
     458,   714,   719,   701,   702,   458,   439,   738,   744,   455,
     453,   439,   457,   455,   453,    22,   440,    22,   440,   628,
     628,   628,   455,   627,   775,   439,   628,   630,   631,   761,
     766,   439,   453,     3,     3,    15,    15,    28,   441,   441,
     441,   441,   445,   628,   628,   441,   445,     7,   441,   445,
     441,   445,     7,   441,   445,   445,    15,   441,   444,   634,
     439,   591,    15,   459,   512,   513,   443,   644,    31,   265,
     647,   453,   512,   682,   453,   453,   455,   453,   443,   490,
     443,   443,   453,   453,   443,   513,   443,   718,   443,   456,
     720,   725,    20,   443,   726,   731,   513,    69,   628,   633,
     628,   624,   439,   225,   443,   439,    22,    22,    33,   445,
     439,   513,   554,   554,    28,   628,   441,   441,    29,   605,
      29,   605,    29,   605,     7,    29,   605,    29,   605,   444,
     183,   644,   643,   640,    19,   462,   266,   648,   439,   683,
     443,   685,   673,   666,   673,   669,   443,   712,   717,   716,
     721,   727,   443,   743,   453,   439,   441,   439,   775,   443,
     601,   634,   617,   628,   628,   126,   191,   192,   248,   254,
     631,   443,   765,     3,     3,   441,   441,   441,   441,   445,
       7,   441,   441,   441,   445,   440,   441,     7,   441,   441,
       7,   441,    15,   640,   137,   139,   167,   257,   258,   261,
     262,   267,   444,   533,   535,   536,   641,   456,   263,   649,
     681,   684,   444,   458,   674,   675,   188,   337,   358,   444,
     667,   444,   180,   267,   339,   340,   341,   343,   444,   533,
     670,   711,   710,   398,   399,   402,   403,   404,   444,   715,
     724,   730,   742,   739,   441,   599,   226,     6,    15,    16,
      17,   440,   444,   602,   604,   606,   608,   609,   611,   613,
     439,   439,   440,   440,   440,   440,   439,   764,   762,    29,
     605,    29,   605,   605,     7,   605,   439,   462,   455,   443,
     259,   260,   260,   454,   453,   127,   146,   268,   269,   642,
     443,   439,   455,    66,   180,   196,   256,   259,   260,   267,
     318,   321,   324,   335,   337,   339,   340,   341,   342,   343,
     344,   350,   353,   356,   368,   376,   444,   533,   672,   358,
     365,   676,   455,   453,   455,   439,   453,   127,   268,   354,
     453,   453,   283,   155,   453,   439,   181,   212,   257,   280,
     324,   390,   391,   394,   395,   397,   405,   406,   444,   706,
     401,   401,   455,   455,   455,   439,   401,   407,   444,   722,
     401,   408,   444,   728,    42,    66,    67,    87,   139,   166,
     256,   259,   260,   267,   318,   368,   385,   416,   417,   419,
     420,   422,   444,   533,   740,   439,   444,   601,   599,   628,
       7,   442,   445,   628,   628,   628,   628,    42,    66,   259,
     260,   340,   344,   416,   434,   444,   763,   441,   441,   441,
     445,   441,   440,   441,   534,   535,   261,   261,   261,   148,
     149,   146,   117,   138,   140,   145,   160,   206,   537,   324,
     453,   443,   455,   361,   178,   179,   342,   378,   516,   127,
     268,   354,   319,   455,   379,   455,   453,   453,   453,   283,
     453,   155,   453,   345,   346,   347,   348,   349,   350,   351,
     352,   377,   347,   453,   369,   345,   439,   453,   439,   453,
     453,   389,   719,   283,   389,   120,   401,   393,   455,   392,
      76,   396,   278,   266,   707,   266,   708,   439,   453,   453,
     400,   453,   732,   720,   723,   439,   732,   726,   729,   439,
     453,   324,   424,    76,   453,   455,   456,   455,   361,   342,
     378,   516,   127,   148,   354,   425,   741,   319,   369,   345,
     418,    76,    76,   360,   453,   421,   423,   439,   441,   440,
     604,   599,   611,   441,   441,   441,   441,   453,   324,   361,
     342,   378,   516,   261,   435,   436,   261,   453,   439,   605,
     605,   444,   439,   454,   454,   454,   148,   149,   453,    20,
     461,   461,   146,   147,   538,   138,   140,   138,   140,   444,
     455,   677,   362,   363,   453,   453,   453,   453,   453,   260,
     455,   380,   453,   453,   455,   455,   453,   455,   261,   453,
     261,   411,   412,   413,   709,   453,   453,   455,   453,   453,
      69,   455,   725,   455,   731,   410,   733,   733,   453,   455,
     455,   453,   453,   453,   453,   260,   455,   453,   453,   453,
     455,   455,   455,   628,   439,   439,   439,   439,   455,   453,
     453,   453,   453,   453,   441,   445,   534,   439,   439,   439,
     148,   149,   150,   151,   152,   148,   149,   150,   151,   152,
     439,   461,   461,   461,   461,   444,   456,   679,   360,   455,
     453,   453,   733,   453,   455,   360,   605,   537,   537,   537,
     537,   439,   439,   439,   439,   355,   678,   445,   537,   537,
     537,   537,   439,   605,   441
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 848 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 849 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 862 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 872 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 873 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 880 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000000; }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 881 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000; }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 882 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1; }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 890 "cf-parse.y"
    { (yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 891 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 892 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 893 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 894 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 895 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 902 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 909 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 910 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 914 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 922 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 926 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 930 "cf-parse.y"
    {
     (yyval.i) = ipa_masklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 937 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 946 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[(1) - (1)].s)).s;
   }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 953 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 954 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 960 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 969 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 970 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 974 "cf-parse.y"
    {
     struct rfile *rf = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!rf) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = rf->f;
   }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 979 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 980 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 984 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 985 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 989 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 990 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 994 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 995 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 996 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 997 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 998 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 999 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 1000 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 1001 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 1002 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 1008 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 1009 "cf-parse.y"
    { add_tail(&new_config->mrt_table_dumps, &this_mrt_table_config->n); }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 1010 "cf-parse.y"
    {
     struct rfile *rf = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!rf) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrt_proto_file = fileno(rf->f);
   }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 1019 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 1020 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 1021 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 1022 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 1025 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 1026 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 1027 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 1028 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 1029 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){NULL, NULL, 0}; }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 1030 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 1040 "cf-parse.y"
    { new_config->latency_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 1041 "cf-parse.y"
    { new_config->latency_limit = (yyvsp[(4) - (4)].i32); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 1042 "cf-parse.y"
    { new_config->watchdog_warning = (yyvsp[(3) - (3)].i32); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 1043 "cf-parse.y"
    { new_config->watchdog_timeout = ((yyvsp[(3) - (3)].i32) + 999999) TO_S; }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 1052 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 1055 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 1062 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 1065 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 1068 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 1071 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 1074 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 1079 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 1080 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 1081 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 1089 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 1094 "cf-parse.y"
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 1095 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) <= 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 1099 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 1100 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 1104 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 1111 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 1112 "cf-parse.y"
    { THIS_KRT->graceful_restart = (yyvsp[(3) - (3)].i); }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 1113 "cf-parse.y"
    {
      THIS_KRT->merge_paths = (yyvsp[(3) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[(3) - (4)].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 1125 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 1130 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1134 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 1148 "cf-parse.y"
    { THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i); }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 1149 "cf-parse.y"
    { THIS_KRT->sys.metric = (yyvsp[(2) - (2)].i); }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 1163 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1164 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1168 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1169 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1171 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 1178 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[(1) - (1)].s)).i;
#ifndef IPV6
     else if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[(1) - (1)].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 1200 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1201 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1202 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 1203 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1208 "cf-parse.y"
    { new_config->gr_wait = (yyvsp[(4) - (5)].i); }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1214 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1215 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1219 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1227 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 1233 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 1247 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1248 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1252 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1258 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1262 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[(2) - (2)].s)->class != SYM_TEMPLATE) && ((yyvsp[(2) - (2)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(2) - (2)].s)->def);
   }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1271 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1282 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1286 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1287 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1288 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1289 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1290 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1291 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1292 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1293 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1294 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1295 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1296 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1297 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1301 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1303 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 1304 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1308 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1309 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1310 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 1311 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 1312 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1316 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1322 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 1326 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1334 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1335 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1343 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 1351 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1352 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1353 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1357 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 1358 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 1372 "cf-parse.y"
    { iface_patt_check(); }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1374 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1386 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 1387 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1393 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1403 "cf-parse.y"
    { DIRECT_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 1407 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 1421 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 1422 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1423 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1428 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 1432 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1433 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 1434 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 1435 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1436 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 1437 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1443 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 1444 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1445 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1450 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1454 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1455 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1461 "cf-parse.y"
    {
   this_mrt_table_config = mrt_table_new_config();
 }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1472 "cf-parse.y"
    {
     if (this_mrt_table_config->c.filter != FILTER_ACCEPT)
       cf_error("Filter specified twice");
     this_mrt_table_config->c.filter = (yyvsp[(1) - (1)].f);
   }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 1477 "cf-parse.y"
    {
     if (this_mrt_table_config->c.filter != FILTER_ACCEPT)
       cf_error("Filter specified twice");
     this_mrt_table_config->c.filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1491 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].r)->name; }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1492 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1496 "cf-parse.y"
    { this_mrt_table_config->c.period = (yyvsp[(2) - (2)].i); }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1497 "cf-parse.y"
    { this_mrt_table_config->c.filename_fmt = (yyvsp[(2) - (2)].t); }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1498 "cf-parse.y"
    { this_mrt_table_config->rtable_wildcard_name = (yyvsp[(2) - (2)].t); }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1520 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->length = strlen((yyvsp[(2) - (2)].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1540 "cf-parse.y"
    { }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1541 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1542 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1543 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1544 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1545 "cf-parse.y"
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[(2) - (4)].time); }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1546 "cf-parse.y"
    { this_p_item->gento = this_p_item->accto = (yyvsp[(2) - (4)].time); }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1547 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1548 "cf-parse.y"
    { this_p_item->alg = (yyvsp[(2) - (4)].i); }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1552 "cf-parse.y"
    { (yyval.i) = ALG_MD5; }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1553 "cf-parse.y"
    { (yyval.i) = ALG_SHA1; }
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1554 "cf-parse.y"
    { (yyval.i) = ALG_SHA256; }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1555 "cf-parse.y"
    { (yyval.i) = ALG_SHA384; }
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1556 "cf-parse.y"
    { (yyval.i) = ALG_SHA512; }
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1557 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_MD5; }
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1558 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA1; }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1559 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA256; }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1560 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA384; }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1561 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA512; }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1568 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1571 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1574 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1577 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1581 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1585 "cf-parse.y"
    { if_show(); }
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1588 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1592 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1595 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1600 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1606 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1613 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1618 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1623 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1628 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1632 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1636 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1640 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1649 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1657 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1661 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1668 "cf-parse.y"
    { (yyval.i) = RSEM_PREEXPORT; }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1669 "cf-parse.y"
    { (yyval.i) = RSEM_EXPORT; }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1670 "cf-parse.y"
    { (yyval.i) = RSEM_NOEXPORT; }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1676 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1679 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1686 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1693 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1697 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1705 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1706 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1707 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1713 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1716 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1719 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1720 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1721 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1722 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1723 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1724 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1725 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1730 "cf-parse.y"
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1735 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1744 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1751 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1758 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1766 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1768 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1770 "cf-parse.y"
    { io_log_dump(); cli_msg(0, ""); }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1772 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1774 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1776 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 1778 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1780 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1783 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 1786 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1792 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1793 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1794 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1798 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 1799 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1806 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1808 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1810 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1812 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 1814 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 1816 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 1820 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1824 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1828 "cf-parse.y"
    {
  this_mrt_table_config->c.cli = this_cli;
  this_mrt_table_config->c.config = NULL;
  mrt_table_cli_cmd(this_mrt_table_config);
}
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 1845 "cf-parse.y"
    { this_mrt_table_config->rtable_wildcard_name = (yyvsp[(2) - (2)].t); }
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 1846 "cf-parse.y"
    { this_mrt_table_config->c.filename_fmt = (yyvsp[(2) - (2)].t); }
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 1851 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 1854 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 1855 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 1856 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 1860 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 1861 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 1862 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 1870 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 1871 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 1880 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 1884 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 1885 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 321:
/* Line 1792 of yacc.c  */
#line 1886 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 1887 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 1888 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 1889 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 1890 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 1891 "cf-parse.y"
    { (yyval.i) = T_LC; }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 1892 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 1893 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 1894 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 1895 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 1896 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 1897 "cf-parse.y"
    { (yyval.i) = T_LCLIST; }
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 1898 "cf-parse.y"
    {
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 1920 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 1931 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 1932 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 1939 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 1940 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 1947 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 1956 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 1964 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 1988 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 1989 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 1993 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 2006 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 2009 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name);
     cf_pop_scope();
   }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 2022 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 2023 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 2026 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 2027 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 2031 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 2034 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 2056 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 2057 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 2058 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 2059 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 2060 "cf-parse.y"
    {
     (yyval.v) = f_eval((yyvsp[(2) - (3)].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 2064 "cf-parse.y"
    {
     if (!cf_symbol_is_constant((yyvsp[(1) - (1)].s))) cf_error("%s: constant expected", (yyvsp[(1) - (1)].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[(1) - (1)].s)))) cf_error("%s: set-incompatible type", (yyvsp[(1) - (1)].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[(1) - (1)].s)->def);
   }
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 2072 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 2073 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 2074 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 2075 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 2076 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 2080 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 2083 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); }
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 2084 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 2085 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), 0, CC_ALL); }
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 2086 "cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 2087 "cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 2088 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, CC_ALL); }
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 2089 "cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); }
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 2090 "cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 2091 "cf-parse.y"
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 2093 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (11)].i32), (yyvsp[(8) - (11)].i32), (yyvsp[(4) - (11)].i32), (yyvsp[(10) - (11)].i32)); }
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 2097 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 2098 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 2099 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 2100 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 2104 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 2105 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 2106 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 2110 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2111 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 2112 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, LC_ALL); }
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 2113 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), 0, LC_ALL); }
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2114 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), 0, LC_ALL, 0, LC_ALL); }
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 2115 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), 0, LC_ALL, 0, LC_ALL); }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 2116 "cf-parse.y"
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2118 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (15)].i32), (yyvsp[(10) - (15)].i32), (yyvsp[(4) - (15)].i32), (yyvsp[(12) - (15)].i32), (yyvsp[(6) - (15)].i32), (yyvsp[(14) - (15)].i32)); }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 2125 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 2126 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2133 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2134 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 2139 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 2144 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 2148 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2155 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2156 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2157 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2158 "cf-parse.y"
    {
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2165 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2166 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2169 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2170 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2177 "cf-parse.y"
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2189 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2190 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2194 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2195 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2199 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2200 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(4) - (4)].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[(1) - (4)].i); (yyval.h)->val2 = (yyvsp[(3) - (4)].i); }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2201 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; }
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2202 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2203 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2204 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2208 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2209 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; }
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2210 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2214 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2215 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2216 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2217 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2218 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2219 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2220 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2221 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2222 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2223 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2224 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2228 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2229 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 2230 "cf-parse.y"
    { (yyval.x) = f_generate_lc((yyvsp[(2) - (7)].x), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2244 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2267 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2281 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2282 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2283 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2284 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2285 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2286 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 2287 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 2288 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 2289 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 2290 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 2294 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 2295 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 2296 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 2297 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 2298 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 2299 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 2300 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 463:
/* Line 1792 of yacc.c  */
#line 2301 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 2302 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 465:
/* Line 1792 of yacc.c  */
#line 2303 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 2304 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 2305 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 2306 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 2307 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 2308 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','~');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 2309 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 2310 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 2312 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 2313 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 2314 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 2316 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 2318 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 2320 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 2322 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 2323 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 2324 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 2325 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 2326 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 2327 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','L'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 2337 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 2338 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 2339 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 2340 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_LCLIST; }
    break;

  case 489:
/* Line 1792 of yacc.c  */
#line 2341 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 2342 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 2343 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 2344 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 2346 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 2347 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 2352 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 2375 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 2376 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 2377 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 2378 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 2379 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 2380 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 2384 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 2387 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 2388 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 2389 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 2397 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 2404 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 2413 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 2414 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 510:
/* Line 1792 of yacc.c  */
#line 2418 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 2424 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 512:
/* Line 1792 of yacc.c  */
#line 2434 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 513:
/* Line 1792 of yacc.c  */
#line 2443 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 2449 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 515:
/* Line 1792 of yacc.c  */
#line 2454 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 2461 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 2466 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 2472 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 2473 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 2474 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 2482 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 2483 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 2484 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 2485 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 2486 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 2493 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[(1) - (2)].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 2520 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 2534 "cf-parse.y"
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 2554 "cf-parse.y"
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[(2) - (2)].i32); }
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 2555 "cf-parse.y"
    { BFD_IFACE->min_rx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 2556 "cf-parse.y"
    { BFD_IFACE->min_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 2557 "cf-parse.y"
    { BFD_IFACE->idle_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 2558 "cf-parse.y"
    { BFD_IFACE->multiplier = (yyvsp[(2) - (2)].i); }
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 2559 "cf-parse.y"
    { BFD_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 2560 "cf-parse.y"
    { BFD_IFACE->auth_type = (yyvsp[(2) - (2)].i); }
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 2561 "cf-parse.y"
    {}
    break;

  case 544:
/* Line 1792 of yacc.c  */
#line 2565 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_NONE; }
    break;

  case 545:
/* Line 1792 of yacc.c  */
#line 2566 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_SIMPLE; }
    break;

  case 546:
/* Line 1792 of yacc.c  */
#line 2567 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 2568 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 2569 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 2570 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 2588 "cf-parse.y"
    { BFD_CFG->multihop = BFD_IFACE; }
    break;

  case 556:
/* Line 1792 of yacc.c  */
#line 2592 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 557:
/* Line 1792 of yacc.c  */
#line 2593 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 2594 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 2598 "cf-parse.y"
    { (yyval.a) = IPA_NONE; }
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 2599 "cf-parse.y"
    { (yyval.a) = (yyvsp[(2) - (2)].a); }
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 2603 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 562:
/* Line 1792 of yacc.c  */
#line 2604 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 563:
/* Line 1792 of yacc.c  */
#line 2608 "cf-parse.y"
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[(1) - (4)].a);
  BFD_NEIGHBOR->local = (yyvsp[(3) - (4)].a);
  BFD_NEIGHBOR->iface = (yyvsp[(2) - (4)].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[(4) - (4)].i);

  if ((yyvsp[(4) - (4)].i) && (yyvsp[(2) - (4)].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[(4) - (4)].i) && ipa_zero((yyvsp[(3) - (4)].a)))
    cf_error("Multihop neighbor requires specified local address");
}
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 2627 "cf-parse.y"
    { bfd_show_sessions(proto_get_named((yyvsp[(4) - (5)].s), &proto_bfd)); }
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 2632 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[(1) - (2)].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->setkey = 1;
 }
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 2659 "cf-parse.y"
    { BGP_CFG->remote_port = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Invalid port number");  }
    break;

  case 568:
/* Line 1792 of yacc.c  */
#line 2660 "cf-parse.y"
    { BGP_CFG->remote_as = (yyvsp[(3) - (3)].i); }
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 2666 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 2667 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 574:
/* Line 1792 of yacc.c  */
#line 2669 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     if ((yyvsp[(4) - (6)].iface)) BGP_CFG->iface = (yyvsp[(4) - (6)].iface);
   }
    break;

  case 575:
/* Line 1792 of yacc.c  */
#line 2675 "cf-parse.y"
    { BGP_CFG->iface = if_get_by_name((yyvsp[(3) - (4)].t)); }
    break;

  case 576:
/* Line 1792 of yacc.c  */
#line 2676 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 577:
/* Line 1792 of yacc.c  */
#line 2677 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 578:
/* Line 1792 of yacc.c  */
#line 2678 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 579:
/* Line 1792 of yacc.c  */
#line 2679 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 2680 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 2681 "cf-parse.y"
    { BGP_CFG->multihop = 0; }
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 2682 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 583:
/* Line 1792 of yacc.c  */
#line 2683 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 2684 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 585:
/* Line 1792 of yacc.c  */
#line 2685 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 2686 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 2687 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 588:
/* Line 1792 of yacc.c  */
#line 2688 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 2689 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 2690 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 2691 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 2692 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 2693 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 2694 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 2695 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 2696 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 2697 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 2698 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 2699 "cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 2700 "cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 2701 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 2702 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 2703 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 2704 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 2705 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 2706 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 2707 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 2708 "cf-parse.y"
    { BGP_CFG->enable_extended_messages = (yyvsp[(5) - (6)].i); }
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 2709 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 2710 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 2711 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 2712 "cf-parse.y"
    { BGP_CFG->setkey = (yyvsp[(3) - (4)].i); }
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 2713 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 2719 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 615:
/* Line 1792 of yacc.c  */
#line 2720 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 616:
/* Line 1792 of yacc.c  */
#line 2721 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 617:
/* Line 1792 of yacc.c  */
#line 2722 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_RX; }
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 2723 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_TX; }
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 2724 "cf-parse.y"
    { BGP_CFG->add_path = (yyvsp[(4) - (5)].i) ? ADD_PATH_FULL : 0; }
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 2725 "cf-parse.y"
    { BGP_CFG->allow_local_as = -1; }
    break;

  case 621:
/* Line 1792 of yacc.c  */
#line 2726 "cf-parse.y"
    { BGP_CFG->allow_local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 2727 "cf-parse.y"
    { BGP_CFG->gr_mode = (yyvsp[(4) - (5)].i); }
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 2728 "cf-parse.y"
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 2729 "cf-parse.y"
    { BGP_CFG->gr_time = (yyvsp[(5) - (6)].i); }
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 2730 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 2731 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 2732 "cf-parse.y"
    { BGP_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 2733 "cf-parse.y"
    { BGP_CFG->bfd = (yyvsp[(3) - (4)].i); cf_check_bfd((yyvsp[(3) - (4)].i)); }
    break;

  case 629:
/* Line 1792 of yacc.c  */
#line 2744 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 2760 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 2761 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 635:
/* Line 1792 of yacc.c  */
#line 2762 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 636:
/* Line 1792 of yacc.c  */
#line 2763 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 637:
/* Line 1792 of yacc.c  */
#line 2764 "cf-parse.y"
    { OSPF_CFG->merge_external = (yyvsp[(3) - (3)].i); }
    break;

  case 638:
/* Line 1792 of yacc.c  */
#line 2765 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 2766 "cf-parse.y"
    { OSPF_CFG->instance_id = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<0) || ((yyvsp[(3) - (3)].i)>255)) cf_error("Instance ID must be in range 0-255"); }
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 2770 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 2785 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 2794 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 2795 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 647:
/* Line 1792 of yacc.c  */
#line 2796 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 648:
/* Line 1792 of yacc.c  */
#line 2797 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 649:
/* Line 1792 of yacc.c  */
#line 2798 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 650:
/* Line 1792 of yacc.c  */
#line 2799 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 2800 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 652:
/* Line 1792 of yacc.c  */
#line 2801 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 653:
/* Line 1792 of yacc.c  */
#line 2802 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 654:
/* Line 1792 of yacc.c  */
#line 2803 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 656:
/* Line 1792 of yacc.c  */
#line 2804 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 2816 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 2830 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 2831 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 2832 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 2836 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 670:
/* Line 1792 of yacc.c  */
#line 2837 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 674:
/* Line 1792 of yacc.c  */
#line 2846 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 675:
/* Line 1792 of yacc.c  */
#line 2847 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); }
    break;

  case 676:
/* Line 1792 of yacc.c  */
#line 2848 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 677:
/* Line 1792 of yacc.c  */
#line 2849 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); }
    break;

  case 678:
/* Line 1792 of yacc.c  */
#line 2850 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 679:
/* Line 1792 of yacc.c  */
#line 2851 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 680:
/* Line 1792 of yacc.c  */
#line 2852 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
    break;

  case 681:
/* Line 1792 of yacc.c  */
#line 2853 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
    break;

  case 682:
/* Line 1792 of yacc.c  */
#line 2854 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 2855 "cf-parse.y"
    { ospf_check_auth(); }
    break;

  case 684:
/* Line 1792 of yacc.c  */
#line 2859 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
    break;

  case 685:
/* Line 1792 of yacc.c  */
#line 2878 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 686:
/* Line 1792 of yacc.c  */
#line 2879 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 687:
/* Line 1792 of yacc.c  */
#line 2880 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 688:
/* Line 1792 of yacc.c  */
#line 2881 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); }
    break;

  case 689:
/* Line 1792 of yacc.c  */
#line 2882 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); }
    break;

  case 690:
/* Line 1792 of yacc.c  */
#line 2883 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 691:
/* Line 1792 of yacc.c  */
#line 2884 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 692:
/* Line 1792 of yacc.c  */
#line 2885 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 693:
/* Line 1792 of yacc.c  */
#line 2886 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 694:
/* Line 1792 of yacc.c  */
#line 2887 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 695:
/* Line 1792 of yacc.c  */
#line 2888 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 696:
/* Line 1792 of yacc.c  */
#line 2889 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 697:
/* Line 1792 of yacc.c  */
#line 2890 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 2891 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 2892 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 2893 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 701:
/* Line 1792 of yacc.c  */
#line 2894 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
    break;

  case 702:
/* Line 1792 of yacc.c  */
#line 2895 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 703:
/* Line 1792 of yacc.c  */
#line 2896 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 2897 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 705:
/* Line 1792 of yacc.c  */
#line 2898 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 706:
/* Line 1792 of yacc.c  */
#line 2899 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 707:
/* Line 1792 of yacc.c  */
#line 2900 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 708:
/* Line 1792 of yacc.c  */
#line 2901 "cf-parse.y"
    { OSPF_PATT->link_lsa_suppression = (yyvsp[(4) - (4)].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
    break;

  case 710:
/* Line 1792 of yacc.c  */
#line 2903 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 2904 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
    break;

  case 712:
/* Line 1792 of yacc.c  */
#line 2905 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
    break;

  case 713:
/* Line 1792 of yacc.c  */
#line 2906 "cf-parse.y"
    { OSPF_PATT->rx_buffer = 0; }
    break;

  case 714:
/* Line 1792 of yacc.c  */
#line 2907 "cf-parse.y"
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 2908 "cf-parse.y"
    { OSPF_PATT->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 2909 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 717:
/* Line 1792 of yacc.c  */
#line 2910 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 718:
/* Line 1792 of yacc.c  */
#line 2911 "cf-parse.y"
    { OSPF_PATT->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 719:
/* Line 1792 of yacc.c  */
#line 2912 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 720:
/* Line 1792 of yacc.c  */
#line 2913 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 721:
/* Line 1792 of yacc.c  */
#line 2914 "cf-parse.y"
    { OSPF_PATT->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 722:
/* Line 1792 of yacc.c  */
#line 2915 "cf-parse.y"
    { OSPF_PATT->bsd_secondary = (yyvsp[(2) - (2)].i); }
    break;

  case 723:
/* Line 1792 of yacc.c  */
#line 2916 "cf-parse.y"
    { ospf_check_auth(); }
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 2927 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 729:
/* Line 1792 of yacc.c  */
#line 2937 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 730:
/* Line 1792 of yacc.c  */
#line 2938 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 733:
/* Line 1792 of yacc.c  */
#line 2947 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 734:
/* Line 1792 of yacc.c  */
#line 2948 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 735:
/* Line 1792 of yacc.c  */
#line 2952 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 736:
/* Line 1792 of yacc.c  */
#line 2961 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 2984 "cf-parse.y"
    { OSPF_PATT->instance_id = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Instance ID must be in range 0-255"); }
    break;

  case 739:
/* Line 1792 of yacc.c  */
#line 2988 "cf-parse.y"
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
    break;

  case 745:
/* Line 1792 of yacc.c  */
#line 3002 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 747:
/* Line 1792 of yacc.c  */
#line 3007 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 748:
/* Line 1792 of yacc.c  */
#line 3013 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 749:
/* Line 1792 of yacc.c  */
#line 3016 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 750:
/* Line 1792 of yacc.c  */
#line 3019 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 751:
/* Line 1792 of yacc.c  */
#line 3024 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 752:
/* Line 1792 of yacc.c  */
#line 3027 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 753:
/* Line 1792 of yacc.c  */
#line 3032 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 754:
/* Line 1792 of yacc.c  */
#line 3035 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 755:
/* Line 1792 of yacc.c  */
#line 3039 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 756:
/* Line 1792 of yacc.c  */
#line 3042 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 757:
/* Line 1792 of yacc.c  */
#line 3045 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 758:
/* Line 1792 of yacc.c  */
#line 3046 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 759:
/* Line 1792 of yacc.c  */
#line 3047 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 760:
/* Line 1792 of yacc.c  */
#line 3048 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 761:
/* Line 1792 of yacc.c  */
#line 3049 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 762:
/* Line 1792 of yacc.c  */
#line 3050 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 763:
/* Line 1792 of yacc.c  */
#line 3051 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 764:
/* Line 1792 of yacc.c  */
#line 3052 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 765:
/* Line 1792 of yacc.c  */
#line 3058 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 768:
/* Line 1792 of yacc.c  */
#line 3067 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 769:
/* Line 1792 of yacc.c  */
#line 3072 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 770:
/* Line 1792 of yacc.c  */
#line 3073 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 771:
/* Line 1792 of yacc.c  */
#line 3080 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, (yyvsp[(1) - (2)].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
    break;

  case 774:
/* Line 1792 of yacc.c  */
#line 3091 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
    break;

  case 775:
/* Line 1792 of yacc.c  */
#line 3092 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 776:
/* Line 1792 of yacc.c  */
#line 3092 "cf-parse.y"
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
    break;

  case 777:
/* Line 1792 of yacc.c  */
#line 3093 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 778:
/* Line 1792 of yacc.c  */
#line 3093 "cf-parse.y"
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
    break;

  case 779:
/* Line 1792 of yacc.c  */
#line 3094 "cf-parse.y"
    {
     RADV_CFG->trigger_prefix = (yyvsp[(2) - (2)].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[(2) - (2)].px).len;
     RADV_CFG->trigger_valid = 1;
   }
    break;

  case 783:
/* Line 1792 of yacc.c  */
#line 3111 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
}
    break;

  case 784:
/* Line 1792 of yacc.c  */
#line 3129 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); }
    break;

  case 785:
/* Line 1792 of yacc.c  */
#line 3130 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
    break;

  case 786:
/* Line 1792 of yacc.c  */
#line 3131 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); }
    break;

  case 787:
/* Line 1792 of yacc.c  */
#line 3132 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); }
    break;

  case 788:
/* Line 1792 of yacc.c  */
#line 3133 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); }
    break;

  case 789:
/* Line 1792 of yacc.c  */
#line 3134 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); }
    break;

  case 790:
/* Line 1792 of yacc.c  */
#line 3135 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
    break;

  case 791:
/* Line 1792 of yacc.c  */
#line 3136 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
    break;

  case 792:
/* Line 1792 of yacc.c  */
#line 3137 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
    break;

  case 793:
/* Line 1792 of yacc.c  */
#line 3138 "cf-parse.y"
    {
     RADV_IFACE->default_lifetime = (yyvsp[(3) - (4)].i);
     if (((yyvsp[(3) - (4)].i) < 0) || ((yyvsp[(3) - (4)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 794:
/* Line 1792 of yacc.c  */
#line 3143 "cf-parse.y"
    { RADV_IFACE->default_preference = (yyvsp[(3) - (3)].i); }
    break;

  case 795:
/* Line 1792 of yacc.c  */
#line 3144 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
    break;

  case 796:
/* Line 1792 of yacc.c  */
#line 3145 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 797:
/* Line 1792 of yacc.c  */
#line 3145 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
    break;

  case 798:
/* Line 1792 of yacc.c  */
#line 3146 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 799:
/* Line 1792 of yacc.c  */
#line 3146 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
    break;

  case 800:
/* Line 1792 of yacc.c  */
#line 3147 "cf-parse.y"
    { RADV_IFACE->rdnss_local = (yyvsp[(3) - (3)].i); }
    break;

  case 801:
/* Line 1792 of yacc.c  */
#line 3148 "cf-parse.y"
    { RADV_IFACE->dnssl_local = (yyvsp[(3) - (3)].i); }
    break;

  case 802:
/* Line 1792 of yacc.c  */
#line 3152 "cf-parse.y"
    { (yyval.i) = RA_PREF_LOW; }
    break;

  case 803:
/* Line 1792 of yacc.c  */
#line 3153 "cf-parse.y"
    { (yyval.i) = RA_PREF_MEDIUM; }
    break;

  case 804:
/* Line 1792 of yacc.c  */
#line 3154 "cf-parse.y"
    { (yyval.i) = RA_PREF_HIGH; }
    break;

  case 805:
/* Line 1792 of yacc.c  */
#line 3157 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
}
    break;

  case 811:
/* Line 1792 of yacc.c  */
#line 3190 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
    break;

  case 812:
/* Line 1792 of yacc.c  */
#line 3202 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); }
    break;

  case 813:
/* Line 1792 of yacc.c  */
#line 3203 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); }
    break;

  case 814:
/* Line 1792 of yacc.c  */
#line 3204 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); }
    break;

  case 815:
/* Line 1792 of yacc.c  */
#line 3205 "cf-parse.y"
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Valid lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 816:
/* Line 1792 of yacc.c  */
#line 3210 "cf-parse.y"
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Preferred lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 817:
/* Line 1792 of yacc.c  */
#line 3218 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
    break;

  case 823:
/* Line 1792 of yacc.c  */
#line 3242 "cf-parse.y"
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[(1) - (1)].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 824:
/* Line 1792 of yacc.c  */
#line 3251 "cf-parse.y"
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 827:
/* Line 1792 of yacc.c  */
#line 3258 "cf-parse.y"
    { RADV_RDNSS->lifetime = (yyvsp[(2) - (2)].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
    break;

  case 828:
/* Line 1792 of yacc.c  */
#line 3262 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
    break;

  case 833:
/* Line 1792 of yacc.c  */
#line 3286 "cf-parse.y"
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[(1) - (1)].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
    break;

  case 834:
/* Line 1792 of yacc.c  */
#line 3298 "cf-parse.y"
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 837:
/* Line 1792 of yacc.c  */
#line 3305 "cf-parse.y"
    { RADV_DNSSL->lifetime = (yyvsp[(2) - (2)].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
    break;

  case 838:
/* Line 1792 of yacc.c  */
#line 3309 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
    break;

  case 843:
/* Line 1792 of yacc.c  */
#line 3333 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i); radv_mult_val = 0; }
    break;

  case 844:
/* Line 1792 of yacc.c  */
#line 3334 "cf-parse.y"
    { (yyval.i) = 0; radv_mult_val = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
    break;

  case 845:
/* Line 1792 of yacc.c  */
#line 3338 "cf-parse.y"
    { (yyval.i) = -1; }
    break;

  case 846:
/* Line 1792 of yacc.c  */
#line 3339 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 847:
/* Line 1792 of yacc.c  */
#line 3346 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[(1) - (2)].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
    break;

  case 849:
/* Line 1792 of yacc.c  */
#line 3359 "cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (2)].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 850:
/* Line 1792 of yacc.c  */
#line 3360 "cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 851:
/* Line 1792 of yacc.c  */
#line 3361 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(2) - (2)].i); }
    break;

  case 856:
/* Line 1792 of yacc.c  */
#line 3375 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
    break;

  case 857:
/* Line 1792 of yacc.c  */
#line 3398 "cf-parse.y"
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
    break;

  case 858:
/* Line 1792 of yacc.c  */
#line 3428 "cf-parse.y"
    { RIP_IFACE->metric = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Metric must be in range 1-255"); }
    break;

  case 859:
/* Line 1792 of yacc.c  */
#line 3429 "cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
    break;

  case 860:
/* Line 1792 of yacc.c  */
#line 3430 "cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
    break;

  case 861:
/* Line 1792 of yacc.c  */
#line 3431 "cf-parse.y"
    { RIP_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 862:
/* Line 1792 of yacc.c  */
#line 3432 "cf-parse.y"
    { RIP_IFACE->address = (yyvsp[(2) - (2)].a); }
    break;

  case 863:
/* Line 1792 of yacc.c  */
#line 3433 "cf-parse.y"
    { RIP_IFACE->port = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid port number"); }
    break;

  case 864:
/* Line 1792 of yacc.c  */
#line 3434 "cf-parse.y"
    { RIP_IFACE->version = (yyvsp[(2) - (2)].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[(2) - (2)].i) != RIP_V1) && ((yyvsp[(2) - (2)].i) != RIP_V2)) cf_error("Unsupported version");
			}
    break;

  case 865:
/* Line 1792 of yacc.c  */
#line 3438 "cf-parse.y"
    { RIP_IFACE->version_only = (yyvsp[(3) - (3)].i); }
    break;

  case 866:
/* Line 1792 of yacc.c  */
#line 3439 "cf-parse.y"
    { RIP_IFACE->split_horizon = (yyvsp[(3) - (3)].i); }
    break;

  case 867:
/* Line 1792 of yacc.c  */
#line 3440 "cf-parse.y"
    { RIP_IFACE->poison_reverse = (yyvsp[(3) - (3)].i); }
    break;

  case 868:
/* Line 1792 of yacc.c  */
#line 3441 "cf-parse.y"
    { RIP_IFACE->check_zero = (yyvsp[(3) - (3)].i); }
    break;

  case 869:
/* Line 1792 of yacc.c  */
#line 3442 "cf-parse.y"
    { RIP_IFACE->update_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Update time must be positive"); }
    break;

  case 870:
/* Line 1792 of yacc.c  */
#line 3443 "cf-parse.y"
    { RIP_IFACE->timeout_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Timeout time must be positive"); }
    break;

  case 871:
/* Line 1792 of yacc.c  */
#line 3444 "cf-parse.y"
    { RIP_IFACE->garbage_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Garbage time must be positive"); }
    break;

  case 872:
/* Line 1792 of yacc.c  */
#line 3445 "cf-parse.y"
    { RIP_IFACE->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 873:
/* Line 1792 of yacc.c  */
#line 3446 "cf-parse.y"
    { RIP_IFACE->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("RX length must be in range 256-65535"); }
    break;

  case 874:
/* Line 1792 of yacc.c  */
#line 3447 "cf-parse.y"
    { RIP_IFACE->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 875:
/* Line 1792 of yacc.c  */
#line 3448 "cf-parse.y"
    { RIP_IFACE->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 876:
/* Line 1792 of yacc.c  */
#line 3449 "cf-parse.y"
    { RIP_IFACE->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 877:
/* Line 1792 of yacc.c  */
#line 3450 "cf-parse.y"
    { RIP_IFACE->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 878:
/* Line 1792 of yacc.c  */
#line 3451 "cf-parse.y"
    { RIP_IFACE->ttl_security = 2; }
    break;

  case 879:
/* Line 1792 of yacc.c  */
#line 3452 "cf-parse.y"
    { RIP_IFACE->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 880:
/* Line 1792 of yacc.c  */
#line 3453 "cf-parse.y"
    { RIP_IFACE->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 881:
/* Line 1792 of yacc.c  */
#line 3454 "cf-parse.y"
    { RIP_IFACE->auth_type = (yyvsp[(2) - (2)].i); if ((yyvsp[(2) - (2)].i)) rip_check_auth(); }
    break;

  case 882:
/* Line 1792 of yacc.c  */
#line 3455 "cf-parse.y"
    { rip_check_auth(); }
    break;

  case 883:
/* Line 1792 of yacc.c  */
#line 3459 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_NONE; }
    break;

  case 884:
/* Line 1792 of yacc.c  */
#line 3460 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_PLAIN; }
    break;

  case 885:
/* Line 1792 of yacc.c  */
#line 3461 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; }
    break;

  case 886:
/* Line 1792 of yacc.c  */
#line 3462 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; }
    break;

  case 892:
/* Line 1792 of yacc.c  */
#line 3483 "cf-parse.y"
    { rip_show_interfaces(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); }
    break;

  case 893:
/* Line 1792 of yacc.c  */
#line 3486 "cf-parse.y"
    { rip_show_neighbors(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); }
    break;

  case 894:
/* Line 1792 of yacc.c  */
#line 3492 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 897:
/* Line 1792 of yacc.c  */
#line 3501 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 898:
/* Line 1792 of yacc.c  */
#line 3502 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 899:
/* Line 1792 of yacc.c  */
#line 3503 "cf-parse.y"
    { static_route_finish(); }
    break;

  case 900:
/* Line 1792 of yacc.c  */
#line 3506 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
    break;

  case 901:
/* Line 1792 of yacc.c  */
#line 3516 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
    break;

  case 902:
/* Line 1792 of yacc.c  */
#line 3525 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 903:
/* Line 1792 of yacc.c  */
#line 3529 "cf-parse.y"
    {
     this_srt_nh->use_bfd = (yyvsp[(3) - (3)].i); cf_check_bfd((yyvsp[(3) - (3)].i));
   }
    break;

  case 904:
/* Line 1792 of yacc.c  */
#line 3535 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 905:
/* Line 1792 of yacc.c  */
#line 3536 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 906:
/* Line 1792 of yacc.c  */
#line 3540 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 907:
/* Line 1792 of yacc.c  */
#line 3545 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 908:
/* Line 1792 of yacc.c  */
#line 3551 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 909:
/* Line 1792 of yacc.c  */
#line 3554 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 910:
/* Line 1792 of yacc.c  */
#line 3559 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 911:
/* Line 1792 of yacc.c  */
#line 3560 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 912:
/* Line 1792 of yacc.c  */
#line 3561 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 913:
/* Line 1792 of yacc.c  */
#line 3562 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 914:
/* Line 1792 of yacc.c  */
#line 3563 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 915:
/* Line 1792 of yacc.c  */
#line 3567 "cf-parse.y"
    { *this_srt_last_cmd = (yyvsp[(1) - (1)].x); this_srt_last_cmd = &((yyvsp[(1) - (1)].x)->next); }
    break;

  case 916:
/* Line 1792 of yacc.c  */
#line 3568 "cf-parse.y"
    { this_srt->use_bfd = (yyvsp[(2) - (3)].i); cf_check_bfd((yyvsp[(2) - (3)].i)); }
    break;

  case 921:
/* Line 1792 of yacc.c  */
#line 3583 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 922:
/* Line 1792 of yacc.c  */
#line 3589 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_babel, (yyvsp[(1) - (2)].i));
  init_list(&BABEL_CFG->iface_list);
}
    break;

  case 928:
/* Line 1792 of yacc.c  */
#line 3609 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
    break;

  case 929:
/* Line 1792 of yacc.c  */
#line 3622 "cf-parse.y"
    {
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
}
    break;

  case 931:
/* Line 1792 of yacc.c  */
#line 3646 "cf-parse.y"
    { BABEL_IFACE->port = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid port number"); }
    break;

  case 932:
/* Line 1792 of yacc.c  */
#line 3647 "cf-parse.y"
    { BABEL_IFACE->rxcost = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid rxcost"); }
    break;

  case 933:
/* Line 1792 of yacc.c  */
#line 3648 "cf-parse.y"
    { BABEL_IFACE->hello_interval = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid hello interval"); }
    break;

  case 934:
/* Line 1792 of yacc.c  */
#line 3649 "cf-parse.y"
    { BABEL_IFACE->update_interval = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid update interval"); }
    break;

  case 935:
/* Line 1792 of yacc.c  */
#line 3650 "cf-parse.y"
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
    break;

  case 936:
/* Line 1792 of yacc.c  */
#line 3651 "cf-parse.y"
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
    break;

  case 937:
/* Line 1792 of yacc.c  */
#line 3652 "cf-parse.y"
    { BABEL_IFACE->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
    break;

  case 938:
/* Line 1792 of yacc.c  */
#line 3653 "cf-parse.y"
    { BABEL_IFACE->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 939:
/* Line 1792 of yacc.c  */
#line 3654 "cf-parse.y"
    { BABEL_IFACE->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 940:
/* Line 1792 of yacc.c  */
#line 3655 "cf-parse.y"
    { BABEL_IFACE->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 941:
/* Line 1792 of yacc.c  */
#line 3656 "cf-parse.y"
    { BABEL_IFACE->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 947:
/* Line 1792 of yacc.c  */
#line 3677 "cf-parse.y"
    { babel_show_interfaces(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel), (yyvsp[(5) - (6)].t)); }
    break;

  case 948:
/* Line 1792 of yacc.c  */
#line 3680 "cf-parse.y"
    { babel_show_neighbors(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel), (yyvsp[(5) - (6)].t)); }
    break;

  case 949:
/* Line 1792 of yacc.c  */
#line 3683 "cf-parse.y"
    { babel_show_entries(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel)); }
    break;

  case 1023:
/* Line 1792 of yacc.c  */
#line 3691 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 1024:
/* Line 1792 of yacc.c  */
#line 3691 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 1037:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 1038:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 1039:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 1040:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 1041:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
    break;

  case 1042:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
    break;

  case 1043:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
    break;

  case 1044:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
    break;

  case 1045:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
    break;

  case 1046:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
    break;

  case 1047:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
    break;

  case 1048:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
    break;

  case 1049:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
    break;

  case 1050:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
    break;

  case 1051:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
    break;

  case 1052:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
    break;

  case 1053:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
    break;

  case 1054:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
    break;

  case 1055:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
    break;

  case 1056:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
    break;

  case 1057:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
    break;

  case 1058:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
    break;

  case 1059:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
    break;

  case 1060:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
    break;

  case 1061:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
    break;

  case 1062:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
    break;

  case 1063:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
    break;

  case 1064:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
    break;

  case 1065:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
    break;

  case 1066:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
    break;

  case 1067:
/* Line 1792 of yacc.c  */
#line 3695 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 1068:
/* Line 1792 of yacc.c  */
#line 3695 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 1069:
/* Line 1792 of yacc.c  */
#line 3696 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 1070:
/* Line 1792 of yacc.c  */
#line 3697 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 1071:
/* Line 1792 of yacc.c  */
#line 3698 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 1072:
/* Line 1792 of yacc.c  */
#line 3699 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 1073:
/* Line 1792 of yacc.c  */
#line 3700 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 1074:
/* Line 1792 of yacc.c  */
#line 3701 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 1075:
/* Line 1792 of yacc.c  */
#line 3702 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 1076:
/* Line 1792 of yacc.c  */
#line 3703 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 1077:
/* Line 1792 of yacc.c  */
#line 3704 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 1078:
/* Line 1792 of yacc.c  */
#line 3705 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 1079:
/* Line 1792 of yacc.c  */
#line 3706 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 1080:
/* Line 1792 of yacc.c  */
#line 3707 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
    break;

  case 1081:
/* Line 1792 of yacc.c  */
#line 3707 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 1082:
/* Line 1792 of yacc.c  */
#line 3707 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 1083:
/* Line 1792 of yacc.c  */
#line 3707 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 1084:
/* Line 1792 of yacc.c  */
#line 3707 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 1085:
/* Line 1792 of yacc.c  */
#line 3707 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 1086:
/* Line 1792 of yacc.c  */
#line 3707 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;

  case 1087:
/* Line 1792 of yacc.c  */
#line 3707 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_BABEL_METRIC); }
    break;


/* Line 1792 of yacc.c  */
#line 10766 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 3709 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

/* C Code from ../../proto/babel/config.Y */

