/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;
static struct mrt_table_config *this_mrt_table_config;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c') && (t3->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst();
    rv->code = 'C';

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->code = P('m','l');
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}


/* Line 371 of yacc.c  */
#line 686 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     NMA = 277,
     DEFINE = 278,
     ON = 279,
     OFF = 280,
     YES = 281,
     NO = 282,
     S = 283,
     MS = 284,
     US = 285,
     PORT = 286,
     LOG = 287,
     SYSLOG = 288,
     ALL = 289,
     DEBUG = 290,
     TRACE = 291,
     INFO = 292,
     REMOTE = 293,
     WARNING = 294,
     ERROR = 295,
     AUTH = 296,
     FATAL = 297,
     BUG = 298,
     STDERR = 299,
     SOFT = 300,
     TIMEFORMAT = 301,
     ISO = 302,
     OLD = 303,
     SHORT = 304,
     LONG = 305,
     BASE = 306,
     NAME = 307,
     CONFIRM = 308,
     UNDO = 309,
     CHECK = 310,
     TIMEOUT = 311,
     LATENCY = 312,
     LIMIT = 313,
     WATCHDOG = 314,
     CONFIGURE = 315,
     DOWN = 316,
     KERNEL = 317,
     PERSIST = 318,
     SCAN = 319,
     TIME = 320,
     LEARN = 321,
     DEVICE = 322,
     ROUTES = 323,
     GRACEFUL = 324,
     RESTART = 325,
     KRT_SOURCE = 326,
     KRT_METRIC = 327,
     MERGE = 328,
     PATHS = 329,
     TABLE = 330,
     METRIC = 331,
     KRT_PREFSRC = 332,
     KRT_REALM = 333,
     KRT_SCOPE = 334,
     KRT_MTU = 335,
     KRT_WINDOW = 336,
     KRT_RTT = 337,
     KRT_RTTVAR = 338,
     KRT_SSTRESH = 339,
     KRT_CWND = 340,
     KRT_ADVMSS = 341,
     KRT_REORDERING = 342,
     KRT_HOPLIMIT = 343,
     KRT_INITCWND = 344,
     KRT_RTO_MIN = 345,
     KRT_INITRWND = 346,
     KRT_QUICKACK = 347,
     KRT_LOCK_MTU = 348,
     KRT_LOCK_WINDOW = 349,
     KRT_LOCK_RTT = 350,
     KRT_LOCK_RTTVAR = 351,
     KRT_LOCK_SSTRESH = 352,
     KRT_LOCK_CWND = 353,
     KRT_LOCK_ADVMSS = 354,
     KRT_LOCK_REORDERING = 355,
     KRT_LOCK_HOPLIMIT = 356,
     KRT_LOCK_RTO_MIN = 357,
     KRT_FEATURE_ECN = 358,
     KRT_FEATURE_ALLFRAG = 359,
     ROUTER = 360,
     ID = 361,
     PROTOCOL = 362,
     TEMPLATE = 363,
     PREFERENCE = 364,
     DISABLED = 365,
     DIRECT = 366,
     INTERFACE = 367,
     IMPORT = 368,
     EXPORT = 369,
     FILTER = 370,
     NONE = 371,
     STATES = 372,
     FILTERS = 373,
     RECEIVE = 374,
     ACTION = 375,
     WARN = 376,
     BLOCK = 377,
     DISABLE = 378,
     KEEP = 379,
     FILTERED = 380,
     PASSWORD = 381,
     FROM = 382,
     PASSIVE = 383,
     TO = 384,
     EVENTS = 385,
     PACKETS = 386,
     PROTOCOLS = 387,
     INTERFACES = 388,
     ALGORITHM = 389,
     KEYED = 390,
     HMAC = 391,
     MD5 = 392,
     SHA1 = 393,
     SHA256 = 394,
     SHA384 = 395,
     SHA512 = 396,
     PRIMARY = 397,
     STATS = 398,
     COUNT = 399,
     FOR = 400,
     COMMANDS = 401,
     PREEXPORT = 402,
     NOEXPORT = 403,
     GENERATE = 404,
     ROA = 405,
     LISTEN = 406,
     BGP = 407,
     V6ONLY = 408,
     DUAL = 409,
     ADDRESS = 410,
     PASSWORDS = 411,
     DESCRIPTION = 412,
     SORTED = 413,
     RELOAD = 414,
     IN = 415,
     OUT = 416,
     MRTDUMP = 417,
     MESSAGES = 418,
     RESTRICT = 419,
     MEMORY = 420,
     IGP_METRIC = 421,
     CLASS = 422,
     DSCP = 423,
     WAIT = 424,
     MAX = 425,
     FLUSH = 426,
     AS = 427,
     PERIOD = 428,
     FILENAME = 429,
     SHOW = 430,
     STATUS = 431,
     SUMMARY = 432,
     ROUTE = 433,
     SYMBOLS = 434,
     ADD = 435,
     DELETE = 436,
     DUMP = 437,
     RESOURCES = 438,
     SOCKETS = 439,
     NEIGHBORS = 440,
     ATTRIBUTES = 441,
     EVAL = 442,
     ECHO = 443,
     ENABLE = 444,
     FUNCTION = 445,
     PRINT = 446,
     PRINTN = 447,
     UNSET = 448,
     RETURN = 449,
     ACCEPT = 450,
     REJECT = 451,
     QUITBIRD = 452,
     INT = 453,
     BOOL = 454,
     IP = 455,
     PREFIX = 456,
     PAIR = 457,
     QUAD = 458,
     EC = 459,
     LC = 460,
     SET = 461,
     STRING = 462,
     BGPMASK = 463,
     BGPPATH = 464,
     CLIST = 465,
     ECLIST = 466,
     LCLIST = 467,
     IF = 468,
     THEN = 469,
     ELSE = 470,
     CASE = 471,
     TRUE = 472,
     FALSE = 473,
     RT = 474,
     RO = 475,
     UNKNOWN = 476,
     GENERIC = 477,
     GW = 478,
     NET = 479,
     MASK = 480,
     PROTO = 481,
     SOURCE = 482,
     SCOPE = 483,
     CAST = 484,
     DEST = 485,
     IFNAME = 486,
     IFINDEX = 487,
     LEN = 488,
     DEFINED = 489,
     CONTAINS = 490,
     RESET = 491,
     PREPEND = 492,
     FIRST = 493,
     LAST = 494,
     LAST_NONAGGREGATED = 495,
     MATCH = 496,
     ROA_CHECK = 497,
     EMPTY = 498,
     WHERE = 499,
     BFD = 500,
     MIN = 501,
     IDLE = 502,
     RX = 503,
     TX = 504,
     INTERVAL = 505,
     MULTIPLIER = 506,
     MULTIHOP = 507,
     NEIGHBOR = 508,
     DEV = 509,
     LOCAL = 510,
     AUTHENTICATION = 511,
     SIMPLE = 512,
     METICULOUS = 513,
     SESSIONS = 514,
     HOLD = 515,
     CONNECT = 516,
     RETRY = 517,
     KEEPALIVE = 518,
     STARTUP = 519,
     VIA = 520,
     NEXT = 521,
     HOP = 522,
     SELF = 523,
     DEFAULT = 524,
     PATH = 525,
     START = 526,
     DELAY = 527,
     FORGET = 528,
     AFTER = 529,
     BGP_PATH = 530,
     BGP_LOCAL_PREF = 531,
     BGP_MED = 532,
     BGP_ORIGIN = 533,
     BGP_NEXT_HOP = 534,
     BGP_ATOMIC_AGGR = 535,
     BGP_AGGREGATOR = 536,
     BGP_COMMUNITY = 537,
     BGP_EXT_COMMUNITY = 538,
     RR = 539,
     RS = 540,
     CLIENT = 541,
     CLUSTER = 542,
     AS4 = 543,
     ADVERTISE = 544,
     IPV4 = 545,
     CAPABILITIES = 546,
     PREFER = 547,
     OLDER = 548,
     MISSING = 549,
     LLADDR = 550,
     DROP = 551,
     IGNORE = 552,
     REFRESH = 553,
     INTERPRET = 554,
     COMMUNITIES = 555,
     BGP_ORIGINATOR_ID = 556,
     BGP_CLUSTER_LIST = 557,
     IGP = 558,
     GATEWAY = 559,
     RECURSIVE = 560,
     MED = 561,
     TTL = 562,
     SECURITY = 563,
     DETERMINISTIC = 564,
     SECONDARY = 565,
     ALLOW = 566,
     AWARE = 567,
     LINK = 568,
     EXTENDED = 569,
     SETKEY = 570,
     BGP_LARGE_COMMUNITY = 571,
     OSPF = 572,
     AREA = 573,
     OSPF_METRIC1 = 574,
     OSPF_METRIC2 = 575,
     OSPF_TAG = 576,
     OSPF_ROUTER_ID = 577,
     RFC1583COMPAT = 578,
     STUB = 579,
     TICK = 580,
     COST = 581,
     COST2 = 582,
     RETRANSMIT = 583,
     HELLO = 584,
     TRANSMIT = 585,
     PRIORITY = 586,
     DEAD = 587,
     TYPE = 588,
     BROADCAST = 589,
     BCAST = 590,
     NONBROADCAST = 591,
     NBMA = 592,
     POINTOPOINT = 593,
     PTP = 594,
     POINTOMULTIPOINT = 595,
     PTMP = 596,
     STRICT = 597,
     CRYPTOGRAPHIC = 598,
     ELIGIBLE = 599,
     POLL = 600,
     NETWORKS = 601,
     HIDDEN = 602,
     VIRTUAL = 603,
     ONLY = 604,
     BUFFER = 605,
     LARGE = 606,
     NORMAL = 607,
     STUBNET = 608,
     TAG = 609,
     EXTERNAL = 610,
     LSADB = 611,
     ECMP = 612,
     WEIGHT = 613,
     NSSA = 614,
     TRANSLATOR = 615,
     STABILITY = 616,
     GLOBAL = 617,
     LSID = 618,
     INSTANCE = 619,
     REAL = 620,
     NETMASK = 621,
     LENGTH = 622,
     LSA = 623,
     SUPPRESSION = 624,
     TOPOLOGY = 625,
     STATE = 626,
     PIPE = 627,
     PEER = 628,
     MODE = 629,
     OPAQUE = 630,
     TRANSPARENT = 631,
     RIP = 632,
     INFINITY = 633,
     UPDATE = 634,
     GARBAGE = 635,
     MULTICAST = 636,
     VERSION = 637,
     SPLIT = 638,
     HORIZON = 639,
     POISON = 640,
     REVERSE = 641,
     ZERO = 642,
     PLAINTEXT = 643,
     RIP_METRIC = 644,
     RIP_TAG = 645,
     STATIC = 646,
     PROHIBIT = 647,
     MULTIPATH = 648,
     BLACKHOLE = 649,
     UNREACHABLE = 650
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 614 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 1152 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1180 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  71
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3434

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  417
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  279
/* YYNRULES -- Number of rules.  */
#define YYNRULES  977
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1848

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   650

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     408,   409,    29,    27,   413,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   410,   407,
      23,    22,    24,   414,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   415,     2,   416,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   411,     2,   412,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    30,    33,    36,    38,    40,    42,    44,    46,    47,
      49,    51,    52,    55,    58,    60,    62,    65,    68,    70,
      72,    74,    76,    77,    82,    85,    86,    88,    91,    93,
      95,    99,   101,   105,   107,   109,   111,   113,   115,   117,
     119,   121,   123,   128,   132,   136,   138,   140,   142,   144,
     147,   152,   156,   160,   164,   168,   172,   176,   181,   185,
     189,   194,   200,   204,   208,   213,   216,   217,   219,   220,
     222,   225,   228,   229,   232,   235,   239,   242,   246,   250,
     255,   258,   262,   266,   270,   273,   278,   284,   286,   290,
     292,   294,   296,   301,   302,   305,   308,   311,   313,   315,
     321,   322,   324,   328,   332,   333,   342,   344,   349,   351,
     353,   354,   356,   359,   363,   364,   367,   370,   373,   376,
     379,   382,   386,   390,   394,   399,   402,   406,   409,   412,
     414,   416,   418,   419,   422,   425,   428,   431,   434,   436,
     438,   442,   446,   447,   449,   451,   454,   455,   457,   461,
     463,   467,   469,   470,   473,   476,   479,   482,   486,   490,
     494,   500,   501,   505,   507,   509,   513,   515,   519,   521,
     523,   525,   527,   529,   531,   533,   535,   539,   541,   545,
     547,   549,   550,   555,   558,   560,   563,   564,   567,   571,
     573,   575,   578,   581,   584,   586,   591,   593,   594,   598,
     603,   605,   608,   609,   615,   621,   627,   633,   638,   643,
     648,   653,   656,   659,   662,   665,   668,   671,   674,   677,
     680,   683,   687,   691,   696,   702,   704,   705,   709,   714,
     719,   720,   723,   727,   731,   735,   738,   741,   744,   747,
     751,   755,   758,   761,   763,   765,   767,   772,   773,   777,
     781,   785,   786,   788,   790,   795,   796,   799,   802,   805,
     808,   811,   814,   817,   818,   821,   831,   841,   846,   850,
     854,   858,   862,   866,   870,   874,   878,   882,   887,   889,
     891,   895,   896,   898,   902,   906,   910,   914,   919,   924,
     929,   934,   939,   942,   943,   945,   948,   951,   954,   956,
     959,   961,   963,   965,   967,   968,   970,   971,   976,   979,
     981,   983,   985,   987,   989,   991,   993,   995,   997,   999,
    1001,  1003,  1005,  1007,  1010,  1013,  1014,  1018,  1020,  1024,
    1026,  1028,  1030,  1033,  1037,  1040,  1045,  1046,  1052,  1053,
    1055,  1057,  1060,  1062,  1066,  1068,  1070,  1072,  1074,  1076,
    1080,  1082,  1084,  1088,  1090,  1092,  1094,  1096,  1102,  1110,
    1116,  1124,  1134,  1142,  1148,  1156,  1162,  1174,  1176,  1178,
    1181,  1183,  1191,  1201,  1209,  1217,  1227,  1235,  1245,  1253,
    1263,  1271,  1287,  1289,  1291,  1293,  1295,  1299,  1301,  1303,
    1305,  1307,  1311,  1313,  1317,  1319,  1323,  1327,  1329,  1332,
    1335,  1342,  1344,  1348,  1349,  1354,  1358,  1360,  1364,  1368,
    1372,  1375,  1380,  1383,  1386,  1389,  1390,  1393,  1396,  1397,
    1399,  1401,  1403,  1405,  1407,  1409,  1411,  1415,  1419,  1421,
    1423,  1429,  1437,  1445,  1446,  1451,  1453,  1455,  1457,  1459,
    1461,  1463,  1465,  1467,  1469,  1471,  1473,  1477,  1481,  1485,
    1489,  1493,  1497,  1501,  1505,  1509,  1513,  1517,  1521,  1525,
    1529,  1533,  1536,  1541,  1543,  1545,  1547,  1549,  1552,  1555,
    1559,  1563,  1570,  1574,  1578,  1582,  1586,  1590,  1596,  1604,
    1611,  1618,  1625,  1632,  1637,  1646,  1651,  1653,  1655,  1657,
    1659,  1661,  1663,  1665,  1666,  1668,  1672,  1674,  1678,  1679,
    1681,  1686,  1693,  1698,  1702,  1708,  1714,  1719,  1726,  1730,
    1733,  1739,  1745,  1754,  1763,  1772,  1781,  1784,  1786,  1789,
    1792,  1795,  1796,  1800,  1806,  1807,  1808,  1811,  1816,  1821,
    1826,  1829,  1832,  1835,  1837,  1839,  1841,  1844,  1847,  1851,
    1855,  1856,  1860,  1861,  1865,  1870,  1874,  1875,  1878,  1881,
    1882,  1885,  1886,  1889,  1894,  1900,  1903,  1904,  1908,  1912,
    1916,  1920,  1926,  1933,  1938,  1945,  1950,  1957,  1962,  1967,
    1973,  1980,  1984,  1988,  1993,  1999,  2005,  2011,  2017,  2023,
    2028,  2033,  2039,  2045,  2051,  2057,  2063,  2069,  2075,  2081,
    2088,  2095,  2102,  2108,  2115,  2124,  2131,  2138,  2144,  2151,
    2156,  2162,  2167,  2172,  2178,  2183,  2189,  2194,  2200,  2206,
    2212,  2218,  2225,  2231,  2237,  2244,  2250,  2256,  2262,  2267,
    2270,  2274,  2278,  2280,  2283,  2287,  2290,  2295,  2299,  2302,
    2306,  2308,  2311,  2316,  2317,  2321,  2324,  2326,  2329,  2333,
    2337,  2341,  2345,  2348,  2352,  2353,  2359,  2360,  2366,  2369,
    2372,  2374,  2379,  2381,  2383,  2384,  2388,  2391,  2394,  2397,
    2403,  2406,  2407,  2411,  2412,  2415,  2418,  2422,  2425,  2428,
    2432,  2435,  2438,  2441,  2443,  2447,  2450,  2453,  2456,  2459,
    2462,  2465,  2469,  2472,  2475,  2478,  2481,  2484,  2487,  2490,
    2493,  2497,  2501,  2505,  2508,  2512,  2515,  2519,  2523,  2528,
    2533,  2536,  2539,  2542,  2546,  2550,  2554,  2557,  2561,  2565,
    2569,  2574,  2577,  2580,  2582,  2583,  2586,  2590,  2592,  2593,
    2595,  2598,  2599,  2602,  2603,  2605,  2609,  2610,  2611,  2614,
    2615,  2619,  2620,  2624,  2625,  2629,  2633,  2635,  2636,  2641,
    2648,  2655,  2662,  2670,  2677,  2685,  2691,  2692,  2695,  2699,
    2702,  2706,  2710,  2713,  2717,  2720,  2723,  2727,  2731,  2737,
    2742,  2747,  2750,  2752,  2755,  2760,  2763,  2766,  2767,  2771,
    2777,  2778,  2779,  2782,  2785,  2788,  2791,  2794,  2797,  2800,
    2804,  2808,  2812,  2816,  2820,  2824,  2828,  2832,  2836,  2840,
    2843,  2847,  2851,  2856,  2860,  2863,  2866,  2868,  2870,  2872,
    2874,  2876,  2877,  2881,  2882,  2886,  2891,  2898,  2905,  2908,
    2912,  2916,  2922,  2928,  2933,  2936,  2940,  2944,  2948,  2950,
    2953,  2958,  2962,  2966,  2970,  2973,  2976,  2979,  2982,  2985,
    2987,  2991,  2992,  2995,  2996,  3000,  3005,  3007,  3009,  3011,
    3013,  3015,  3017,  3019,  3021,  3023,  3025,  3027,  3029,  3031,
    3033,  3035,  3037,  3039,  3041,  3043,  3045,  3047,  3049,  3051,
    3053,  3055,  3057,  3059,  3061,  3063,  3065,  3067,  3069,  3071,
    3073,  3075,  3077,  3079,  3081,  3083,  3085,  3087,  3089,  3091,
    3093,  3095,  3097,  3099,  3101,  3103,  3105,  3107,  3109,  3111,
    3113,  3115,  3117,  3119,  3121,  3123,  3125,  3127,  3129,  3131,
    3133,  3135,  3137,  3140,  3143,  3146,  3148,  3151,  3154,  3157,
    3159,  3162,  3166,  3170,  3174,  3178,  3182,  3186,  3190,  3192,
    3194,  3196,  3198,  3200,  3202,  3204,  3206,  3208,  3210,  3212,
    3214,  3216,  3218,  3220,  3222,  3224,  3226,  3228,  3230,  3232,
    3234,  3236,  3238,  3240,  3242,  3244,  3246,  3248,  3250,  3252,
    3254,  3256,  3258,  3260,  3262,  3264,  3266,  3268,  3270,  3272,
    3274,  3276,  3278,  3280,  3282,  3284,  3286,  3288
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     418,     0,    -1,   419,     3,    -1,     4,   691,    -1,    -1,
     419,   690,    -1,    34,    19,    22,   596,   407,    -1,    15,
      -1,   408,   596,   409,    -1,    19,    -1,   421,    39,    -1,
     421,    40,    -1,   421,    41,    -1,   421,    -1,    35,    -1,
      37,    -1,    36,    -1,    38,    -1,    -1,    18,    -1,    19,
      -1,    -1,    31,    19,    -1,   424,   428,    -1,   426,    -1,
     424,    -1,    30,   421,    -1,   410,   424,    -1,    20,    -1,
      20,    -1,    19,    -1,    20,    -1,    -1,    43,   434,   435,
     407,    -1,    63,   430,    -1,    -1,   430,    -1,    44,   433,
      -1,    55,    -1,    45,    -1,   411,   436,   412,    -1,   437,
      -1,   436,   413,   437,    -1,    46,    -1,    47,    -1,    48,
      -1,    49,    -1,    50,    -1,    51,    -1,    52,    -1,    53,
      -1,    54,    -1,   173,   143,   492,   407,    -1,   173,    79,
     496,    -1,   173,   430,   407,    -1,   189,    -1,   118,    -1,
      62,    -1,    43,    -1,   439,    20,    -1,   439,    20,   421,
      20,    -1,   439,    58,    60,    -1,   439,    58,    61,    -1,
     439,    59,    60,    -1,   439,    59,    61,    -1,    57,   440,
     407,    -1,    46,    68,   423,    -1,    46,    68,    69,   422,
      -1,    70,    50,   422,    -1,    70,    67,   422,    -1,    71,
     449,   450,     3,    -1,    71,    56,   449,   450,     3,    -1,
      71,    64,     3,    -1,    71,    65,     3,    -1,    71,    66,
     449,     3,    -1,    72,     3,    -1,    -1,    20,    -1,    -1,
      67,    -1,    67,   421,    -1,   468,    73,    -1,    -1,    69,
     421,    -1,    74,   423,    -1,    75,    76,   421,    -1,    77,
     423,    -1,    78,    79,   423,    -1,    80,    81,   423,    -1,
      84,    85,   423,   452,    -1,   468,    78,    -1,    75,    76,
     421,    -1,   153,   431,   427,    -1,    73,    86,   421,    -1,
      87,   421,    -1,   116,   117,   458,   407,    -1,   116,   117,
     138,   483,   407,    -1,    15,    -1,   408,   596,   409,    -1,
      17,    -1,    18,    -1,    19,    -1,   162,   163,   460,   407,
      -1,    -1,   460,   461,    -1,   166,   424,    -1,    42,   421,
      -1,   164,    -1,   165,    -1,    80,    81,   180,   421,   407,
      -1,    -1,   169,    -1,    86,    19,   463,    -1,   161,    86,
      19,    -1,    -1,   466,   161,   426,   181,    15,   183,    15,
     407,    -1,   465,    -1,   465,   411,   466,   412,    -1,   118,
      -1,   119,    -1,    -1,    19,    -1,   138,    19,    -1,    19,
     138,    19,    -1,    -1,   120,   421,    -1,   121,   423,    -1,
      46,   489,    -1,   173,   492,    -1,   124,   471,    -1,   125,
     471,    -1,   130,    69,   473,    -1,   124,    69,   473,    -1,
     125,    69,   473,    -1,   124,   135,   136,   423,    -1,    86,
     474,    -1,   116,   117,   458,    -1,   168,   430,    -1,   126,
     561,    -1,   562,    -1,    45,    -1,   127,    -1,    -1,   131,
     132,    -1,   131,   133,    -1,   131,    81,    -1,   131,   134,
      -1,   421,   472,    -1,    36,    -1,    19,    -1,    46,   143,
     489,    -1,    46,   157,   421,    -1,    -1,    20,    -1,   427,
      -1,    20,   427,    -1,    -1,    28,    -1,   476,   478,   477,
      -1,   479,    -1,   480,   413,   479,    -1,   480,    -1,    -1,
     482,   480,    -1,   178,   421,    -1,   179,   421,    -1,   468,
     122,    -1,   485,   469,   411,    -1,   486,   470,   407,    -1,
     486,   488,   407,    -1,   486,    66,   324,   423,   407,    -1,
      -1,   123,   487,   480,    -1,    45,    -1,    36,    -1,   411,
     490,   412,    -1,   491,    -1,   490,   413,   491,    -1,   128,
      -1,    79,    -1,   129,    -1,   144,    -1,   141,    -1,   142,
      -1,    45,    -1,    36,    -1,   411,   493,   412,    -1,   494,
      -1,   493,   413,   494,    -1,   128,    -1,   174,    -1,    -1,
     411,   495,   498,   412,    -1,   495,   407,    -1,   562,    -1,
     126,   561,    -1,    -1,   500,   407,    -1,   498,   500,   407,
      -1,   474,    -1,    20,    -1,   184,   421,    -1,   185,   430,
      -1,    86,   499,    -1,   497,    -1,   167,   411,   502,   412,
      -1,   503,    -1,    -1,   503,   407,   502,    -1,   504,   411,
     505,   412,    -1,   504,    -1,   137,   430,    -1,    -1,   160,
     138,   429,   407,   505,    -1,   160,   140,   429,   407,   505,
      -1,   206,   138,   429,   407,   505,    -1,   206,   140,   429,
     407,   505,    -1,   138,   429,   407,   505,    -1,   140,   429,
     407,   505,    -1,   117,   421,   407,   505,    -1,   145,   506,
     407,   505,    -1,   146,   148,    -1,   146,   149,    -1,   146,
     150,    -1,   146,   151,    -1,   146,   152,    -1,   147,   148,
      -1,   147,   149,    -1,   147,   150,    -1,   147,   151,    -1,
     147,   152,    -1,   186,   187,     3,    -1,   186,   176,     3,
      -1,   186,   143,   552,     3,    -1,   186,   143,    45,   552,
       3,    -1,    19,    -1,    -1,   186,   144,     3,    -1,   186,
     144,   188,     3,    -1,   186,   189,   515,     3,    -1,    -1,
     515,   426,    -1,   515,   156,   427,    -1,   515,    86,    19,
      -1,   515,   126,   561,    -1,   515,   562,    -1,   515,    45,
      -1,   515,   153,    -1,   515,   136,    -1,   515,   516,    19,
      -1,   515,   118,    19,    -1,   515,   154,    -1,   515,   155,
      -1,   158,    -1,   125,    -1,   159,    -1,   186,   161,   518,
       3,    -1,    -1,   518,   519,   426,    -1,   518,   183,    15,
      -1,   518,    86,    19,    -1,    -1,   171,    -1,   156,    -1,
     186,   190,   521,     3,    -1,    -1,   521,    86,    -1,   521,
     201,    -1,   521,   126,    -1,   521,   118,    -1,   521,   119,
      -1,   521,   161,    -1,   521,    19,    -1,    -1,    86,    19,
      -1,   191,   161,   426,   181,    15,   183,    15,   522,     3,
      -1,   192,   161,   426,   181,    15,   183,    15,   522,     3,
      -1,   182,   161,   522,     3,    -1,   193,   194,     3,    -1,
     193,   195,     3,    -1,   193,   141,     3,    -1,   193,   144,
       3,    -1,   193,   196,     3,    -1,   193,   197,     3,    -1,
     193,    79,     3,    -1,   193,   143,     3,    -1,   198,   596,
       3,    -1,   199,   536,   537,     3,    -1,    45,    -1,    36,
      -1,   411,   436,   412,    -1,    -1,    15,    -1,   134,   551,
       3,    -1,   200,   551,     3,    -1,    81,   551,     3,    -1,
     170,   551,     3,    -1,   170,   171,   551,     3,    -1,   170,
     172,   551,     3,    -1,    46,   551,   489,     3,    -1,   173,
     551,   492,     3,    -1,   173,    79,   547,     3,    -1,   495,
     548,    -1,    -1,   549,    -1,   548,   549,    -1,    86,   499,
      -1,   140,   430,    -1,   497,    -1,   175,     3,    -1,    19,
      -1,    45,    -1,    20,    -1,    19,    -1,    -1,    20,    -1,
      -1,   126,    19,   554,   560,    -1,   198,   596,    -1,   209,
      -1,   210,    -1,   211,    -1,   212,    -1,   213,    -1,   214,
      -1,   215,    -1,   216,    -1,   218,    -1,   219,    -1,   220,
      -1,   221,    -1,   222,    -1,   223,    -1,   556,   217,    -1,
     556,    19,    -1,    -1,   557,   407,   558,    -1,   557,    -1,
     557,   407,   559,    -1,   564,    -1,    19,    -1,   560,    -1,
     255,   596,    -1,   408,   559,   409,    -1,   408,   409,    -1,
     558,   411,   567,   412,    -1,    -1,   201,    19,   566,   563,
     564,    -1,    -1,   568,    -1,   602,    -1,   568,   602,    -1,
     602,    -1,   411,   567,   412,    -1,    18,    -1,    15,    -1,
      17,    -1,   570,    -1,    16,    -1,   408,   596,   409,    -1,
      19,    -1,    15,    -1,   408,   596,   409,    -1,    17,    -1,
     570,    -1,    16,    -1,   596,    -1,   408,   573,   413,   573,
     409,    -1,   408,   573,   413,   573,     7,   573,   409,    -1,
     408,   573,   413,    29,   409,    -1,   408,   573,     7,   573,
     413,   573,   409,    -1,   408,   573,     7,   573,   413,   573,
       7,   573,   409,    -1,   408,   573,     7,   573,   413,    29,
     409,    -1,   408,    29,   413,   573,   409,    -1,   408,    29,
     413,   573,     7,   573,   409,    -1,   408,    29,   413,    29,
     409,    -1,   408,   573,   413,   573,   409,     7,   408,   573,
     413,   573,   409,    -1,   230,    -1,   231,    -1,   232,    15,
      -1,   233,    -1,   408,   575,   413,   573,   413,   573,   409,
      -1,   408,   575,   413,   573,   413,   573,     7,   573,   409,
      -1,   408,   575,   413,   573,   413,    29,   409,    -1,   408,
     573,   413,   573,   413,   573,   409,    -1,   408,   573,   413,
     573,   413,   573,     7,   573,   409,    -1,   408,   573,   413,
     573,   413,    29,   409,    -1,   408,   573,   413,   573,     7,
     573,   413,    29,   409,    -1,   408,   573,   413,    29,   413,
      29,   409,    -1,   408,   573,     7,   573,   413,    29,   413,
      29,   409,    -1,   408,    29,   413,    29,   413,    29,   409,
      -1,   408,   573,   413,   573,   413,   573,   409,     7,   408,
     573,   413,   573,   413,   573,   409,    -1,   574,    -1,   576,
      -1,   577,    -1,   571,    -1,   571,     7,   571,    -1,   574,
      -1,   576,    -1,   577,    -1,   572,    -1,   572,     7,   572,
      -1,   578,    -1,   580,   413,   578,    -1,   579,    -1,   581,
     413,   579,    -1,    18,    30,    15,    -1,   582,    -1,   582,
      27,    -1,   582,    28,    -1,   582,   411,    15,   413,    15,
     412,    -1,   583,    -1,   584,   413,   583,    -1,    -1,   585,
     581,   410,   567,    -1,   585,     6,   567,    -1,   594,    -1,
     408,   596,   409,    -1,    13,   588,    14,    -1,    30,   589,
      30,    -1,    15,   588,    -1,    15,     7,    15,   588,    -1,
      29,   588,    -1,   414,   588,    -1,   586,   588,    -1,    -1,
      15,   589,    -1,   414,   589,    -1,    -1,    15,    -1,   228,
      -1,   229,    -1,    20,    -1,   570,    -1,   582,    -1,    17,
      -1,   415,   580,   416,    -1,   415,   584,   416,    -1,    16,
      -1,   587,    -1,   408,   596,   413,   596,   409,    -1,   408,
     575,   413,   596,   413,   596,   409,    -1,   408,   596,   413,
     596,   413,   596,   409,    -1,    -1,    19,   408,   601,   409,
      -1,    19,    -1,   138,    -1,   234,    -1,   235,    -1,   237,
      -1,   238,    -1,   239,    -1,   240,    -1,   241,    -1,   242,
      -1,   243,    -1,   408,   596,   409,    -1,   596,    27,   596,
      -1,   596,    28,   596,    -1,   596,    29,   596,    -1,   596,
      30,   596,    -1,   596,    11,   596,    -1,   596,    12,   596,
      -1,   596,    22,   596,    -1,   596,    10,   596,    -1,   596,
      23,   596,    -1,   596,     9,   596,    -1,   596,    24,   596,
      -1,   596,     8,   596,    -1,   596,    25,   596,    -1,   596,
      26,   596,    -1,    32,   596,    -1,   245,   408,   596,   409,
      -1,   594,    -1,   590,    -1,   591,    -1,   120,    -1,   592,
     595,    -1,   592,   695,    -1,   596,    33,   211,    -1,   596,
      33,   244,    -1,   596,    33,   236,   408,   596,   409,    -1,
     596,    33,   249,    -1,   596,    33,   250,    -1,   596,    33,
     251,    -1,    27,   254,    27,    -1,    28,   254,    28,    -1,
      28,    28,   254,    28,    28,    -1,    28,    28,    28,   254,
      28,    28,    28,    -1,   248,   408,   596,   413,   596,   409,
      -1,   191,   408,   596,   413,   596,   409,    -1,   192,   408,
     596,   413,   596,   409,    -1,   126,   408,   596,   413,   596,
     409,    -1,   253,   408,    19,   409,    -1,   253,   408,    19,
     413,   596,   413,   596,   409,    -1,    19,   408,   601,   409,
      -1,   208,    -1,   206,    -1,   207,    -1,    51,    -1,   202,
      -1,   203,    -1,   596,    -1,    -1,   598,    -1,   598,   413,
     599,    -1,   596,    -1,   596,   413,   600,    -1,    -1,   600,
      -1,   224,   596,   225,   569,    -1,   224,   596,   225,   569,
     226,   569,    -1,    19,    22,   596,   407,    -1,   205,   596,
     407,    -1,   592,   695,    22,   596,   407,    -1,   592,   595,
      22,   596,   407,    -1,   120,    22,   596,   407,    -1,   204,
     408,   592,   695,   409,   407,    -1,   597,   599,   407,    -1,
     593,   407,    -1,   227,   596,   411,   585,   412,    -1,   592,
     695,    33,   254,   407,    -1,   592,   695,    33,   248,   408,
     596,   409,   407,    -1,   592,   695,    33,   191,   408,   596,
     409,   407,    -1,   592,   695,    33,   192,   408,   596,   409,
     407,    -1,   592,   695,    33,   126,   408,   596,   409,   407,
      -1,   468,   256,    -1,   470,    -1,   123,   613,    -1,   263,
     614,    -1,   264,   618,    -1,    -1,   605,   604,   407,    -1,
     603,   469,   411,   605,   412,    -1,    -1,    -1,   261,   422,
      -1,   257,   259,   261,   422,    -1,   257,   260,   261,   422,
      -1,   258,   260,   261,   422,    -1,   262,   421,    -1,   139,
     423,    -1,   267,   610,    -1,   501,    -1,   127,    -1,   268,
      -1,   146,   148,    -1,   146,   149,    -1,   269,   146,   148,
      -1,   269,   146,   149,    -1,    -1,   611,   609,   407,    -1,
      -1,   411,   611,   412,    -1,   607,   481,   612,   608,    -1,
     607,   612,   608,    -1,    -1,    31,    19,    -1,   265,   430,
      -1,    -1,   266,   424,    -1,    -1,   263,   423,    -1,   424,
     615,   616,   617,    -1,   186,   256,   270,   511,     3,    -1,
     468,   163,    -1,    -1,   621,    42,   421,    -1,   621,   183,
     421,    -1,   620,   469,   411,    -1,   622,   470,   407,    -1,
     622,   266,   183,   421,   407,    -1,   622,   266,   424,   183,
     421,   407,    -1,   622,   264,   621,   407,    -1,   622,   264,
     424,   425,   621,   407,    -1,   622,   123,    20,   407,    -1,
     622,   295,   298,   117,   458,   407,    -1,   622,   295,   297,
     407,    -1,   622,   296,   297,   407,    -1,   622,   271,    76,
     421,   407,    -1,   622,   275,   271,    76,   421,   407,    -1,
     622,   122,   407,    -1,   622,   263,   407,    -1,   622,   263,
     421,   407,    -1,   622,   277,   278,   279,   407,    -1,   622,
     277,   278,   135,   407,    -1,   622,   305,   306,   279,   407,
      -1,   622,   305,   306,   307,   407,    -1,   622,   305,   306,
     308,   407,    -1,   622,   315,   122,   407,    -1,   622,   315,
     316,   407,    -1,   622,   281,    87,   423,   407,    -1,   622,
     317,    87,   423,   407,    -1,   622,   314,    87,   423,   407,
      -1,   622,   303,   304,   423,   407,    -1,   622,   320,   317,
     423,   407,    -1,   622,   280,   288,   421,   407,    -1,   622,
     280,   287,   421,   407,    -1,   622,   238,   166,   424,   407,
      -1,   622,   282,   283,    76,   421,   407,    -1,   622,   272,
     283,    76,   421,   407,    -1,   622,   272,   273,    76,   421,
     407,    -1,   622,   274,    76,   421,   407,    -1,   622,    51,
     284,    76,   421,   407,    -1,   622,    51,   180,    76,   421,
     413,   421,   407,    -1,   622,   134,   285,    51,   423,   407,
      -1,   622,   200,   189,   309,   423,   407,    -1,   622,   200,
     299,   423,   407,    -1,   622,   200,   325,   174,   423,   407,
      -1,   622,   302,   423,   407,    -1,   622,   300,   301,   423,
     407,    -1,   622,   137,   430,   407,    -1,   622,   326,   423,
     407,    -1,   622,   189,    69,   421,   407,    -1,   622,   139,
     423,   407,    -1,   622,   310,   311,   423,   407,    -1,   622,
     321,   423,   407,    -1,   622,   191,    85,   259,   407,    -1,
     622,   191,    85,   260,   407,    -1,   622,   191,    85,   423,
     407,    -1,   622,   322,   266,   183,   407,    -1,   622,   322,
     266,   183,   421,   407,    -1,   622,    80,    81,   423,   407,
      -1,   622,    80,    81,   323,   407,    -1,   622,    80,    81,
      76,   421,   407,    -1,   622,   314,    86,   474,   407,    -1,
     622,   318,   319,   423,   407,    -1,   622,    66,   324,   423,
     407,    -1,   622,   256,   423,   407,    -1,   468,   328,    -1,
     623,   469,   411,    -1,   624,   625,   407,    -1,   470,    -1,
     334,   423,    -1,   335,   116,   423,    -1,   368,   423,    -1,
     368,   423,    69,   421,    -1,    84,   366,   423,    -1,   336,
     421,    -1,   375,   117,   421,    -1,   627,    -1,   329,   458,
      -1,   626,   411,   628,   412,    -1,    -1,   628,   629,   407,
      -1,   335,   423,    -1,   370,    -1,   188,   423,    -1,   280,
     370,   423,    -1,   280,   337,   421,    -1,   280,   338,   421,
      -1,   335,   337,   421,    -1,   371,   423,    -1,   371,   372,
     421,    -1,    -1,   357,   630,   411,   641,   412,    -1,    -1,
     366,   631,   411,   641,   412,    -1,   364,   632,    -1,   123,
     654,    -1,   636,    -1,   633,   411,   634,   412,    -1,   633,
      -1,   426,    -1,    -1,   634,   635,   407,    -1,   358,   423,
      -1,   188,   423,    -1,   337,   421,    -1,   639,   649,   411,
     637,   412,    -1,   639,   649,    -1,    -1,   637,   638,   407,
      -1,    -1,   340,   421,    -1,   339,   421,    -1,   341,   283,
     421,    -1,   180,   421,    -1,   343,   421,    -1,   343,   155,
     421,    -1,   267,   127,    -1,   267,   268,    -1,   267,   354,
      -1,   501,    -1,   359,   324,   458,    -1,   337,   421,    -1,
     340,   421,    -1,   356,   421,    -1,   339,   421,    -1,   180,
     421,    -1,   343,   421,    -1,   343,   155,   421,    -1,   344,
     345,    -1,   344,   346,    -1,   344,   347,    -1,   344,   348,
      -1,   344,   349,    -1,   344,   350,    -1,   344,   351,    -1,
     344,   352,    -1,   376,   345,   423,    -1,   350,   377,   423,
      -1,   341,   283,   421,    -1,   342,   421,    -1,   353,   347,
     423,    -1,   335,   423,    -1,    66,   324,   423,    -1,   368,
     369,   421,    -1,   324,   379,   380,   423,    -1,   196,   411,
     645,   412,    -1,   267,   127,    -1,   267,   268,    -1,   267,
     354,    -1,   259,   361,   363,    -1,   259,   361,   362,    -1,
     259,   361,   421,    -1,   260,   484,    -1,   260,   342,   421,
      -1,   260,   378,   421,    -1,   318,   319,   423,    -1,   318,
     319,   260,   360,    -1,   256,   423,    -1,   321,   423,    -1,
     501,    -1,    -1,   641,   642,    -1,   643,   644,   407,    -1,
     426,    -1,    -1,   358,    -1,   365,   421,    -1,    -1,   645,
     647,    -1,    -1,   355,    -1,   424,   646,   407,    -1,    -1,
      -1,   375,   421,    -1,    -1,   480,   651,   649,    -1,    -1,
     652,   640,   407,    -1,    -1,   411,   652,   412,    -1,   648,
     650,   653,    -1,    20,    -1,    -1,   186,   328,   511,     3,
      -1,   186,   328,   196,   511,   655,     3,    -1,   186,   328,
     123,   511,   655,     3,    -1,   186,   328,   381,   511,   655,
       3,    -1,   186,   328,   381,    45,   511,   655,     3,    -1,
     186,   328,   382,   511,   655,     3,    -1,   186,   328,   382,
      45,   511,   655,     3,    -1,   186,   328,   367,   664,     3,
      -1,    -1,   664,   373,    -1,   664,   329,   458,    -1,   664,
     324,    -1,   664,   344,    15,    -1,   664,   374,   458,    -1,
     664,   279,    -1,   664,   116,   458,    -1,   664,    19,    -1,
     468,   383,    -1,   665,   469,   411,    -1,   666,   470,   407,
      -1,   666,   384,    86,    19,   407,    -1,   666,   385,   386,
     407,    -1,   666,   385,   387,   407,    -1,   468,   388,    -1,
     470,    -1,   368,   423,    -1,   368,   423,    69,   421,    -1,
     389,   421,    -1,   123,   677,    -1,    -1,   669,   668,   407,
      -1,   667,   469,   411,   669,   412,    -1,    -1,    -1,    87,
     421,    -1,   385,   392,    -1,   385,   345,    -1,   139,   423,
      -1,   166,   424,    -1,    42,   421,    -1,   393,   421,    -1,
     393,   360,   423,    -1,   394,   395,   423,    -1,   396,   397,
     423,    -1,    66,   398,   423,    -1,   390,    76,   421,    -1,
      67,    76,   421,    -1,   391,    76,   421,    -1,   368,   369,
     421,    -1,   259,   361,   421,    -1,   260,   378,   421,    -1,
     260,   484,    -1,   260,   342,   421,    -1,   318,   319,   423,
      -1,   318,   319,   260,   360,    -1,    66,   324,   423,    -1,
     256,   423,    -1,   267,   674,    -1,   501,    -1,   127,    -1,
     399,    -1,   354,    -1,   148,    -1,    -1,   675,   673,   407,
      -1,    -1,   411,   675,   412,    -1,   671,   481,   676,   672,
      -1,   186,   388,   144,   511,   655,     3,    -1,   186,   388,
     196,   511,   655,     3,    -1,   468,   402,    -1,   680,   469,
     411,    -1,   681,   470,   407,    -1,   681,    66,   324,   423,
     407,    -1,   681,   314,    86,   474,   407,    -1,   681,   685,
     688,   407,    -1,   189,   426,    -1,   276,   424,   425,    -1,
     683,   369,   421,    -1,   683,   256,   423,    -1,   683,    -1,
     684,   683,    -1,   682,   276,   424,   425,    -1,   682,   276,
      20,    -1,   682,   404,   684,    -1,   682,   316,   424,    -1,
     682,   307,    -1,   682,   207,    -1,   682,   405,    -1,   682,
     406,    -1,   682,   403,    -1,   602,    -1,   256,   423,   407,
      -1,    -1,   687,   686,    -1,    -1,   411,   687,   412,    -1,
     186,   402,   511,     3,    -1,   407,    -1,   420,    -1,   432,
      -1,   438,    -1,   441,    -1,   442,    -1,   457,    -1,   459,
      -1,   462,    -1,   464,    -1,   467,    -1,   692,    -1,   475,
      -1,   553,    -1,   555,    -1,   565,    -1,   443,    -1,   444,
      -1,   445,    -1,   446,    -1,   447,    -1,   448,    -1,   507,
      -1,   508,    -1,   509,    -1,   510,    -1,   512,    -1,   513,
      -1,   514,    -1,   517,    -1,   520,    -1,   523,    -1,   524,
      -1,   525,    -1,   526,    -1,   527,    -1,   528,    -1,   529,
      -1,   530,    -1,   531,    -1,   532,    -1,   533,    -1,   534,
      -1,   535,    -1,   538,    -1,   539,    -1,   540,    -1,   541,
      -1,   542,    -1,   543,    -1,   544,    -1,   545,    -1,   546,
      -1,   550,    -1,   619,    -1,   656,    -1,   657,    -1,   658,
      -1,   659,    -1,   660,    -1,   661,    -1,   662,    -1,   663,
      -1,   678,    -1,   679,    -1,   689,    -1,   693,   412,    -1,
     694,   412,    -1,   486,   412,    -1,   606,    -1,   622,   412,
      -1,   624,   412,    -1,   666,   412,    -1,   670,    -1,   681,
     412,    -1,   451,   469,   411,    -1,   693,   470,   407,    -1,
     693,   453,   407,    -1,   693,   456,   407,    -1,   454,   469,
     411,    -1,   694,   470,   407,    -1,   694,   455,   407,    -1,
      82,    -1,    83,    -1,    88,    -1,    89,    -1,    90,    -1,
      91,    -1,    92,    -1,    93,    -1,    94,    -1,    95,    -1,
      96,    -1,    97,    -1,    98,    -1,    99,    -1,   100,    -1,
     101,    -1,   102,    -1,   103,    -1,   104,    -1,   105,    -1,
     106,    -1,   107,    -1,   108,    -1,   109,    -1,   110,    -1,
     111,    -1,   112,    -1,   113,    -1,   114,    -1,   115,    -1,
     177,    -1,     5,    -1,   289,    -1,   286,    -1,   290,    -1,
     288,    -1,   287,    -1,   291,    -1,   292,    -1,   293,    -1,
     312,    -1,   313,    -1,   294,    -1,   327,    -1,   330,    -1,
     331,    -1,   332,    -1,   333,    -1,   400,    -1,   401,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   808,   808,   809,   812,   814,   822,   831,   832,   833,
     840,   841,   842,   850,   851,   852,   853,   854,   855,   861,
     862,   869,   870,   874,   881,   882,   886,   890,   897,   905,
     906,   913,   914,   920,   929,   930,   934,   939,   940,   944,
     945,   949,   950,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   968,   969,   970,   979,   980,   981,   982,   985,
     986,   987,   988,   989,   990,   994,  1000,  1001,  1002,  1003,
    1011,  1014,  1021,  1024,  1027,  1030,  1034,  1035,  1039,  1040,
    1041,  1049,  1054,  1055,  1059,  1060,  1064,  1071,  1072,  1073,
    1085,  1090,  1094,  1108,  1109,  1123,  1124,  1128,  1129,  1130,
    1131,  1138,  1152,  1154,  1156,  1160,  1161,  1162,  1163,  1168,
    1174,  1175,  1179,  1187,  1191,  1193,  1199,  1200,  1207,  1208,
    1212,  1218,  1222,  1231,  1240,  1242,  1246,  1247,  1248,  1249,
    1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,  1261,  1262,
    1263,  1264,  1268,  1269,  1270,  1271,  1272,  1276,  1282,  1286,
    1294,  1295,  1303,  1311,  1312,  1313,  1317,  1318,  1322,  1327,
    1328,  1332,  1334,  1342,  1346,  1347,  1353,  1360,  1361,  1362,
    1363,  1367,  1375,  1381,  1382,  1383,  1387,  1388,  1392,  1393,
    1394,  1395,  1396,  1397,  1403,  1404,  1405,  1409,  1410,  1414,
    1415,  1421,  1427,  1428,  1432,  1437,  1444,  1446,  1447,  1451,
    1452,  1456,  1457,  1458,  1459,  1465,  1466,  1469,  1471,  1475,
    1476,  1480,  1500,  1501,  1502,  1503,  1504,  1505,  1506,  1507,
    1508,  1512,  1513,  1514,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,  1527,  1530,  1533,  1536,  1540,  1541,  1544,  1547,  1551,
    1555,  1560,  1566,  1573,  1578,  1583,  1588,  1592,  1596,  1600,
    1609,  1617,  1621,  1628,  1629,  1630,  1635,  1639,  1646,  1653,
    1657,  1665,  1666,  1667,  1672,  1676,  1679,  1680,  1681,  1682,
    1683,  1684,  1685,  1690,  1695,  1703,  1710,  1717,  1725,  1727,
    1729,  1731,  1733,  1735,  1737,  1739,  1742,  1746,  1752,  1753,
    1754,  1758,  1759,  1765,  1767,  1769,  1771,  1773,  1775,  1779,
    1783,  1787,  1795,  1798,  1800,  1801,  1805,  1806,  1807,  1810,
    1814,  1815,  1816,  1820,  1821,  1822,  1830,  1830,  1840,  1844,
    1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,
    1855,  1856,  1857,  1858,  1880,  1891,  1892,  1899,  1900,  1907,
    1916,  1920,  1924,  1948,  1949,  1953,  1966,  1966,  1982,  1983,
    1986,  1987,  1991,  1994,  2003,  2016,  2017,  2018,  2019,  2020,
    2024,  2032,  2033,  2034,  2035,  2036,  2040,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2057,  2058,  2059,
    2060,  2064,  2065,  2066,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2082,  2083,  2084,  2085,  2086,  2090,  2091,  2092,
    2093,  2094,  2098,  2099,  2103,  2104,  2108,  2115,  2116,  2117,
    2118,  2125,  2126,  2129,  2130,  2137,  2149,  2150,  2154,  2155,
    2159,  2160,  2161,  2162,  2163,  2164,  2168,  2169,  2170,  2174,
    2175,  2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,
    2188,  2189,  2190,  2200,  2204,  2227,  2241,  2242,  2243,  2244,
    2245,  2246,  2247,  2248,  2249,  2250,  2254,  2255,  2256,  2257,
    2258,  2259,  2260,  2261,  2262,  2263,  2264,  2265,  2266,  2267,
    2268,  2269,  2270,  2272,  2273,  2274,  2276,  2278,  2280,  2282,
    2283,  2284,  2285,  2286,  2287,  2297,  2298,  2299,  2300,  2301,
    2302,  2303,  2304,  2306,  2307,  2312,  2335,  2336,  2337,  2338,
    2339,  2340,  2344,  2347,  2348,  2349,  2357,  2364,  2373,  2374,
    2378,  2384,  2394,  2403,  2409,  2414,  2421,  2426,  2432,  2433,
    2434,  2442,  2443,  2444,  2445,  2446,  2452,  2464,  2465,  2466,
    2467,  2470,  2472,  2476,  2480,  2494,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,  2521,  2525,  2526,  2527,  2528,  2529,  2530,
    2533,  2535,  2538,  2540,  2544,  2547,  2552,  2553,  2554,  2558,
    2559,  2563,  2564,  2567,  2586,  2592,  2617,  2619,  2620,  2624,
    2625,  2626,  2627,  2628,  2629,  2635,  2636,  2637,  2638,  2639,
    2640,  2641,  2642,  2643,  2644,  2645,  2646,  2647,  2648,  2649,
    2650,  2651,  2652,  2653,  2654,  2655,  2656,  2657,  2658,  2659,
    2660,  2661,  2662,  2663,  2664,  2665,  2666,  2667,  2668,  2669,
    2670,  2671,  2672,  2673,  2679,  2680,  2681,  2682,  2683,  2684,
    2685,  2686,  2687,  2688,  2689,  2690,  2691,  2692,  2693,  2704,
    2714,  2715,  2719,  2720,  2721,  2722,  2723,  2724,  2725,  2726,
    2727,  2730,  2745,  2748,  2750,  2754,  2755,  2756,  2757,  2758,
    2759,  2760,  2761,  2762,  2763,  2763,  2764,  2764,  2765,  2766,
    2767,  2771,  2772,  2776,  2784,  2786,  2790,  2791,  2792,  2796,
    2797,  2800,  2802,  2805,  2806,  2807,  2808,  2809,  2810,  2811,
    2812,  2813,  2814,  2815,  2818,  2838,  2839,  2840,  2841,  2842,
    2843,  2844,  2845,  2846,  2847,  2848,  2849,  2850,  2851,  2852,
    2853,  2854,  2855,  2856,  2857,  2858,  2859,  2860,  2861,  2862,
    2863,  2864,  2865,  2866,  2867,  2868,  2869,  2870,  2871,  2872,
    2873,  2874,  2875,  2876,  2879,  2881,  2884,  2886,  2895,  2897,
    2898,  2901,  2903,  2907,  2908,  2911,  2921,  2942,  2944,  2948,
    2948,  2951,  2953,  2956,  2958,  2962,  2966,  2967,  2972,  2975,
    2978,  2983,  2986,  2991,  2994,  2998,  3002,  3005,  3006,  3007,
    3008,  3009,  3010,  3011,  3012,  3018,  3025,  3026,  3027,  3032,
    3033,  3039,  3052,  3053,  3054,  3055,  3056,  3059,  3061,  3065,
    3069,  3092,  3122,  3123,  3124,  3125,  3126,  3127,  3128,  3132,
    3133,  3134,  3135,  3136,  3137,  3138,  3139,  3140,  3141,  3142,
    3143,  3144,  3145,  3146,  3147,  3148,  3149,  3153,  3154,  3155,
    3156,  3159,  3161,  3164,  3166,  3170,  3176,  3179,  3186,  3193,
    3194,  3195,  3196,  3197,  3200,  3210,  3219,  3223,  3229,  3230,
    3234,  3239,  3245,  3248,  3253,  3254,  3255,  3256,  3257,  3261,
    3262,  3265,  3267,  3270,  3272,  3276,  3283,  3283,  3283,  3283,
    3283,  3283,  3283,  3283,  3283,  3283,  3283,  3283,  3283,  3283,
    3283,  3283,  3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,
    3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,
    3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,
    3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,
    3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,  3284,
    3284,  3284,  3285,  3285,  3285,  3285,  3285,  3285,  3285,  3285,
    3285,  3286,  3286,  3286,  3286,  3287,  3287,  3287,  3288,  3288,
    3288,  3288,  3288,  3288,  3288,  3288,  3288,  3288,  3288,  3288,
    3288,  3288,  3288,  3288,  3288,  3288,  3288,  3288,  3288,  3288,
    3288,  3288,  3288,  3288,  3288,  3288,  3288,  3288,  3288,  3289,
    3289,  3290,  3291,  3292,  3293,  3294,  3295,  3296,  3297,  3298,
    3299,  3300,  3301,  3301,  3301,  3301,  3301,  3301
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES", "FILTERS",
  "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1", "SHA256",
  "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN", "BGP", "V6ONLY",
  "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN",
  "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC",
  "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "PERIOD", "FILENAME",
  "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST",
  "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH",
  "ROA_CHECK", "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX",
  "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT",
  "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT",
  "PATH", "START", "DELAY", "FORGET", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "AWARE", "LINK",
  "EXTENDED", "SETKEY", "BGP_LARGE_COMMUNITY", "OSPF", "AREA",
  "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2", "RETRANSMIT", "HELLO",
  "TRANSMIT", "PRIORITY", "DEAD", "TYPE", "BROADCAST", "BCAST",
  "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP",
  "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN",
  "VIRTUAL", "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "LSA",
  "SUPPRESSION", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE",
  "TRANSPARENT", "RIP", "INFINITY", "UPDATE", "GARBAGE", "MULTICAST",
  "VERSION", "SPLIT", "HORIZON", "POISON", "REVERSE", "ZERO", "PLAINTEXT",
  "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE",
  "UNREACHABLE", "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'",
  "'['", "']'", "$accept", "config", "conf_entries", "definition", "expr",
  "expr_us", "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa",
  "pxlen", "datetime", "text", "text_or_none", "log_config", "syslog_name",
  "log_file", "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base", "debug_unix",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_mp_limit", "kern_item",
  "kif_proto_start", "kif_item", "kern_sys_item", "rtrid", "idval",
  "listen", "listen_opts", "listen_opt", "gr_opts", "tab_sorted", "newtab",
  "roa_table_start", "roa_table_opts", "roa_table", "proto_start",
  "proto_name", "proto_item", "imexport", "limit_action", "limit_spec",
  "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "iface_patt_list_nopx", "iface_patt_init",
  "iface_patt", "tos", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "mrtdump_table_config_init", "mrtdump_table_config",
  "mrtdump_table_filter_option", "mrtdump_table_config_list",
  "mrtdump_table_config_table_option", "mrtdump_table_config_option",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "export_mode",
  "cmd_SHOW_ROA", "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args",
  "roa_table_arg", "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_MRTDUMP_ROUTES", "mrtdump_table_cli_config",
  "mrtdump_table_cli_config_list", "mrtdump_table_cli_config_option",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "switch_atom", "cnum", "pair_item", "ec_kind", "ec_item", "lc_item",
  "set_item", "switch_item", "set_items", "switch_items", "fprefix_s",
  "fprefix", "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_finish", "bfd_iface_item", "bfd_auth_type",
  "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface", "bfd_multihop",
  "bfd_neigh_iface", "bfd_neigh_local", "bfd_neigh_multihop",
  "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start",
  "bgp_nbr_opts", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_proto_start",
  "rip_proto_item", "rip_proto_opts", "rip_proto", "rip_iface_start",
  "rip_iface_finish", "rip_iface_item", "rip_auth", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface", "cmd_SHOW_RIP_INTERFACES",
  "cmd_SHOW_RIP_NEIGHBORS", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,    59,    40,    41,
      58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   417,   418,   418,   419,   419,   420,   421,   421,   421,
     422,   422,   422,   423,   423,   423,   423,   423,   423,   424,
     424,   425,   425,   426,   427,   427,   428,   428,   429,   430,
     430,   431,   431,   432,   433,   433,   434,   434,   434,   435,
     435,   436,   436,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   438,   438,   438,   439,   439,   439,   439,   440,
     440,   440,   440,   440,   440,   441,   442,   442,   442,   442,
     443,   444,   445,   446,   447,   448,   449,   449,   450,   450,
     450,   451,   452,   452,   453,   453,   453,   453,   453,   453,
     454,   455,   455,   456,   456,   457,   457,   458,   458,   458,
     458,   458,   459,   460,   460,   461,   461,   461,   461,   462,
     463,   463,   464,   465,   466,   466,   467,   467,   468,   468,
     469,   469,   469,   469,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   471,   471,
     471,   471,   472,   472,   472,   472,   472,   473,   473,   474,
     475,   475,   476,   477,   477,   477,   478,   478,   479,   480,
     480,   481,   482,   483,   484,   484,   485,   486,   486,   486,
     486,   487,   488,   489,   489,   489,   490,   490,   491,   491,
     491,   491,   491,   491,   492,   492,   492,   493,   493,   494,
     494,   495,   496,   496,   497,   497,   498,   498,   498,   499,
     499,   500,   500,   500,   500,   501,   501,   502,   502,   503,
     503,   504,   505,   505,   505,   505,   505,   505,   505,   505,
     505,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     506,   507,   508,   509,   510,   511,   511,   512,   513,   514,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   515,   516,   516,   516,   517,   518,   518,   518,
     518,   519,   519,   519,   520,   521,   521,   521,   521,   521,
     521,   521,   521,   522,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   536,
     536,   537,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   548,   548,   549,   549,   549,   550,
     551,   551,   551,   552,   552,   552,   554,   553,   555,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   557,   558,   558,   559,   559,   560,
     561,   561,   562,   563,   563,   564,   566,   565,   567,   567,
     568,   568,   569,   569,   570,   571,   571,   571,   571,   571,
     571,   572,   572,   572,   572,   572,   573,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   575,   575,   575,
     575,   576,   576,   576,   577,   577,   577,   577,   577,   577,
     577,   577,   578,   578,   578,   578,   578,   579,   579,   579,
     579,   579,   580,   580,   581,   581,   582,   583,   583,   583,
     583,   584,   584,   585,   585,   585,   586,   586,   587,   587,
     588,   588,   588,   588,   588,   588,   589,   589,   589,   590,
     590,   590,   590,   590,   590,   590,   590,   590,   590,   590,
     591,   591,   591,   592,   593,   594,   595,   595,   595,   595,
     595,   595,   595,   595,   595,   595,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   597,   597,   597,   597,
     597,   597,   598,   599,   599,   599,   600,   600,   601,   601,
     602,   602,   602,   602,   602,   602,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   603,   604,   604,   604,
     604,   605,   605,   606,   607,   608,   609,   609,   609,   609,
     609,   609,   609,   609,   610,   610,   610,   610,   610,   610,
     611,   611,   612,   612,   613,   614,   615,   615,   615,   616,
     616,   617,   617,   618,   619,   620,   621,   621,   621,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   623,
     624,   624,   625,   625,   625,   625,   625,   625,   625,   625,
     625,   626,   627,   628,   628,   629,   629,   629,   629,   629,
     629,   629,   629,   629,   630,   629,   631,   629,   629,   629,
     629,   632,   632,   633,   634,   634,   635,   635,   635,   636,
     636,   637,   637,   638,   638,   638,   638,   638,   638,   638,
     638,   638,   638,   638,   639,   640,   640,   640,   640,   640,
     640,   640,   640,   640,   640,   640,   640,   640,   640,   640,
     640,   640,   640,   640,   640,   640,   640,   640,   640,   640,
     640,   640,   640,   640,   640,   640,   640,   640,   640,   640,
     640,   640,   640,   640,   641,   641,   642,   643,   644,   644,
     644,   645,   645,   646,   646,   647,   648,   649,   649,   651,
     650,   652,   652,   653,   653,   654,   655,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   664,   664,   664,
     664,   664,   664,   664,   664,   665,   666,   666,   666,   666,
     666,   667,   668,   668,   668,   668,   668,   669,   669,   670,
     671,   672,   673,   673,   673,   673,   673,   673,   673,   673,
     673,   673,   673,   673,   673,   673,   673,   673,   673,   673,
     673,   673,   673,   673,   673,   673,   673,   674,   674,   674,
     674,   675,   675,   676,   676,   677,   678,   679,   680,   681,
     681,   681,   681,   681,   682,   683,   683,   683,   684,   684,
     685,   685,   685,   685,   685,   685,   685,   685,   685,   686,
     686,   687,   687,   688,   688,   689,   690,   690,   690,   690,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   690,   691,   691,   691,   691,   691,   691,   691,   691,
     691,   691,   691,   691,   691,   691,   691,   691,   691,   691,
     691,   691,   691,   691,   691,   691,   691,   691,   691,   691,
     691,   691,   691,   691,   691,   691,   691,   691,   691,   691,
     691,   691,   691,   691,   691,   691,   691,   691,   691,   691,
     691,   691,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   693,   693,   693,   693,   694,   694,   694,   695,   695,
     695,   695,   695,   695,   695,   695,   695,   695,   695,   695,
     695,   695,   695,   695,   695,   695,   695,   695,   695,   695,
     695,   695,   695,   695,   695,   695,   695,   695,   695,   695,
     695,   695,   695,   695,   695,   695,   695,   695,   695,   695,
     695,   695,   695,   695,   695,   695,   695,   695
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     4,     2,     0,     1,     2,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     3,     1,     1,     1,     1,     2,
       4,     3,     3,     3,     3,     3,     3,     4,     3,     3,
       4,     5,     3,     3,     4,     2,     0,     1,     0,     1,
       2,     2,     0,     2,     2,     3,     2,     3,     3,     4,
       2,     3,     3,     3,     2,     4,     5,     1,     3,     1,
       1,     1,     4,     0,     2,     2,     2,     1,     1,     5,
       0,     1,     3,     3,     0,     8,     1,     4,     1,     1,
       0,     1,     2,     3,     0,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     4,     2,     3,     2,     2,     1,
       1,     1,     0,     2,     2,     2,     2,     2,     1,     1,
       3,     3,     0,     1,     1,     2,     0,     1,     3,     1,
       3,     1,     0,     2,     2,     2,     2,     3,     3,     3,
       5,     0,     3,     1,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     3,     1,
       1,     0,     4,     2,     1,     2,     0,     2,     3,     1,
       1,     2,     2,     2,     1,     4,     1,     0,     3,     4,
       1,     2,     0,     5,     5,     5,     5,     4,     4,     4,
       4,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     3,     3,     4,     5,     1,     0,     3,     4,     4,
       0,     2,     3,     3,     3,     2,     2,     2,     2,     3,
       3,     2,     2,     1,     1,     1,     4,     0,     3,     3,
       3,     0,     1,     1,     4,     0,     2,     2,     2,     2,
       2,     2,     2,     0,     2,     9,     9,     4,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     4,     1,     1,
       3,     0,     1,     3,     3,     3,     3,     4,     4,     4,
       4,     4,     2,     0,     1,     2,     2,     2,     1,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     3,     1,     3,     1,
       1,     1,     2,     3,     2,     4,     0,     5,     0,     1,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     1,     3,     1,     1,     1,     1,     5,     7,     5,
       7,     9,     7,     5,     7,     5,    11,     1,     1,     2,
       1,     7,     9,     7,     7,     9,     7,     9,     7,     9,
       7,    15,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     4,     2,     2,     2,     0,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     1,
       5,     7,     7,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     4,     1,     1,     1,     1,     2,     2,     3,
       3,     6,     3,     3,     3,     3,     3,     5,     7,     6,
       6,     6,     6,     4,     8,     4,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     1,     3,     0,     1,
       4,     6,     4,     3,     5,     5,     4,     6,     3,     2,
       5,     5,     8,     8,     8,     8,     2,     1,     2,     2,
       2,     0,     3,     5,     0,     0,     2,     4,     4,     4,
       2,     2,     2,     1,     1,     1,     2,     2,     3,     3,
       0,     3,     0,     3,     4,     3,     0,     2,     2,     0,
       2,     0,     2,     4,     5,     2,     0,     3,     3,     3,
       3,     5,     6,     4,     6,     4,     6,     4,     4,     5,
       6,     3,     3,     4,     5,     5,     5,     5,     5,     4,
       4,     5,     5,     5,     5,     5,     5,     5,     5,     6,
       6,     6,     5,     6,     8,     6,     6,     5,     6,     4,
       5,     4,     4,     5,     4,     5,     4,     5,     5,     5,
       5,     6,     5,     5,     6,     5,     5,     5,     4,     2,
       3,     3,     1,     2,     3,     2,     4,     3,     2,     3,
       1,     2,     4,     0,     3,     2,     1,     2,     3,     3,
       3,     3,     2,     3,     0,     5,     0,     5,     2,     2,
       1,     4,     1,     1,     0,     3,     2,     2,     2,     5,
       2,     0,     3,     0,     2,     2,     3,     2,     2,     3,
       2,     2,     2,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     2,     3,     2,     3,     3,     4,     4,
       2,     2,     2,     3,     3,     3,     2,     3,     3,     3,
       4,     2,     2,     1,     0,     2,     3,     1,     0,     1,
       2,     0,     2,     0,     1,     3,     0,     0,     2,     0,
       3,     0,     3,     0,     3,     3,     1,     0,     4,     6,
       6,     6,     7,     6,     7,     5,     0,     2,     3,     2,
       3,     3,     2,     3,     2,     2,     3,     3,     5,     4,
       4,     2,     1,     2,     4,     2,     2,     0,     3,     5,
       0,     0,     2,     2,     2,     2,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     3,     4,     3,     2,     2,     1,     1,     1,     1,
       1,     0,     3,     0,     3,     4,     6,     6,     2,     3,
       3,     5,     5,     4,     2,     3,     3,     3,     1,     2,
       4,     3,     3,     3,     2,     2,     2,     2,     2,     1,
       3,     0,     2,     0,     3,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     1,     2,     2,     2,     1,
       2,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    76,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   443,     0,     0,
     862,   863,   864,   865,   866,   867,   868,   869,   870,   871,
     872,   873,   874,   875,   876,   877,   878,   879,   880,   881,
     882,   883,   884,   885,   886,   887,   888,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,   899,   900,   901,
     902,   903,   904,   905,   906,   907,   908,   909,   910,   911,
       3,     1,     2,     0,     0,     0,     0,     0,     0,     0,
       0,   118,   119,     0,     0,     0,     0,   443,     0,   846,
     847,   848,   849,   850,   851,   120,   120,   852,   853,   854,
     855,   116,   856,     0,   858,   120,   124,   859,   860,   861,
     120,   915,   120,   124,   120,   124,   120,   124,   120,   919,
     120,   124,     5,   857,   124,   124,   310,   312,   311,     0,
      77,    76,     0,     0,    76,    78,    75,     0,     0,     0,
       0,     0,   191,     0,   309,   273,   314,     0,   257,     0,
       0,   240,   265,     0,   236,     0,   236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   425,   429,   438,
     435,   354,   445,   432,     0,     0,   428,   443,   476,     0,
       0,     0,   430,   431,     0,     0,     0,   443,     0,   433,
     434,   439,   474,   475,     0,   473,     0,   289,   288,     0,
     291,     0,     0,    30,    29,    35,    38,    36,     0,    18,
       0,     0,    58,    57,    56,    55,     0,     0,     0,     0,
       0,   110,     0,   316,     0,   103,   191,     0,     0,   318,
     346,   121,     0,     0,     0,   114,    81,    90,   166,   565,
     526,   629,   765,   771,   818,     0,     0,     0,     0,     0,
       0,    18,   171,     0,     0,     0,     0,     0,   914,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,    18,     0,   566,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,     0,     0,     0,     0,    18,
       0,    18,   916,     0,     0,     0,     0,    18,     0,     0,
      18,     0,   917,   632,     0,     0,   640,     0,     0,     0,
     918,     0,     0,     0,     0,     0,     0,   920,     0,     0,
     843,     0,    18,     0,    18,     0,     0,     0,     0,   912,
       0,     0,     0,     0,    32,   913,     0,     0,   174,   173,
       0,     0,    78,    72,    73,     0,    79,     0,   295,   293,
       0,     0,   296,   303,     0,   185,   184,     0,     0,     0,
       0,   313,   315,   314,     0,   237,     0,   261,   232,   231,
       0,     0,   236,   235,   236,   236,   756,   236,   236,     0,
     236,   236,     0,    19,    20,     0,     0,     0,   284,   280,
     285,   281,   278,   279,   282,   283,   425,   445,   425,   443,
     425,   425,     0,   416,     0,   443,     0,     0,     0,   428,
     428,     0,   471,   443,   443,   443,   443,   443,     0,   377,
     378,     0,   380,     0,     0,   355,   358,   356,   360,   443,
     357,   395,   392,   393,   394,   402,     0,   407,   411,     0,
     959,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   446,   958,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   961,   964,   963,   960,   962,   965,   966,   967,
     970,   968,   969,   971,   972,   973,   974,   975,   976,   977,
     477,   478,   286,   443,   443,   443,   443,   443,   443,   443,
     443,   443,   443,   443,   443,   443,   443,     0,    43,    44,
      45,    46,    47,    48,    49,    50,    51,     0,    41,   292,
       0,   294,   443,     0,    37,    39,     0,     0,     7,     9,
      14,    16,    15,    17,     0,   443,    13,    66,   150,   151,
      59,     0,     0,    65,     0,    68,    69,     0,   111,   112,
      97,    99,   100,   101,   162,   443,     0,   335,   113,     0,
     191,     0,    53,     0,    54,     0,     0,   122,   921,   925,
       0,   167,   127,    18,   149,   135,     0,   125,   126,   152,
     140,     0,   335,   141,     0,   443,   129,   139,     0,   130,
       0,   137,   128,   168,   169,   531,   569,     0,     0,    18,
      18,   581,     0,     0,     0,     0,     0,    18,     0,    18,
       0,     0,     0,   582,     0,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,    18,     0,    18,     0,    18,     0,    18,     0,
       0,    18,    18,    18,     0,     0,     0,   570,   630,    18,
     641,   633,    18,   638,   635,     0,   631,   643,   766,     0,
       0,     0,   767,   777,   819,    18,   824,     0,   820,   835,
       0,   834,     0,   838,     0,   836,   837,   841,     0,     0,
      84,     0,    86,    18,    18,    18,    94,   923,   924,   922,
       0,    31,     0,   927,   926,   179,   178,   180,   182,   183,
     181,     0,   176,   299,     0,    74,    80,    70,   297,   298,
       0,   335,     0,   308,   302,   304,   194,   301,   189,   190,
       0,   187,   300,   274,   277,     0,   233,   238,   256,     0,
     263,   262,     0,     0,   239,   246,     0,     0,   254,   335,
     248,   247,   251,   252,     0,   253,   255,   241,     0,   245,
     264,   272,   266,   269,   270,   268,   271,   267,     0,   747,
     747,     0,   236,   747,   236,   747,   748,   747,   747,   845,
       0,     0,    23,     0,     0,     0,   420,   422,     0,   423,
     424,   418,   406,   506,   509,     0,   485,     0,     0,   486,
     426,   427,   419,     0,     0,     0,     0,     0,     0,   379,
     443,   456,   443,     0,     0,     0,   366,     0,     0,   436,
     408,   409,     0,     0,   437,   468,   466,   464,   461,   462,
     463,   465,   467,   469,   470,   457,   458,   459,   460,   479,
       0,   480,   482,   483,   484,   290,     0,   287,     0,    34,
       0,    33,    67,     0,     0,    61,    62,    63,    64,    10,
      11,    12,     0,   152,     0,     0,    95,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,     0,     0,     0,   317,   339,     0,   107,   108,     0,
     102,   104,   196,   193,    52,     0,   335,   123,     0,   117,
       0,   136,   156,   159,   172,   148,   142,   132,   340,   341,
     138,    18,   342,   133,   131,   124,     0,     0,     0,     0,
       0,     0,   575,    18,   611,   614,     0,     0,     0,     0,
      18,     0,    18,     0,   628,   583,     0,   566,     0,     0,
     573,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   577,     0,   578,     0,   609,     0,
       0,     0,     0,     0,     0,     0,   589,   590,     0,     0,
       0,   616,     0,   612,   637,   634,     0,   639,     0,     0,
     769,   770,   124,     0,     0,   831,    21,   833,     0,   828,
     832,   443,   823,    93,    85,    87,    88,    82,    91,    25,
      24,    92,   175,     0,    71,   200,   199,   306,   195,   307,
     305,   186,     0,   234,   260,   259,   258,   243,   250,   244,
     242,   249,   564,   746,     0,     0,   755,   764,     0,   762,
     759,     0,     0,   757,     0,   747,     0,   747,     0,     0,
       0,    26,    27,     0,     0,   425,   417,   443,   495,     0,
       0,   443,   443,   443,   472,   443,   493,   443,     0,     0,
     443,   443,   443,   443,   359,   354,   443,   396,   403,     0,
       0,   412,   443,    42,     6,    40,     8,    60,   109,   163,
      96,    98,   334,   333,   335,   443,   106,   105,     0,     0,
       0,   204,     0,     0,   344,   337,     0,   347,     0,   170,
     157,     0,   152,     0,   147,   134,   534,   534,     0,   533,
     527,     0,     0,     0,   627,     0,   623,   622,     0,   613,
     617,   618,   619,     0,   607,     0,   598,    22,     0,   567,
     568,   571,     0,   579,     0,     0,   602,     0,   585,   584,
     597,   596,   591,     0,     0,   610,   594,   586,   587,   588,
     615,   625,   593,   592,   626,   595,   620,     0,   636,   736,
      18,     0,    18,   654,     0,     0,   656,   646,    18,   642,
       0,   660,   737,   768,   780,    18,     0,   779,   772,     0,
     821,   822,   830,    21,    18,     0,   829,     0,   499,     0,
     500,   501,     0,   443,   497,   498,   496,   443,   443,    18,
     844,     0,     0,   443,   839,   842,     0,    89,   177,   188,
     750,   749,   763,   758,   760,   761,     0,   751,     0,   753,
     816,   817,     0,     0,   421,   507,     0,   487,     0,     0,
       0,     0,     0,   443,   440,   443,     0,     0,   366,     0,
       0,     0,     0,     0,     0,     0,   336,     0,   443,   350,
     203,   201,   202,   192,     0,   197,     0,   343,     0,   153,
     154,   158,   160,   145,   143,   144,   146,   152,   528,   552,
     529,   556,   530,   532,     0,   603,   624,   605,   606,   608,
     574,   572,   601,   600,   580,   599,   576,   621,   152,   659,
     647,     0,     0,    18,     0,   645,     0,     0,   663,   658,
     662,     0,     0,   652,   644,     0,   670,   152,   776,   773,
     775,   778,   825,   827,   826,   443,   443,   443,   443,     0,
       0,     0,     0,     0,     0,   519,   502,   504,     0,    83,
     752,   754,   273,   273,     0,   492,   490,   491,   489,   443,
       0,     0,   375,     0,   443,   373,   443,   369,     0,   443,
     367,   443,   443,     0,   481,   345,   351,   198,   338,     0,
     155,   161,   552,   550,   535,     0,     0,   559,     0,   739,
     743,   649,   650,   648,   651,   724,   684,   664,   724,   653,
     738,   671,   813,     0,     0,     0,     0,     0,   513,   443,
     413,   840,   443,   443,     0,   443,   518,     0,     0,   488,
       0,   441,   442,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   410,     0,   535,     0,   555,   557,
     558,     0,   561,   604,   737,   741,   745,     0,     0,     0,
     673,   811,   781,   774,   512,   444,   516,     0,   443,   510,
     352,     0,     0,     0,     0,     0,     0,     0,     0,   505,
     275,   276,   494,   390,   374,   372,     0,   443,   370,   388,
     368,     0,   443,   386,   443,   384,   383,   443,   381,     0,
     554,     0,    18,     0,     0,     0,     0,     0,     0,   553,
     543,   206,   210,     0,   560,    18,   563,   740,     0,   655,
     727,   725,   728,    18,     0,    18,   661,     0,   657,     0,
       0,     0,     0,     0,     0,   669,   683,     0,     0,   815,
       0,     0,   443,   443,   361,   365,   363,   443,   520,   364,
     400,   397,   398,   399,   404,     0,   515,   514,   443,   443,
     443,   443,   521,     0,     0,     0,     0,     0,     0,     0,
     115,   211,   541,   207,     0,     0,     0,   536,   540,   544,
       0,   545,     0,   542,   212,   551,   562,     0,     0,     0,
      18,     0,     0,     0,     0,    18,     0,    18,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     744,   723,     0,   729,     0,     0,   667,   668,   666,   665,
     677,   680,   681,   682,   675,   674,     0,     0,   678,   672,
       0,     0,     0,     0,    18,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   814,   806,
       0,   517,   353,   511,   415,   366,     0,   443,     0,     0,
       0,     0,     0,   389,   371,   387,   443,   385,   443,   382,
       0,     0,     0,     0,     0,   546,   547,     0,     0,     0,
       0,     0,     0,     0,     0,    18,   689,   731,   721,     0,
       0,     0,     0,     0,   716,   710,   711,   712,    18,   722,
       0,   705,   685,   688,   686,     0,   703,     0,   690,   692,
     693,   694,   695,   696,   697,   698,   699,    18,    18,   687,
       0,    18,   742,   730,   726,   676,   679,   787,    18,    18,
       0,   782,   785,   786,   804,     0,     0,     0,   799,   807,
     810,   809,   808,   805,    18,     0,   784,   783,     0,     0,
      18,   788,    18,    18,   812,   362,   443,   401,   414,   405,
       0,     0,     0,     0,     0,     0,   205,   207,   537,   538,
     539,   548,   549,     0,    28,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   209,   706,     0,   714,   713,   715,
     164,   165,   717,   718,     0,   719,    18,   702,   691,   701,
     704,   707,   700,   803,   792,   794,   797,   800,   798,     0,
     801,   796,   793,   795,   789,   790,   791,     0,   525,   523,
     524,   522,   376,   443,   208,   212,   212,   212,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   212,     0,
       0,     0,     0,   709,   733,   732,   720,   708,   802,     0,
     219,   217,   218,   220,   212,   212,   212,   212,   734,     0,
     443,   213,   214,   215,   216,   735,     0,   391
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    90,   556,   565,   557,   395,   947,  1010,
    1011,   792,  1755,   207,   712,    91,   544,   208,   547,   537,
     538,    92,   216,   217,    93,    94,    20,    21,    22,    23,
      24,    25,   135,   357,    95,  1217,   340,    96,   346,   341,
      97,   576,    98,   579,   901,    99,   569,   100,   101,   590,
     102,   103,   233,   259,   606,  1114,   917,  1016,   104,   912,
    1271,  1111,   913,  1371,  1372,   873,   874,  1674,   105,   106,
     599,   260,   351,   721,   722,   368,   740,   741,   363,   582,
     733,  1102,  1017,  1103,  1490,  1650,  1491,  1492,  1664,  1759,
      26,    27,    28,    29,   389,    30,    31,    32,   380,   768,
      33,   377,   753,    34,   381,   370,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,   200,
     540,    48,    49,    50,    51,    52,    53,    54,    55,    56,
     364,   734,   735,    57,   129,   374,   107,   577,   108,   891,
     892,   893,  1106,   919,   920,   736,   906,   895,   109,   585,
    1257,  1258,  1449,   189,   441,  1530,   824,   442,   825,   443,
     444,   445,  1534,   446,  1535,   190,   448,   449,  1451,   411,
     191,   412,   421,   192,   193,   194,  1212,   195,   510,  1248,
    1213,  1337,  1338,   804,   805,  1259,   110,  1121,   925,   111,
    1277,  1428,  1493,  1563,  1427,  1374,  1278,  1280,  1377,  1432,
    1496,  1282,    58,   112,   636,   113,   114,   115,   314,   315,
     316,   988,  1180,  1306,  1311,  1309,  1310,  1438,  1507,  1181,
    1440,  1517,  1182,  1592,  1437,  1501,  1502,  1595,  1766,  1839,
    1825,  1298,  1316,  1380,  1434,  1498,  1436,  1299,  1034,    59,
      60,    61,    62,    63,    64,    65,    66,   781,   116,   117,
     118,  1189,   992,   119,  1317,  1519,  1630,  1723,  1518,  1442,
    1318,    67,    68,   120,   121,   329,   999,  1000,   330,  1215,
    1001,   698,    69,   122,    70,   123,   124,   125,   511
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1457
static const yytype_int16 yypact[] =
{
     111,  3113,   124,   785,   624,   904,   184,   624,   624,   772,
     869,   204,   198,  1850,   215,   243,   975,  1816,   123,   624,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457,   313,   702,   236,   299,   177,   257,   392,
     303, -1457, -1457,   416,   359,   292,   503,  1816,   440, -1457,
   -1457, -1457, -1457, -1457, -1457,    16,    16, -1457, -1457, -1457,
   -1457,   118, -1457,  1294, -1457,    16,  2966, -1457, -1457, -1457,
      16, -1457,    16,  2799,    16,  2821,    16,  1693,    16, -1457,
      16,  2583, -1457, -1457,  1206,  3022, -1457, -1457, -1457,   140,
   -1457,   490,   553,   570,   490,   519, -1457,   606,   618,   624,
     624,   627, -1457,   192, -1457,   561,   897,   120, -1457,   657,
     696, -1457, -1457,   382,   552,   113,   691,   458,   458,   715,
     732,   739,   758,   773,   775,   821,   840,    52, -1457, -1457,
   -1457,   815,   448, -1457,   609,    44,    10,  1816, -1457,   462,
     478,   486, -1457, -1457,   488,   500,   510,  1120,   147, -1457,
   -1457, -1457, -1457, -1457,  2451, -1457,  3306, -1457, -1457,  1308,
     883,   909,   898, -1457, -1457,   860, -1457, -1457,    -6,   136,
     140,   297, -1457, -1457, -1457, -1457,   608,   522,   297,   297,
     746,   763,    75, -1457,   919, -1457,   529,   192,   542,  3332,
   -1457,   813,   935,   564,   573, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457,   592,   140,   681,   989,   903,
     297,    81, -1457,  1039,   680,   974,   651,   192, -1457,   634,
     640,   638,   642,    99,   740,   977,   671,  1059,   797,   651,
      81,  1014,  1005,    49,   930,    81,   134,   458,   456,  1015,
    -125,  1017,   826,   834,   502,  1026,   831,   515,   818,   820,
      81,   819,   816,   823,   734,   -86,  1044,   832,   836,    81,
     866,    81, -1457,   749,   743,   792,   216,    81,  1045,   297,
      81,  1043, -1457, -1457,   755,   756, -1457,   765,  1089,   443,
   -1457,   770,   768,   769,   863,   458,  1102, -1457,   788,   804,
     782,  1111,    81,  1122,    81,  1127,  1118,  1128,   297, -1457,
     805,   807,   808,  1140,  1201, -1457,   817,   822, -1457, -1457,
     927,  1219,   519, -1457, -1457,  1227,   297,  1228, -1457, -1457,
    1233,  1234, -1457,   676,  1236, -1457, -1457,   -18,  1238,  1223,
    1240, -1457, -1457,   862,  1241, -1457,  1242,   603, -1457, -1457,
    3126,  1252,   691, -1457,   691,   691, -1457,   294,   337,  1244,
     691,   691,  1245, -1457, -1457,    39,  1069,  1070, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457,    36, -1457,    52,  1816,
      52,    52,  1239, -1457,  1243,  1411,  1229,    45,  1232,    10,
      10,  1231,  1230,  1816,  1816,  1816,  1816,  1816,  1246, -1457,
   -1457,  1251, -1457,   865,   117, -1457, -1457, -1457, -1457,   972,
   -1457,  1266, -1457, -1457, -1457, -1457,   195,    21, -1457,   219,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457,  1816,  1816,  1816,  1816,  1816,  1816,  1816,
    1816,  1816,  1816,  1816,  1816,  1816,  1816,   983, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457,   544, -1457, -1457,
    1273, -1457,  1816,   651, -1457, -1457,  1308,   875, -1457, -1457,
   -1457, -1457, -1457, -1457,   297,  1816, -1457, -1457, -1457, -1457,
     297,   906,   911, -1457,   786, -1457, -1457,   297, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457,  1816,   880,  1946, -1457,   180,
   -1457,   890, -1457,   891, -1457,   888,  1285, -1457, -1457, -1457,
    -111, -1457, -1457,    81, -1457, -1457,   216, -1457, -1457, -1457,
   -1457,   142,  2424, -1457,  1169,  1816, -1457, -1457,   142, -1457,
     142, -1457, -1457, -1457, -1457, -1457, -1457,  1247,  1249,    81,
      76, -1457,   899,  1256,   921,   926,   297,   205,  1020,    81,
    1161,   458,   932, -1457,   933,  1312,    56,   297,  1162,   297,
    1270,  1271,   297,  1287,    68,   297,   297,    81,  1288,   968,
    1259,   970,    81,   987,    81,   178,    81,   989,    81,   988,
     990,    81,    81,    81,   991,  1186,   992, -1457, -1457,    81,
   -1457, -1457,    81, -1457,  1313,   297, -1457, -1457, -1457,  1365,
     994,   995, -1457, -1457, -1457,    81, -1457,   989, -1457, -1457,
     848, -1457,   458, -1457,  1136, -1457, -1457, -1457,  1010,   297,
   -1457,   297, -1457,    81,    81,    81, -1457, -1457, -1457, -1457,
     297, -1457,   458, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457,   565, -1457, -1457,  1393, -1457, -1457, -1457, -1457, -1457,
     962,  2424,   651, -1457,   676, -1457, -1457, -1457, -1457, -1457,
     581, -1457, -1457, -1457, -1457,  1416, -1457, -1457, -1457,  1399,
   -1457, -1457,  1405,   458, -1457, -1457,  1402,  1403, -1457,  2424,
   -1457, -1457, -1457, -1457,   458, -1457, -1457, -1457,  1404, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,  1422,  1413,
    1413,   894,   691,  1413,   691,  1413, -1457,  1413,  1413, -1457,
     297,   458, -1457,  1419,  1425,  1427, -1457, -1457,   850, -1457,
   -1457, -1457, -1457,   342, -1457,  1035, -1457,  1192,  1420, -1457,
   -1457, -1457, -1457,   537,   567,   668,  1006,   704,  -207, -1457,
    1816, -1457,  1816,  1034,    14,  1037,  1077,   193,   199, -1457,
   -1457, -1457,  1437,  1436, -1457,  3360,  3360,  3360,  3386,  3386,
    3360,  3360,  3360,  3360,  3360,   710,   710,  1230,  1230, -1457,
    1047, -1457, -1457, -1457, -1457, -1457,  1308, -1457,  2329, -1457,
     600, -1457, -1457,  1291,  1438, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457,  1049, -1457,  1054,  1381, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457,    63,  1055,  1052, -1457, -1457,   297, -1457, -1457,   458,
   -1457, -1457,   100, -1457, -1457,  2364,  1946, -1457,   458, -1457,
    1060, -1457,  1441, -1457,  1053, -1457,  1339, -1457, -1457, -1457,
   -1457,    81,  3332, -1457, -1457,  2771,   297,   297,  1064,   297,
    1065,  1066, -1457,    81, -1457, -1457,  1067,  1071,  1072,  1073,
      81,  1074,    81,  1076, -1457, -1457,  1469, -1457,   297,   297,
   -1457,  1082,   297,  1083,   297,   297,  1086,   297,  1087,  1088,
    1091,  1095,  1104,   297, -1457,   216, -1457,  1105, -1457,  1106,
    1107,  1112,  1119,  1123,  1125,  1126, -1457, -1457,  1129,  1131,
    1132, -1457,   274, -1457, -1457, -1457,   297, -1457,  2591,  1133,
   -1457, -1457,  2885,  1135,  1137, -1457,  1312, -1457,   458,  -200,
    1136,   922, -1457, -1457, -1457, -1457, -1457,  1440, -1457,    39,
   -1457, -1457, -1457,   927, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457,   -18, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457,  1493,  1522, -1457, -1457,   216, -1457,
   -1457,   216,  1512, -1457,   216,  1413,  1526,  1413,  1531,  1542,
    1543, -1457, -1457,  1364,  1366,    52, -1457,  1816, -1457,  1520,
    1529,  1816,  1816,  1816, -1457,  1816, -1457,  1816,   742,   171,
    1488,  1816,  1546,  1816, -1457, -1457,  1816, -1457, -1457,  1141,
     815, -1457,  1816, -1457, -1457, -1457, -1457, -1457, -1457,  1053,
   -1457, -1457, -1457, -1457,  1946,  2298, -1457, -1457,   962,   297,
     651, -1457,   103,  1151, -1457,  1163,  1159, -1457,  1388, -1457,
   -1457,   978, -1457,   504, -1457, -1457, -1457, -1457,   458, -1457,
   -1457,  1164,  1168,  1165, -1457,  1170, -1457, -1457,  1175, -1457,
   -1457, -1457, -1457,  1177, -1457,  1178, -1457, -1457,    62, -1457,
   -1457, -1457,  1180, -1457,  1181,  1182, -1457,  1184, -1457, -1457,
   -1457, -1457, -1457,  1193,  1194, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457,  1199, -1457, -1457,
      81,   279,   365, -1457,  1275,   458, -1457, -1457,   649, -1457,
    1203, -1457,  1237, -1457, -1457,    81,   297, -1457, -1457,  1204,
   -1457, -1457, -1457,  1312,    81,   297,  -200,     5, -1457,  1591,
   -1457, -1457,  1207,  1816, -1457, -1457, -1457,  1816,  1816,    81,
   -1457,  2451,  1209,  1577, -1457, -1457,   297, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457,  1614, -1457,  1620, -1457,
   -1457, -1457,  1609,  1613, -1457, -1457,  1601, -1457,  1846,  1904,
    1941,  2024,   771,  1816, -1457,  1816,   144,    25,  3332,  1217,
     189,    24,  1220,  1077,  1619,  2062, -1457,  1224,    70, -1457,
   -1457, -1457, -1457, -1457,  1248, -1457,  1946, -1457,  1622,   458,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,  1250,
   -1457,    27, -1457, -1457,   297, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457,   297,   297,    81,   297, -1457,  1254,   216, -1457, -1457,
    1257,  1258,   297, -1457, -1457,   297,  1260, -1457, -1457,  1566,
   -1457, -1457, -1457, -1457, -1457,  1816,  1411,  1816, -1457,  2355,
    3016,   824,  1255,  1616,   446, -1457,  3332,  1261,  1263, -1457,
   -1457, -1457,   561,   561,  1624, -1457, -1457, -1457, -1457,  1816,
    2089,  2121, -1457,  1612,  1816, -1457,  1695, -1457,  1618,  1816,
    1646,  1727,  1768,  1264, -1457, -1457, -1457, -1457, -1457,  1471,
   -1457,  1053,  1250, -1457, -1457,  1638,   651,  1397,  1268,  1053,
    1267, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457,  1274,   297,  2381,  1272,  2412,  2510, -1457,  2608,
   -1457, -1457,  1816,  1816,   289,  1577, -1457,  1664,  1681, -1457,
    2162, -1457, -1457,  1277,  1278,   214,    31,  1282,   310,  1284,
    1286,    33,  1290,    34, -1457,  1678, -1457,   648, -1457, -1457,
   -1457,   458,  1431, -1457,  1237, -1457, -1457,    35,   305,    41,
     842, -1457, -1457, -1457, -1457, -1457, -1457,  1295,  2298,  1479,
   -1457,    46,  2439,  2466,  1298,  1299,  1301,  1310,  1314, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457,  1691,  1816, -1457, -1457,
   -1457,  1697,  1816, -1457,  1816,  1721, -1457,  1816, -1457,  1322,
   -1457,   651,    81,  1319,   764,  1472,   297,   297,   393, -1457,
   -1457, -1457,  1320,  1327, -1457,    81, -1457, -1457,  2881, -1457,
   -1457, -1457,    32,    81,   297,    81, -1457,  1328, -1457,   297,
     -49,   297,   297,  1465,   312, -1457, -1457,  1342,  2588, -1457,
    1343,  1340,  2608,   116, -1457, -1457, -1457,   972, -1457, -1457,
    1744, -1457, -1457, -1457, -1457,   106, -1457, -1457,  1816,  1816,
    1816,  1816, -1457,  1344,  1349,  1361,  1358,  1363,  1368,  1369,
   -1457, -1457, -1457,  1636,  1516,  1519,  1521, -1457, -1457, -1457,
     877, -1457,  1643, -1457,   747, -1457, -1457,  1468,   297,  1382,
      81,  1442,   -95,   250,  1482,    81,  1423,    81,   297,   297,
     297,  1524,   297,   376,  1415,  1433,  1457,   297,  1439,  1466,
   -1457, -1457,  1409, -1457,   297,  1417, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457,   297,   297, -1457, -1457,
     297,    -9,  1736,   297,    81,   458,    81,  1467,   -72,   133,
    1508,  1470,   -19,  1761,  1762,   295,  1445,  1444, -1457, -1457,
    1435, -1457, -1457, -1457, -1457,  2188,   237,   116,   251,  2217,
    2248,  2274,  2300, -1457, -1457, -1457,  1816, -1457,  1816, -1457,
    1447,  1443,   297,   297,   297, -1457, -1457,   889,   297,  1825,
    1825,   905,   566,   607,  1448,    81, -1457, -1457, -1457,   206,
     297,   297,   297,   297, -1457, -1457, -1457, -1457,   476, -1457,
    1483, -1457, -1457, -1457, -1457,   297, -1457,   297, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457,    81,    81, -1457,
     297,    81, -1457, -1457, -1457, -1457, -1457, -1457,    81,    81,
     297, -1457, -1457, -1457, -1457,   297,   297,   297, -1457, -1457,
   -1457, -1457, -1457, -1457,   803,   297, -1457, -1457,   297,   297,
      81, -1457,    81,    81, -1457, -1457,  1816, -1457, -1457, -1457,
    1455,  1458,  1460,  1473,  1474,  1451, -1457,  1636, -1457, -1457,
   -1457, -1457, -1457,  1475, -1457,  1478,  1484,   925,   993,  1485,
    1825,  1825,  1825,  1825, -1457, -1457,    61, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457,  1489, -1457,    81, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,  1491,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457,  2188, -1457, -1457,
   -1457, -1457, -1457,  1816, -1457,   747,   747,   747, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,   747,  1490,
    1492,  1494,  1498, -1457,  1497, -1457, -1457, -1457, -1457,  1464,
   -1457, -1457, -1457, -1457,   747,   747,   747,   747, -1457,  1500,
    1816, -1457, -1457, -1457, -1457, -1457,  1480, -1457
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1457, -1457, -1457, -1457,   -27,  -217,  -233,  -274,  -893,  -148,
    -748, -1457,  -952,   -81, -1457, -1457, -1457, -1457, -1457,  1332,
    1025, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457,   523,  1538, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457,  -300, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457,  1788,  -102,  1641, -1457,   148,  -231, -1457, -1457,
   -1457, -1457,   798,  -587,   594, -1457, -1457,   291, -1457, -1457,
   -1457, -1457,   139, -1457,   907,  -152, -1457,   895,  -192, -1457,
    -800, -1457,   827,   833,  -946,   174, -1456, -1457,  -186, -1457,
   -1457, -1457, -1457, -1457,  -126, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457,  -281, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457,  1188, -1457,   955,  1565, -1457, -1457, -1457, -1457,
    -885,   845,   675,  1367,  -397,  -117, -1457,  1040, -1457, -1457,
   -1145, -1457,   423,  -187,  1130,   311, -1026, -1331,  1771, -1321,
   -1313,  1134,   335, -1457, -1457,  -180,  1143, -1457, -1457, -1457,
   -1457,  -382,   647, -1457, -1457,  -987, -1457,  -160,   766,   -17,
   -1457, -1457,   574,   924,   652,  -968, -1457, -1457, -1457, -1457,
     870,   556, -1457, -1457, -1457,   611, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457,  1041, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457,   598, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457,   555, -1457, -1457, -1457, -1457, -1457,  -154, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457,   998, -1457, -1457, -1457,
   -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1457, -1102
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -509
static const yytype_int16 yytable[] =
{
     196,   440,   566,   635,   638,   228,   670,   413,   447,   396,
     397,   303,   914,   313,  1211,   321,  1030,   595,   598,   328,
    1105,  1071,   342,   347,   796,   419,   797,  1325,   799,   800,
     392,  1359,  1354,  1214,   581,   231,   659,   625,  1467,   545,
    1474,  1477,   632,   795,  1247,  1249,  1251,  1252,   830,   831,
     908,   406,  1523,   393,   394,   407,  1194,   653,  1375,   393,
     394,  1524,  1525,  1526,  1075,   408,   664,   406,   666,   790,
     229,   407,   417,   807,   671,   583,  -349,   674,  1601,   393,
     394,   408,  1092,  1670,  1671,  -349,  -349,  -349,  -349,  1197,
     570,   548,   571,   572,   573,   549,   548,  1651,   948,   700,
     549,   702,  1101,  1192,   948,   612,  1670,  1671,  1211,  1334,
     738,   550,   551,   552,   553,     1,   550,   551,   552,   553,
    1531,  1198,  -348,   375,    71,   513,   514,   515,   516,   517,
    1532,  -348,  -348,  -348,  -348,  1197,   607,   607,  1533,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   640,   548,
     527,   548,   929,   549,   232,   549,   739,   548,   641,   197,
     422,   549,   435,   436,   437,   171,   438,  1198,   198,  1195,
     434,   550,   551,   552,   553,   611,   348,   686,   915,   513,
     514,   515,   516,   517,   559,   349,  1098,   136,   624,  1098,
    1199,   564,   564,   518,   519,   520,   521,   522,   523,   524,
     525,   526,  1066,   958,   527,   554,  1067,   144,   435,   436,
     437,  1075,   438,   574,   435,   436,   437,  1075,   438,  1602,
     548,   548,   896,   597,   549,   549,   731,   218,   365,   731,
     660,   570,   767,   571,   572,   573,  1199,   366,   628,   949,
     550,   551,   552,   553,   219,   949,   413,  1672,   413,   634,
     413,   413,  1524,  1525,  1526,  1075,   778,   390,   779,   780,
    1719,   783,   785,   769,   787,   788,  1524,  1525,  1526,  1075,
    1716,  1211,  1200,  1201,  1202,  1203,  1204,  1205,  1206,   617,
    1093,  1720,   673,  1673,  1099,  1100,  1089,  1099,  1100,   548,
    1366,  1651,  1376,   549,  1207,  1447,   911,  1208,   418,   808,
    1322,   909,  1101,  1521,   209,  1603,  1717,  1531,   376,   391,
     548,   706,   548,   383,   549,  1708,   549,  1532,  1200,  1201,
    1202,  1203,  1204,  1205,  1206,  1533,  1726,   548,  1414,   726,
    1416,   549,   202,  1418,  1018,  1421,  1423,   862,   220,   782,
    1207,  1397,   212,  1208,   897,   898,   899,   959,   629,   558,
     513,   514,   515,   516,   517,   605,   383,   943,   605,   145,
     910,   213,  1029,  1270,   518,   519,   520,   521,   522,   523,
     524,   525,   526,  1727,   630,   527,   157,  1675,  1634,   210,
     548,  1105,   784,   618,   549,   592,   928,   931,   902,  1709,
    1593,   548,   798,   211,   939,   549,   941,  1594,   803,   930,
     550,   551,   552,   553,   158,   546,   813,   814,   815,   816,
     817,   221,  1211,  1326,   962,  1454,   996,   214,   997,   967,
     222,   969,   826,   973,   420,   975,   974,  1072,   978,   979,
     980,  1450,   832,  1360,  1355,   223,   984,  1361,  1009,   985,
    1468,  1544,  1475,  1478,   409,   224,  1546,  1499,  1547,   791,
     410,  1549,   993,  1508,  1527,   225,   994,   970,  1528,   230,
     409,  1211,   859,   950,   937,   938,   410,  1607,  1403,  1290,
    1005,  1006,  1007,  1823,   393,   394,   393,   394,  -349,  1404,
    1455,  1456,  -349,   575,   555,   971,   972,  1721,   215,   555,
    1009,   548,  1738,  1503,  1516,   549,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     130,   550,   551,   552,   553,  1263,  1637,  1052,  1676,  1638,
    1559,  1370,   203,   204,  -348,   858,   821,   564,  -348,   235,
     822,  1687,  1722,   864,   199,  1211,  1211,  1457,   863,  1560,
     872,   633,   555,  1458,   555,   513,   514,   515,   516,   517,
     555,   350,  1591,  1352,  1450,   439,   353,  1353,   875,   518,
     519,   520,   521,   522,   523,   524,   525,   526,  1767,  1768,
     527,   383,  1629,   354,   916,   513,   514,   515,   516,   517,
    1244,   916,   226,   916,  1245,  1273,   356,   900,   922,   518,
     519,   520,   521,   522,   523,   524,   525,   526,  1357,   936,
     527,  1076,  1358,   367,  1677,  1026,   748,   439,   828,   358,
     951,   829,   953,   555,   555,   956,  1301,  1302,   960,   961,
    1744,   359,  1745,  1465,   575,  1097,  1035,  1466,   560,  1046,
     362,  1048,   833,  1049,  1050,   834,  1274,  1275,  1276,   637,
     440,   440,  1504,   126,   127,  1736,   227,   369,   987,  1303,
    1211,  1019,   382,   447,   352,  1730,  1045,   355,  1047,  1527,
     378,  1561,  1562,  1505,   548,  1154,   561,   562,   549,   128,
     203,   204,  1003,  1234,  1004,   384,   513,   514,   515,   516,
     517,  1166,   555,  1008,   550,   551,   552,   553,  1115,   749,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   379,
    1128,   527,  1304,   555,  1760,   555,  1761,  1133,  1756,  1135,
     383,  1379,   513,   514,   515,   516,   517,  1506,   398,  1470,
     555,   203,   204,  1471,  1193,   600,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   399,  1774,   527,  1222,   525,
     526,  1223,   400,   527,  1225,  1762,   205,  1763,   385,   608,
     513,   514,   515,   516,   517,  1057,   923,   206,   924,   750,
    1108,   401,   730,  1051,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   555,   751,   527,   402,  1829,   403,   513,
     514,   515,   516,   517,   555,  1481,   752,  1482,    72,   645,
     646,   126,   127,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   731,  1068,   527,  1069,   602,   603,  1819,  1820,
    1821,  1822,   649,   650,  1846,  1483,   732,   128,   548,    73,
     657,   658,   549,  1120,   404,   869,   870,   871,    74,   680,
     681,    75,   513,   514,   515,   516,   517,  1009,   550,   551,
     552,   553,    76,   405,  1281,   414,   518,   519,   520,   521,
     522,   523,   524,   525,   526,    77,   415,   527,   513,   514,
     515,   516,   517,   416,  1658,    78,   393,   394,   995,  1096,
     423,    79,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   371,   372,   527,   555,  1659,   424,  1660,   126,   127,
    1188,  1226,  1661,  1228,   425,   413,   426,  1036,   539,  1122,
    1123,    80,  1125,    81,    82,  1484,  1485,  1662,   427,  1486,
    1487,    83,   541,  1037,   128,  1488,   371,   372,   428,   386,
     542,  1139,  1140,   543,   130,  1142,   567,  1144,  1145,   563,
    1147,   605,   568,   387,   388,   605,  1153,  1300,   578,  1305,
     580,  1197,   373,   139,   140,  1313,    84,    85,   142,   584,
    1061,   586,  1319,  1663,   587,  1167,   855,   856,    86,  1168,
     131,  1323,   137,   138,   141,   143,   865,   866,   132,   133,
     134,   867,   868,  1198,   201,   588,  1332,  1012,  1013,  1481,
    1062,   594,  1015,    87,   589,   167,    88,   168,   169,   170,
     171,   172,   173,  1021,  1022,  1009,   393,   394,  1269,   174,
     175,   823,   176,   591,   177,   593,   715,  1386,   594,  1483,
    1038,   689,  1085,   856,   513,   514,   515,   516,   517,  1262,
     596,  1312,  1509,  1554,  1555,  1655,  1656,  1308,   518,   519,
     520,   521,   522,   523,   524,   525,   526,  1751,  1752,   527,
     803,   613,  1199,   610,  1238,  1239,  1240,   614,  1241,   615,
    1242,  1757,  1758,   616,   159,   716,   717,   555,   620,  1253,
    1489,  1407,  1408,  1789,   619,  1255,   810,   811,   718,   719,
    1383,   720,  1261,  1808,  1809,  1810,  1811,  1812,   621,   622,
     690,  1063,   623,   626,   600,   513,   514,   515,   516,   517,
     627,   639,   178,   642,   360,   361,   631,   643,   179,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   601,  1510,
     527,   691,   644,   647,   648,   651,   160,  1065,   161,   162,
     692,   652,   655,   654,  1200,  1201,  1202,  1203,  1204,  1205,
    1206,   661,   665,   167,   656,   168,   169,   170,   171,   172,
     173,  1813,  1814,  1815,  1816,  1817,  1207,   174,   175,  1208,
     176,   662,   177,   663,   668,  1243,   667,  1494,   669,  1320,
     675,   672,   676,   180,   181,   602,   603,   677,  1324,   163,
     164,   165,   166,  1039,   604,   679,   678,   682,  1209,   683,
     684,  1511,  1512,  1513,  1349,  1514,  1329,   685,   687,  1339,
    1330,  1331,    89,   697,   849,   688,  1336,   699,   701,   704,
     182,   183,   429,   430,   431,   432,   703,   693,   694,   695,
     696,   555,   707,   705,   708,   709,   710,   184,  1040,   850,
     185,   711,   723,  1041,   713,   186,  1350,   851,  1351,   714,
     725,   727,   852,   853,   854,  1400,   728,   729,  1042,   737,
     178,   742,   743,   744,   746,   747,   179,   786,   789,  1552,
     793,   794,   246,   801,  1515,   770,   806,  1378,   802,  1056,
     809,   812,  1566,   527,  1529,   818,   819,  1043,  1044,  1557,
    1596,   771,  1598,   827,  1381,  1382,   857,  1384,   820,   331,
     332,   333,   861,   334,   335,  1389,   336,   876,  1390,  1500,
     337,  1500,   248,   338,   605,  1430,   905,   903,   904,   513,
     514,   515,   516,   517,   907,   921,   932,   933,  1394,   803,
    1396,   180,   181,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   249,   926,   527,   927,   250,   251,   934,   940,
     253,   254,  1410,   935,  1210,   942,   255,  1668,   772,   944,
     945,  1713,  1679,   946,  1681,   952,   954,   955,   182,   183,
     429,   430,   431,   432,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   957,   963,   184,  1443,   236,   185,   982,
     773,   774,   237,   186,   256,   964,   965,   966,   775,   257,
     187,  1712,   986,  1714,   989,  1452,  1453,   188,  1336,   513,
     514,   515,   516,   517,   968,   976,  1014,   977,   981,   983,
    1551,   990,   991,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   998,   776,   527,  1064,   238,  1002,  1024,  1023,
    1025,  1027,  1028,  1031,   167,  1032,   168,   169,   170,   171,
     172,   173,  1765,  1033,  1053,  1748,  1749,  1750,   174,   175,
    1054,   176,  1055,   177,  1058,  1775,  1059,  1070,  1060,  1529,
    1073,  1529,  1079,   777,  1080,  1082,  1088,   239,  1087,   564,
    1558,  1090,  1094,  1095,  1779,  1780,  1112,  1109,  1782,  1110,
    1113,  1124,  1126,  1127,  1129,  1783,  1784,  1597,  1130,  1131,
    1132,  1134,  1600,  1136,  1604,  1605,  1074,  1608,  1137,  1141,
    1143,  1790,  1824,  1146,  1148,  1149,  1220,  1794,  1150,  1795,
    1796,   167,  1151,   168,   169,   170,   171,   172,   173,  1216,
    1635,  1152,  1155,  1156,  1157,   174,   175,  1246,   176,  1158,
     177,  1639,  1640,  1641,  1642,  1221,  1159,  1224,   187,  1227,
    1160,   178,  1161,  1162,  1229,   188,  1163,   179,  1164,  1165,
    1183,  1666,  1190,  1827,  1191,  1230,  1231,  1232,  1236,  1233,
     240,  1682,  1683,  1684,  1254,  1686,  1688,  1237,  1265,   167,
    1699,   168,   169,   170,   171,   172,   173,  1703,  1267,  1268,
    1266,  1283,  1285,   174,   175,  1250,   176,  1286,   177,  1705,
    1706,  1284,  1287,  1707,  1288,  1289,  1711,  1291,  1292,  1293,
     167,  1294,   168,   169,   170,   171,   172,   173,  1731,  1307,
    1295,  1296,   180,   181,   174,   175,  1297,   176,   178,   177,
    1314,  1321,  1315,  1327,   179,  1328,  1335,  1340,   339,  1830,
    1831,  1832,   241,  1341,  1342,   564,   564,   564,  1343,  1344,
    1356,  1753,  1833,  1362,  1363,  1393,  1365,  1369,  1402,   182,
     183,  1413,  1769,  1770,  1771,  1772,  1773,  1417,  1841,  1842,
    1843,  1844,  1409,  1419,  1425,  1367,   184,  1429,  1777,   185,
    1778,  1373,  1401,  1431,   186,  1385,   178,  1460,  1387,  1388,
    1406,  1391,   179,  1781,  1405,  1433,  1424,   242,  1435,   180,
     181,  1445,   243,  1785,  1461,  1441,  1463,  1464,  1786,  1787,
    1788,  1469,  1472,  1479,  1495,  1473,   244,   178,  1791,  1476,
    1086,  1792,  1793,   179,  1520,  1522,  1538,  1539,   167,  1540,
     168,   169,   170,   171,   172,   173,   182,   183,  1541,  1797,
    1543,  1542,   174,   175,  1415,   176,  1545,   177,  1548,  1550,
    1553,  1564,  1556,   184,  1565,  1599,   185,   180,   181,   246,
     167,   186,   168,   169,   170,   171,   172,   173,  1606,  1609,
    1631,  1636,  1632,  1643,   174,   175,  1420,   176,  1644,   177,
    1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,   180,   181,
    1645,  1646,  1647,  1481,   182,   183,  1648,  1652,  1649,   248,
    1653,   167,  1654,   168,   169,   170,   171,   172,   173,  1657,
    1091,   184,  1665,  1667,   185,   174,   175,  1422,   176,   186,
     177,  1678,  1680,  1669,  1698,   182,   183,  1685,  1700,   249,
    1697,  1701,  1710,   250,   251,   178,  1702,   253,   254,   187,
    -508,   179,   184,   255,  1704,   185,   188,  1724,  1715,   167,
     186,   168,   169,   170,   171,   172,   173,  1728,  1729,  1725,
    1732,  1733,  1734,   174,   175,  1754,   176,   178,   177,  1826,
    1747,  1828,  1838,   179,   513,   514,   515,   516,   517,  1746,
    1764,   256,  1798,  1776,  1803,  1799,   257,  1800,   518,   519,
     520,   521,   522,   523,   524,   525,   526,  1840,   860,   527,
    1801,  1083,  1805,  1802,   234,  1806,   180,   181,   178,  1847,
     724,  1807,  1818,   245,   179,   609,   187,  1834,   261,  1835,
     262,  1836,   304,   188,   317,  1837,   322,  1845,   323,  1718,
    1272,  1392,   513,   514,   515,   516,   517,  1219,   180,   181,
    1218,  1804,  1020,   182,   183,  1260,   518,   519,   520,   521,
     522,   523,   524,   525,   526,  1264,   178,   527,   745,  1256,
     184,  1368,   179,   185,   894,  1633,  1107,  1737,   186,   513,
     514,   515,   516,   517,   187,   182,   183,  1077,   433,   180,
     181,   188,  1078,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   184,  1739,   527,   185,  1081,  1333,  1395,  1459,
     186,  1235,  1480,  1426,  -503,   187,  1439,  1279,  1138,  1497,
       0,     0,   188,   146,   147,     0,   182,   183,  1196,     0,
       0,     0,     0,     0,     0,     0,     0,   180,   181,     0,
       0,   148,     0,   184,     0,     0,   185,     0,     0,     0,
       0,   186,     0,     0,     0,     0,   149,     0,     0,     0,
       0,     0,   513,   514,   515,   516,   517,   150,     0,   151,
     152,     0,     0,     0,   182,   183,   518,   519,   520,   521,
     522,   523,   524,   525,   526,     0,     0,   527,     0,     0,
       0,   184,     0,     0,   185,     0,     0,     0,     0,   186,
     513,   514,   515,   516,   517,     0,     0,   318,   319,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,     0,     0,   527,     0,   513,   514,   515,
     516,   517,     0,   187,     0,   320,   153,     0,     0,     0,
     188,   518,   519,   520,   521,   522,   523,   524,   525,   526,
       0,     0,   527,     0,     0,     0,     0,     0,     0,   513,
     514,   515,   516,   517,     0,   187,     0,     0,     0,     0,
       0,     0,   188,   518,   519,   520,   521,   522,   523,   524,
     525,   526,     0,     0,   527,   877,   878,   879,   880,   881,
     882,   883,   884,     0,   885,   886,   887,   888,   889,   890,
     513,   514,   515,   516,   517,     0,   187,     0,   154,     0,
       0,     0,     0,   188,   518,   519,   520,   521,   522,   523,
     524,   525,   526,     0,     0,   527,   513,   514,   515,   516,
     517,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,     0,
       0,   527,     0,     0,   187,   513,   514,   515,   516,   517,
       0,   188,     0,     0,     0,     0,     0,     0,   155,   518,
     519,   520,   521,   522,   523,   524,   525,   526,     0,     0,
     527,     0,   156,     0,     0,  1345,   513,   514,   515,   516,
     517,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,     0,
       0,   527,   513,   514,   515,   516,   517,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,     0,     0,   527,   513,   514,
     515,   516,   517,  1346,     0,     0,     0,  1197,     0,     0,
       0,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,     0,     0,   527,     0,     0,     0,   513,   514,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,  1198,
    1347,   518,   519,   520,   521,   522,   523,   524,   525,   526,
       0,     0,   527,   513,   514,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   522,   523,   524,   525,   526,     0,     0,   527,   513,
     514,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   522,   523,   524,
     525,   526,     0,     0,   527,     0,     0,     0,  1199,     0,
     513,   514,   515,   516,   517,     0,     0,     0,     0,     0,
       0,     0,     0,  1348,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   918,     0,   527,     0,   513,   514,   515,
     516,   517,     0,     0,     0,     0,   450,     0,     0,     0,
       0,   518,   519,   520,   521,   522,   523,   524,   525,   526,
       0,  1364,   527,     0,   513,   514,   515,   516,   517,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,     0,  1411,   527,
    1200,  1201,  1202,  1203,  1204,  1205,  1206,     0,     0,     0,
       0,     0,     0,     0,     0,   450,     0,     0,     0,     0,
       0,     0,  1207,     0,     0,  1208,     0,     0,     0,     0,
    1412,     0,     0,   451,   452,     0,     0,     0,     0,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,     0,     0,
       0,  1462,     0,   877,   878,   879,   880,   881,   882,   883,
     884,     0,   885,   886,   887,   888,   889,   890,     0,   481,
       0,     0,   451,   452,     0,     0,     0,  1735,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,  1740,  1197,   482,   246,
    1610,     0,     0,   877,   878,   879,   880,   881,   882,   883,
     884,     0,   885,   886,   887,   888,   889,   890,     0,   324,
       0,     0,     0,     0,  1611,  1612,     0,  1741,     0,  1198,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   248,
       0,     0,     0,     0,     0,  1613,     0,     0,     0,     0,
       0,     0,     0,  1742,     0,   483,   484,   482,   485,   486,
     487,   488,   489,   490,   491,     0,     0,     0,     0,   249,
       0,     0,     0,   250,   251,     0,     0,   253,   254,  1743,
    -348,     0,     0,   255,  1169,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1481,     0,  1614,  1199,     0,
       0,     0,     0,     0,     0,     0,  1084,   492,   493,   494,
     495,   496,   497,   498,   499,   500,     0,     0,     0,     0,
       0,   256,     0,     0,  1615,  1483,   257,     0,     0,     0,
       0,     0,  1398,   501,   502,     0,     0,     0,     0,     0,
       0,     0,   325,  1104,     0,     0,     0,     0,   503,  1170,
       0,   504,   505,   506,   507,     0,     0,     0,  1444,     0,
       0,     0,     0,     0,     0,     0,   492,   493,   494,   495,
     496,   497,   498,   499,   500,     0,     0,     0,     0,     0,
    1200,  1201,  1202,  1203,  1204,  1205,  1206,   246,     0,  1446,
       0,     0,   501,   502,     0,     0,     0,     0,     0,     0,
       0,     0,  1207,     0,     0,  1208,     0,   503,     0,     0,
     504,   505,   506,   507,  1616,   246,  1536,  1617,  1618,     0,
     263,   508,   509,     0,     0,  1619,     0,   248,     0,     0,
       0,     0,     0,     0,     0,   264,     0,   246,     0,     0,
       0,  1171,     0,  1537,     0,     0,     0,     0,     0,   265,
       0,     0,     0,     0,     0,   248,     0,   249,     0,     0,
       0,   250,   251,     0,  1116,   253,   254,   326,     0,     0,
       0,   255,     0,     0,     0,   305,  1620,   248,     0,     0,
     508,   509,     0,     0,     0,   249,     0,     0,     0,   250,
     251,   266,   267,   253,   254,     0,  1172,     0,     0,   255,
       0,   246,     0,   268,     0,     0,   269,   249,   270,   256,
       0,   250,   251,     0,   257,   253,   254,  1567,  1173,     0,
    1174,   255,     0,     0,     0,  1175,  1621,  1176,     0,     0,
       0,  1177,  1178,     0,     0,     0,     0,   256,     0,     0,
       0,   248,   257,  1622,     0,     0,     0,     0,  1623,  1624,
       0,  1625,  1626,     0,  1627,     0,     0,     0,   271,   256,
     272,     0,     0,     0,   257,   327,     0,     0,     0,   273,
    1628,   249,     0,  1179,     0,   250,   251,     0,  1184,   253,
     254,     0,   246,     0,     0,   255,     0,     0,  1481,  1448,
       0,     0,     0,     0,   513,   514,   515,   516,   517,     0,
       0,     0,   247,     0,  1117,  1118,     0,   274,   518,   519,
     520,   521,   522,   523,   524,   525,   526,     0,  1483,   527,
       0,     0,   248,   256,     0,   275,     0,     0,   257,     0,
       0,  1568,   276,   277,     0,   278,     0,     0,   246,     0,
     279,   280,     0,   281,   282,     0,   283,  1569,     0,   284,
     285,   286,   249,     0,     0,     0,   250,   251,     0,   252,
     253,   254,     0,     0,   287,   288,   255,   343,     0,   289,
       0,   290,   291,     0,   292,     0,     0,     0,   248,   293,
       0,     0,     0,   294,   295,     0,   296,   297,     0,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   754,
       0,     0,     0,     0,   256,     0,     0,  1570,   249,   257,
    1571,  1572,   250,   251,   393,   394,   253,   254,  1573,     0,
     306,     0,   255,     0,     0,   307,   308,   309,     0,     4,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   755,     0,     0,     0,   344,     0,     0,     0,     0,
       0,     0,     0,  1119,     5,     6,     0,     0,     0,   310,
     256,     0,     0,     0,     7,   257,   311,     0,     0,  1574,
       0,     0,  1575,     0,     0,  1576,     0,     0,     0,     0,
       0,   302,   756,     0,     0,     0,  1577,     0,  1578,     0,
    1579,  1580,  1581,  1582,  1583,  1584,     0,     0,     0,     0,
       0,  1585,     0,   312,  1586,     0,     0,  1587,     0,     0,
       0,  1399,     0,     0,   757,     0,     0,     8,     0,  1588,
       0,   758,   759,  1185,     0,     0,     0,  1589,     0,     0,
       0,     0,   760,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1186,     0,     0,     0,     0,   761,
     762,   763,   764,     9,   765,   766,    10,     0,    11,     0,
       0,     0,     0,  1590,     0,    12,     0,  1187,     0,    13,
       0,     0,     0,     0,    14,    15,    16,     0,     0,   512,
       0,    17,    18,    19,   513,   514,   515,   516,   517,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,     0,     0,   527,
     513,   514,   515,   516,   517,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,     0,     0,   527,     0,     0,  -509,  -509,
    -509,     0,     0,     0,     0,     0,     0,     0,   258,     0,
       0,   605,  -509,  -509,  -509,  -509,  -509,   523,   524,   525,
     526,     0,     0,   527,   513,   514,   515,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,     0,     0,   527,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   345
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1457)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-509)))

static const yytype_int16 yycheck[] =
{
      17,   188,   219,   277,   278,    86,   306,   167,   188,   157,
     158,   113,   599,   115,  1001,   117,   764,   248,   251,   121,
     905,     7,   124,   125,   406,    15,   408,    22,   410,   411,
     156,     7,     7,  1001,   226,    19,   122,   270,     7,    45,
       7,     7,   275,     7,  1070,  1071,  1072,  1073,    27,    28,
     161,    15,     6,    18,    19,    19,   256,   290,    31,    18,
      19,    15,    16,    17,    18,    29,   299,    15,   301,    30,
      87,    19,    28,    28,   307,   227,     6,   310,   127,    18,
      19,    29,    19,   178,   179,    15,    16,    17,    18,    19,
      15,    15,    17,    18,    19,    19,    15,  1553,    42,   332,
      19,   334,   902,   996,    42,   257,   178,   179,  1095,  1211,
     128,    35,    36,    37,    38,     4,    35,    36,    37,    38,
    1451,    51,     6,     3,     0,     8,     9,    10,    11,    12,
    1451,    15,    16,    17,    18,    19,   253,   254,  1451,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   273,    15,
      33,    15,    76,    19,   138,    19,   174,    15,   283,    36,
     177,    19,    15,    16,    17,    18,    19,    51,    45,   369,
     187,    35,    36,    37,    38,   256,    36,   325,    36,     8,
       9,    10,    11,    12,   211,    45,    86,     3,   269,    86,
     120,   218,   219,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   409,   135,    33,    69,   413,     3,    15,    16,
      17,    18,    19,   138,    15,    16,    17,    18,    19,   268,
      15,    15,    42,   250,    19,    19,   126,    50,    36,   126,
     316,    15,   380,    17,    18,    19,   120,    45,   189,   183,
      35,    36,    37,    38,    67,   183,   406,   342,   408,   276,
     410,   411,    15,    16,    17,    18,   382,   144,   384,   385,
     127,   387,   388,   380,   390,   391,    15,    16,    17,    18,
     342,  1258,   202,   203,   204,   205,   206,   207,   208,   180,
     217,   148,   309,   378,   184,   185,   873,   184,   185,    15,
    1258,  1747,   265,    19,   224,  1397,   596,   227,   254,   254,
    1193,   412,  1102,  1448,    68,   354,   378,  1638,   188,   196,
      15,   338,    15,    19,    19,   324,    19,  1638,   202,   203,
     204,   205,   206,   207,   208,  1638,   345,    15,  1354,   356,
    1356,    19,    19,  1359,   731,  1361,  1362,   554,    81,    45,
     224,  1328,    43,   227,   164,   165,   166,   279,   299,   210,
       8,     9,    10,    11,    12,   255,    19,   631,   255,   161,
     593,    62,   759,  1111,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   392,   325,    33,   161,   127,  1523,   143,
      15,  1266,    45,   284,    19,   246,   619,   620,   580,   398,
     358,    15,   409,   157,   627,    19,   629,   365,   415,   323,
      35,    36,    37,    38,   161,   411,   423,   424,   425,   426,
     427,    19,  1399,   408,   647,   126,   690,   118,   692,   652,
     117,   654,   439,   656,   414,   658,   657,   413,   661,   662,
     663,  1399,   411,   409,   409,    19,   669,   413,   712,   672,
     409,  1467,   409,   409,   408,    86,  1472,   412,  1474,   410,
     414,  1477,   685,   412,   408,   163,   687,   279,   412,    19,
     408,  1448,   543,   407,   259,   260,   414,   155,    22,   407,
     703,   704,   705,   412,    18,    19,    18,    19,   408,    33,
     191,   192,   412,   408,   408,   307,   308,   354,   189,   408,
     764,    15,  1637,   188,  1440,    19,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
      20,    35,    36,    37,    38,   412,   410,   791,   268,   413,
     127,  1269,    19,    20,   408,   542,   409,   554,   412,   411,
     413,   155,   399,   560,   411,  1522,  1523,   248,   555,   146,
     567,   407,   408,   254,   408,     8,     9,    10,    11,    12,
     408,   411,  1498,   409,  1522,   408,     3,   413,   575,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   362,   363,
      33,    19,  1518,     3,   601,     8,     9,    10,    11,    12,
     409,   608,    79,   610,   413,    81,    67,   407,   605,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   409,   626,
      33,   408,   413,   411,   354,   753,     3,   408,   413,     3,
     637,   416,   639,   408,   408,   642,   337,   338,   645,   646,
    1646,     3,  1648,   409,   408,   899,   780,   413,    20,   783,
       3,   785,   413,   787,   788,   416,   132,   133,   134,   183,
     827,   828,   337,    19,    20,   408,   143,    86,   675,   370,
    1637,   732,   270,   833,   131,   360,   782,   134,   784,   408,
       3,   268,   269,   358,    15,   965,    58,    59,    19,    45,
      19,    20,   699,  1055,   701,   123,     8,     9,    10,    11,
      12,   407,   408,   710,    35,    36,    37,    38,   921,    86,
      22,    23,    24,    25,    26,    27,    28,    29,    30,     3,
     933,    33,   337,   408,   138,   408,   140,   940,  1660,   942,
      19,  1298,     8,     9,    10,    11,    12,   412,     3,   409,
     408,    19,    20,   413,   998,    45,    22,    23,    24,    25,
      26,    27,    28,    29,    30,     3,   260,    33,  1038,    29,
      30,  1041,     3,    33,  1044,   138,    44,   140,   196,    69,
       8,     9,    10,    11,    12,   413,   608,    55,   610,   156,
     908,     3,    86,   790,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   408,   171,    33,     3,  1803,     3,     8,
       9,    10,    11,    12,   408,   137,   183,   139,     3,   287,
     288,    19,    20,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   126,   820,    33,   822,   126,   127,  1760,  1761,
    1762,  1763,   297,   298,  1840,   167,   140,    45,    15,    34,
      86,    87,    19,   925,     3,    39,    40,    41,    43,   386,
     387,    46,     8,     9,    10,    11,    12,  1111,    35,    36,
      37,    38,    57,     3,  1118,    30,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    70,   408,    33,     8,     9,
      10,    11,    12,   254,   117,    80,    18,    19,    20,   896,
     408,    86,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    19,    20,    33,   408,   138,   408,   140,    19,    20,
     992,  1045,   145,  1047,   408,  1055,   408,     3,    15,   926,
     927,   116,   929,   118,   119,   257,   258,   160,   408,   261,
     262,   126,     3,    19,    45,   267,    19,    20,   408,   367,
      22,   948,   949,    63,    20,   952,   180,   954,   955,   407,
     957,   255,   169,   381,   382,   255,   963,  1170,    19,  1172,
     411,    19,    45,   171,   172,  1178,   161,   162,    79,   407,
     413,   138,  1185,   206,    19,   982,   412,   413,   173,   986,
      56,  1194,     7,     8,     9,    10,    60,    61,    64,    65,
      66,    60,    61,    51,    19,   411,  1209,   412,   413,   137,
     413,    19,    20,   198,   411,    13,   201,    15,    16,    17,
      18,    19,    20,   412,   413,  1269,    18,    19,    20,    27,
      28,    29,    30,   411,    32,   324,    79,  1307,    19,   167,
     116,   207,   412,   413,     8,     9,    10,    11,    12,  1100,
     117,   372,   180,   259,   260,   148,   149,  1175,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   148,   149,    33,
    1057,   407,   120,    69,  1061,  1062,  1063,   407,  1065,   411,
    1067,   146,   147,   411,    79,   128,   129,   408,    81,  1076,
     412,  1342,  1343,   260,   324,  1082,   419,   420,   141,   142,
    1303,   144,  1099,   148,   149,   150,   151,   152,   407,    20,
     276,   413,   285,    69,    45,     8,     9,    10,    11,    12,
      85,    76,   120,    76,   139,   140,   166,   271,   126,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    69,   267,
      33,   307,   278,    87,   283,   297,   141,   413,   143,   144,
     316,   301,   306,   304,   202,   203,   204,   205,   206,   207,
     208,    87,   266,    13,   311,    15,    16,    17,    18,    19,
      20,   148,   149,   150,   151,   152,   224,    27,    28,   227,
      30,   319,    32,   317,   411,   413,   407,  1431,   366,  1186,
     117,   116,   407,   191,   192,   126,   127,   411,  1195,   194,
     195,   196,   197,   279,   135,    86,   411,   407,   256,   411,
     411,   339,   340,   341,   413,   343,  1203,   324,    86,  1216,
    1207,  1208,   407,   411,   211,   407,  1213,    86,    76,    81,
     228,   229,   230,   231,   232,   233,    79,   403,   404,   405,
     406,   408,   407,    85,   407,   407,    76,   245,   324,   236,
     248,    20,     3,   329,   407,   253,  1243,   244,  1245,   407,
       3,     3,   249,   250,   251,   411,     3,     3,   344,     3,
     120,     3,    19,     3,     3,     3,   126,     3,     3,  1482,
     181,   181,    46,    14,   412,     3,    27,  1284,    15,   409,
      28,    30,  1495,    33,  1451,    19,    15,   373,   374,  1486,
    1503,    19,  1505,     7,  1301,  1302,     3,  1304,   413,    73,
      74,    75,   407,    77,    78,  1312,    80,   407,  1315,  1437,
      84,  1439,    86,    87,   255,  1376,   408,   407,   407,     8,
       9,    10,    11,    12,    19,   136,   407,    51,  1325,  1326,
    1327,   191,   192,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   116,    76,    33,    76,   120,   121,   407,   309,
     124,   125,  1349,   407,   412,   174,   130,  1570,    86,   407,
     407,  1615,  1575,    31,  1577,   183,    76,    76,   228,   229,
     230,   231,   232,   233,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    76,    76,   245,  1393,    73,   248,   183,
     118,   119,    78,   253,   168,   407,   117,   407,   126,   173,
     408,  1614,    69,  1616,    19,  1402,  1403,   415,  1405,     8,
       9,    10,    11,    12,   407,   407,     3,   407,   407,   407,
    1481,   407,   407,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   276,   161,    33,   409,   122,   407,    19,     3,
      15,    19,    19,    19,    13,     3,    15,    16,    17,    18,
      19,    20,  1665,    20,    15,  1652,  1653,  1654,    27,    28,
      15,    30,    15,    32,   409,  1678,   254,   413,    28,  1636,
     413,  1638,    15,   201,    18,   408,   407,   163,    20,  1486,
    1487,   407,   407,   411,  1697,  1698,   413,   407,  1701,    28,
     131,   407,   407,   407,   407,  1708,  1709,  1504,   407,   407,
     407,   407,  1509,   407,  1511,  1512,   409,  1514,    19,   407,
     407,  1724,  1766,   407,   407,   407,     3,  1730,   407,  1732,
    1733,    13,   407,    15,    16,    17,    18,    19,    20,    69,
    1527,   407,   407,   407,   407,    27,    28,    29,    30,   407,
      32,  1538,  1539,  1540,  1541,     3,   407,    15,   408,     3,
     407,   120,   407,   407,     3,   415,   407,   126,   407,   407,
     407,  1568,   407,  1776,   407,     3,     3,   183,    28,   183,
     256,  1578,  1579,  1580,   413,  1582,  1583,    28,   407,    13,
    1587,    15,    16,    17,    18,    19,    20,  1594,   409,   181,
     407,   407,   407,    27,    28,    29,    30,   407,    32,  1606,
    1607,   413,   407,  1610,   407,   407,  1613,   407,   407,   407,
      13,   407,    15,    16,    17,    18,    19,    20,  1625,   324,
     407,   407,   191,   192,    27,    28,   407,    30,   120,    32,
     407,   407,   375,    22,   126,   408,   407,     3,   412,  1805,
    1806,  1807,   328,     3,    15,  1652,  1653,  1654,    15,    28,
     413,  1658,  1818,   413,    15,    69,   412,    15,    22,   228,
     229,    29,  1669,  1670,  1671,  1672,  1673,    29,  1834,  1835,
    1836,  1837,    28,     7,   183,   407,   245,    19,  1685,   248,
    1687,   411,   407,   266,   253,   411,   120,     3,   411,   411,
     407,   411,   126,  1700,   413,   407,   412,   383,   411,   191,
     192,   409,   388,  1710,     3,   411,   409,   409,  1715,  1716,
    1717,   409,   408,    15,   263,   409,   402,   120,  1725,   409,
     409,  1728,  1729,   126,   409,   226,   408,   408,    13,   408,
      15,    16,    17,    18,    19,    20,   228,   229,   408,  1736,
      29,   407,    27,    28,    29,    30,    29,    32,     7,   407,
     411,   411,   260,   245,   407,   407,   248,   191,   192,    46,
      13,   253,    15,    16,    17,    18,    19,    20,   283,   407,
     407,     7,   412,   409,    27,    28,    29,    30,   409,    32,
     345,   346,   347,   348,   349,   350,   351,   352,   191,   192,
     409,   413,   409,   137,   228,   229,   408,   261,   409,    86,
     261,    13,   261,    15,    16,    17,    18,    19,    20,   146,
     409,   245,   324,   411,   248,    27,    28,    29,    30,   253,
      32,   319,   379,   361,   347,   228,   229,   283,   369,   116,
     377,   345,    76,   120,   121,   120,   407,   124,   125,   408,
     409,   126,   245,   130,   407,   248,   415,   319,   361,    13,
     253,    15,    16,    17,    18,    19,    20,    76,    76,   369,
     395,   397,   407,    27,    28,    20,    30,   120,    32,   360,
     407,   360,   355,   126,     8,     9,    10,    11,    12,   412,
     412,   168,   407,   380,   413,   407,   173,   407,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   413,   546,    33,
     407,   856,   407,   409,    96,   407,   191,   192,   120,   409,
     352,   407,   407,   105,   126,   254,   408,   407,   110,   407,
     112,   407,   114,   415,   116,   407,   118,   407,   120,  1618,
    1112,  1317,     8,     9,    10,    11,    12,  1022,   191,   192,
    1013,  1747,   734,   228,   229,  1098,    22,    23,    24,    25,
      26,    27,    28,    29,    30,  1102,   120,    33,   373,  1094,
     245,  1266,   126,   248,   577,  1522,   906,  1636,   253,     8,
       9,    10,    11,    12,   408,   228,   229,   827,   187,   191,
     192,   415,   828,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   245,  1638,    33,   248,   833,  1211,  1326,  1405,
     253,  1057,  1426,  1372,   407,   408,  1388,  1117,   947,  1434,
      -1,    -1,   415,   143,   144,    -1,   228,   229,  1000,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,
      -1,   161,    -1,   245,    -1,    -1,   248,    -1,    -1,    -1,
      -1,   253,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,
      -1,    -1,     8,     9,    10,    11,    12,   187,    -1,   189,
     190,    -1,    -1,    -1,   228,   229,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,
      -1,   245,    -1,    -1,   248,    -1,    -1,    -1,    -1,   253,
       8,     9,    10,    11,    12,    -1,    -1,   384,   385,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,    -1,     8,     9,    10,
      11,    12,    -1,   408,    -1,   412,   256,    -1,    -1,    -1,
     415,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,     8,
       9,    10,    11,    12,    -1,   408,    -1,    -1,    -1,    -1,
      -1,    -1,   415,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,   219,   220,   221,   222,   223,
       8,     9,    10,    11,    12,    -1,   408,    -1,   328,    -1,
      -1,    -1,    -1,   415,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,    -1,    -1,   408,     8,     9,    10,    11,    12,
      -1,   415,    -1,    -1,    -1,    -1,    -1,    -1,   388,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,    -1,   402,    -1,    -1,   409,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,     8,     9,
      10,    11,    12,   409,    -1,    -1,    -1,    19,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,    -1,    -1,    -1,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
     409,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,    -1,    -1,    -1,   120,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   409,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    19,    -1,    33,    -1,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,   409,    33,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,   409,    33,
     202,   203,   204,   205,   206,   207,   208,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,   224,    -1,    -1,   227,    -1,    -1,    -1,    -1,
     409,    -1,    -1,    82,    83,    -1,    -1,    -1,    -1,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,    -1,    -1,    -1,
      -1,   409,    -1,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,   219,   220,   221,   222,   223,    -1,   138,
      -1,    -1,    82,    83,    -1,    -1,    -1,   409,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   409,    19,   177,    46,
      42,    -1,    -1,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,   219,   220,   221,   222,   223,    -1,    66,
      -1,    -1,    -1,    -1,    66,    67,    -1,   409,    -1,    51,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   409,    -1,   234,   235,   177,   237,   238,
     239,   240,   241,   242,   243,    -1,    -1,    -1,    -1,   116,
      -1,    -1,    -1,   120,   121,    -1,    -1,   124,   125,   409,
     412,    -1,    -1,   130,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   137,    -1,   139,   120,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   407,   286,   287,   288,
     289,   290,   291,   292,   293,   294,    -1,    -1,    -1,    -1,
      -1,   168,    -1,    -1,   166,   167,   173,    -1,    -1,    -1,
      -1,    -1,   407,   312,   313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   189,   409,    -1,    -1,    -1,    -1,   327,   188,
      -1,   330,   331,   332,   333,    -1,    -1,    -1,   407,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   286,   287,   288,   289,
     290,   291,   292,   293,   294,    -1,    -1,    -1,    -1,    -1,
     202,   203,   204,   205,   206,   207,   208,    46,    -1,   407,
      -1,    -1,   312,   313,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,    -1,    -1,   227,    -1,   327,    -1,    -1,
     330,   331,   332,   333,   256,    46,   407,   259,   260,    -1,
      51,   400,   401,    -1,    -1,   267,    -1,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    46,    -1,    -1,
      -1,   280,    -1,   407,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    -1,    -1,    86,    -1,   116,    -1,    -1,
      -1,   120,   121,    -1,   123,   124,   125,   314,    -1,    -1,
      -1,   130,    -1,    -1,    -1,    84,   318,    86,    -1,    -1,
     400,   401,    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,
     121,   122,   123,   124,   125,    -1,   335,    -1,    -1,   130,
      -1,    46,    -1,   134,    -1,    -1,   137,   116,   139,   168,
      -1,   120,   121,    -1,   173,   124,   125,    66,   357,    -1,
     359,   130,    -1,    -1,    -1,   364,   368,   366,    -1,    -1,
      -1,   370,   371,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,    86,   173,   385,    -1,    -1,    -1,    -1,   390,   391,
      -1,   393,   394,    -1,   396,    -1,    -1,    -1,   189,   168,
     191,    -1,    -1,    -1,   173,   412,    -1,    -1,    -1,   200,
     412,   116,    -1,   412,    -1,   120,   121,    -1,   123,   124,
     125,    -1,    46,    -1,    -1,   130,    -1,    -1,   137,   411,
      -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    66,    -1,   263,   264,    -1,   238,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,   167,    33,
      -1,    -1,    86,   168,    -1,   256,    -1,    -1,   173,    -1,
      -1,   180,   263,   264,    -1,   266,    -1,    -1,    46,    -1,
     271,   272,    -1,   274,   275,    -1,   277,   196,    -1,   280,
     281,   282,   116,    -1,    -1,    -1,   120,   121,    -1,   123,
     124,   125,    -1,    -1,   295,   296,   130,    75,    -1,   300,
      -1,   302,   303,    -1,   305,    -1,    -1,    -1,    86,   310,
      -1,    -1,    -1,   314,   315,    -1,   317,   318,    -1,   320,
     321,   322,    -1,    -1,    -1,   326,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,   168,    -1,    -1,   256,   116,   173,
     259,   260,   120,   121,    18,    19,   124,   125,   267,    -1,
     329,    -1,   130,    -1,    -1,   334,   335,   336,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,   153,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   412,    71,    72,    -1,    -1,    -1,   368,
     168,    -1,    -1,    -1,    81,   173,   375,    -1,    -1,   318,
      -1,    -1,   321,    -1,    -1,   324,    -1,    -1,    -1,    -1,
      -1,   412,    86,    -1,    -1,    -1,   335,    -1,   337,    -1,
     339,   340,   341,   342,   343,   344,    -1,    -1,    -1,    -1,
      -1,   350,    -1,   412,   353,    -1,    -1,   356,    -1,    -1,
      -1,   225,    -1,    -1,   118,    -1,    -1,   134,    -1,   368,
      -1,   125,   126,   368,    -1,    -1,    -1,   376,    -1,    -1,
      -1,    -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   389,    -1,    -1,    -1,    -1,   153,
     154,   155,   156,   170,   158,   159,   173,    -1,   175,    -1,
      -1,    -1,    -1,   412,    -1,   182,    -1,   412,    -1,   186,
      -1,    -1,    -1,    -1,   191,   192,   193,    -1,    -1,     3,
      -1,   198,   199,   200,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,    -1,    -1,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,    -1,
      -1,   255,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   412
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   418,   419,    46,    71,    72,    81,   134,   170,
     173,   175,   182,   186,   191,   192,   193,   198,   199,   200,
     443,   444,   445,   446,   447,   448,   507,   508,   509,   510,
     512,   513,   514,   517,   520,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   550,   619,   656,
     657,   658,   659,   660,   661,   662,   663,   678,   679,   689,
     691,     0,     3,    34,    43,    46,    57,    70,    80,    86,
     116,   118,   119,   126,   161,   162,   173,   198,   201,   407,
     420,   432,   438,   441,   442,   451,   454,   457,   459,   462,
     464,   465,   467,   468,   475,   485,   486,   553,   555,   565,
     603,   606,   620,   622,   623,   624,   665,   666,   667,   670,
     680,   681,   690,   692,   693,   694,    19,    20,    45,   551,
      20,    56,    64,    65,    66,   449,     3,   551,   551,   171,
     172,   551,    79,   551,     3,   161,   143,   144,   161,   176,
     187,   189,   190,   256,   328,   388,   402,   161,   161,    79,
     141,   143,   144,   194,   195,   196,   197,    13,    15,    16,
      17,    18,    19,    20,    27,    28,    30,    32,   120,   126,
     191,   192,   228,   229,   245,   248,   253,   408,   415,   570,
     582,   587,   590,   591,   592,   594,   596,    36,    45,   411,
     536,   551,    19,    19,    20,    44,    55,   430,   434,    68,
     143,   157,    43,    62,   118,   189,   439,   440,    50,    67,
      81,    19,   117,    19,    86,   163,    79,   143,   430,   596,
      19,    19,   138,   469,   469,   411,    73,    78,   122,   163,
     256,   328,   383,   388,   402,   469,    46,    66,    86,   116,
     120,   121,   123,   124,   125,   130,   168,   173,   412,   470,
     488,   469,   469,    51,    66,    80,   122,   123,   134,   137,
     139,   189,   191,   200,   238,   256,   263,   264,   266,   271,
     272,   274,   275,   277,   280,   281,   282,   295,   296,   300,
     302,   303,   305,   310,   314,   315,   317,   318,   320,   321,
     322,   326,   412,   470,   469,    84,   329,   334,   335,   336,
     368,   375,   412,   470,   625,   626,   627,   469,   384,   385,
     412,   470,   469,   469,    66,   189,   314,   412,   470,   682,
     685,    73,    74,    75,    77,    78,    80,    84,    87,   412,
     453,   456,   470,    75,   153,   412,   455,   470,    36,    45,
     411,   489,   449,     3,     3,   449,    67,   450,     3,     3,
     551,   551,     3,   495,   547,    36,    45,   411,   492,    86,
     522,    19,    20,    45,   552,     3,   188,   518,     3,     3,
     515,   521,   270,    19,   123,   196,   367,   381,   382,   511,
     144,   196,   511,    18,    19,   424,   426,   426,     3,     3,
       3,     3,     3,     3,     3,     3,    15,    19,    29,   408,
     414,   586,   588,   594,    30,   408,   254,    28,   254,    15,
     414,   589,   596,   408,   408,   408,   408,   408,   408,   230,
     231,   232,   233,   575,   596,    15,    16,    17,    19,   408,
     570,   571,   574,   576,   577,   578,   580,   582,   583,   584,
       5,    82,    83,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   138,   177,   234,   235,   237,   238,   239,   240,   241,
     242,   243,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   312,   313,   327,   330,   331,   332,   333,   400,   401,
     595,   695,     3,     8,     9,    10,    11,    12,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    33,    46,    47,
      48,    49,    50,    51,    52,    53,    54,   436,   437,    15,
     537,     3,    22,    63,   433,    45,   411,   435,    15,    19,
      35,    36,    37,    38,    69,   408,   421,   423,   489,   421,
      20,    58,    59,   407,   421,   422,   422,   180,   169,   463,
      15,    17,    18,    19,   138,   408,   458,   554,    19,   460,
     411,   495,   496,   492,   407,   566,   138,    19,   411,   411,
     466,   411,   489,   324,    19,   474,   117,   421,   423,   487,
      45,    69,   126,   127,   135,   255,   471,   562,    69,   471,
      69,   430,   492,   407,   407,   411,   411,   180,   284,   324,
      81,   407,    20,   285,   430,   423,    69,    85,   189,   299,
     325,   166,   423,   407,   421,   424,   621,   183,   424,    76,
     273,   283,    76,   271,   278,   287,   288,    87,   283,   297,
     298,   297,   301,   423,   304,   306,   311,    86,    87,   122,
     316,    87,   319,   317,   423,   266,   423,   407,   411,   366,
     458,   423,   116,   421,   423,   117,   407,   411,   411,    86,
     386,   387,   407,   411,   411,   324,   426,    86,   407,   207,
     276,   307,   316,   403,   404,   405,   406,   411,   688,    86,
     423,    76,   423,    79,    81,    85,   421,   407,   407,   407,
      76,    20,   431,   407,   407,    79,   128,   129,   141,   142,
     144,   490,   491,     3,   450,     3,   421,     3,     3,     3,
      86,   126,   140,   497,   548,   549,   562,     3,   128,   174,
     493,   494,     3,    19,     3,   552,     3,     3,     3,    86,
     156,   171,   183,   519,     3,    45,    86,   118,   125,   126,
     136,   153,   154,   155,   156,   158,   159,   426,   516,   562,
       3,    19,    86,   118,   119,   126,   161,   201,   511,   511,
     511,   664,    45,   511,    45,   511,     3,   511,   511,     3,
      30,   410,   428,   181,   181,     7,   588,   588,   596,   588,
     588,    14,    15,   596,   600,   601,    27,    28,   254,    28,
     589,   589,    30,   596,   596,   596,   596,   596,    19,    15,
     413,   409,   413,    29,   573,   575,   596,     7,   413,   416,
      27,    28,   411,   413,   416,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   596,   596,   596,   211,
     236,   244,   249,   250,   251,   412,   413,     3,   596,   430,
     436,   407,   422,   596,   421,    60,    61,    60,    61,    39,
      40,    41,   421,   482,   483,   596,   407,   209,   210,   211,
     212,   213,   214,   215,   216,   218,   219,   220,   221,   222,
     223,   556,   557,   558,   560,   564,    42,   164,   165,   166,
     407,   461,   495,   407,   407,   408,   563,    19,   161,   412,
     423,   458,   476,   479,   480,    36,   421,   473,    19,   560,
     561,   136,   596,   473,   473,   605,    76,    76,   423,    76,
     323,   423,   407,    51,   407,   407,   421,   259,   260,   423,
     309,   423,   174,   424,   407,   407,    31,   425,    42,   183,
     407,   421,   183,   421,    76,    76,   421,    76,   135,   279,
     421,   421,   423,    76,   407,   117,   407,   423,   407,   423,
     279,   307,   308,   423,   474,   423,   407,   407,   423,   423,
     423,   407,   183,   407,   423,   423,    69,   421,   628,    19,
     407,   407,   669,   423,   474,    20,   424,   424,   276,   683,
     684,   687,   407,   421,   421,   423,   423,   423,   421,   424,
     426,   427,   412,   413,     3,    20,   474,   499,   561,   430,
     549,   412,   413,     3,    19,    15,   426,    19,    19,   561,
     427,    19,     3,    20,   655,   655,     3,    19,   116,   279,
     324,   329,   344,   373,   374,   511,   655,   511,   655,   655,
     655,   421,   424,    15,    15,    15,   409,   413,   409,   254,
      28,   413,   413,   413,   409,   413,   409,   413,   596,   596,
     413,     7,   413,   413,   409,    18,   408,   571,   578,    15,
      18,   583,   408,   437,   407,   412,   409,    20,   407,   480,
     407,   409,    19,   217,   407,   411,   421,   424,    86,   184,
     185,   497,   498,   500,   409,   557,   559,   564,   426,   407,
      28,   478,   413,   131,   472,   423,   123,   263,   264,   412,
     470,   604,   421,   421,   407,   421,   407,   407,   423,   407,
     407,   407,   407,   423,   407,   423,   407,    19,   621,   421,
     421,   407,   421,   407,   421,   421,   407,   421,   407,   407,
     407,   407,   407,   421,   458,   407,   407,   407,   407,   407,
     407,   407,   407,   407,   407,   407,   407,   421,   421,   123,
     188,   280,   335,   357,   359,   364,   366,   370,   371,   412,
     629,   636,   639,   407,   123,   368,   389,   412,   470,   668,
     407,   407,   425,   424,   256,   369,   683,    19,    51,   120,
     202,   203,   204,   205,   206,   207,   208,   224,   227,   256,
     412,   592,   593,   597,   602,   686,    69,   452,   491,   494,
       3,     3,   458,   458,    15,   458,   655,     3,   655,     3,
       3,     3,   183,   183,   588,   600,    28,    28,   596,   596,
     596,   596,   596,   413,   409,   413,    29,   573,   596,   573,
      29,   573,   573,   596,   413,   596,   558,   567,   568,   602,
     499,   421,   430,   412,   500,   407,   407,   409,   181,    20,
     427,   477,   479,    81,   132,   133,   134,   607,   613,   607,
     614,   424,   618,   407,   413,   407,   407,   407,   407,   407,
     407,   407,   407,   407,   407,   407,   407,   407,   648,   654,
     423,   337,   338,   370,   337,   423,   630,   324,   426,   632,
     633,   631,   372,   423,   407,   375,   649,   671,   677,   423,
     421,   407,   425,   423,   421,    22,   408,    22,   408,   596,
     596,   596,   423,   595,   695,   407,   596,   598,   599,   421,
       3,     3,    15,    15,    28,   409,   409,   409,   409,   413,
     596,   596,   409,   413,     7,   409,   413,   409,   413,     7,
     409,   413,   413,    15,   409,   412,   602,   407,   559,    15,
     427,   480,   481,   411,   612,    31,   265,   615,   421,   480,
     650,   421,   421,   423,   421,   411,   458,   411,   411,   421,
     421,   411,   481,    69,   596,   601,   596,   592,   407,   225,
     411,   407,    22,    22,    33,   413,   407,   522,   522,    28,
     596,   409,   409,    29,   573,    29,   573,    29,   573,     7,
      29,   573,    29,   573,   412,   183,   612,   611,   608,    19,
     430,   266,   616,   407,   651,   411,   653,   641,   634,   641,
     637,   411,   676,   421,   407,   409,   407,   695,   411,   569,
     602,   585,   596,   596,   126,   191,   192,   248,   254,   599,
       3,     3,   409,   409,   409,   409,   413,     7,   409,   409,
     409,   413,   408,   409,     7,   409,   409,     7,   409,    15,
     608,   137,   139,   167,   257,   258,   261,   262,   267,   412,
     501,   503,   504,   609,   424,   263,   617,   649,   652,   412,
     426,   642,   643,   188,   337,   358,   412,   635,   412,   180,
     267,   339,   340,   341,   343,   412,   501,   638,   675,   672,
     409,   567,   226,     6,    15,    16,    17,   408,   412,   570,
     572,   574,   576,   577,   579,   581,   407,   407,   408,   408,
     408,   408,   407,    29,   573,    29,   573,   573,     7,   573,
     407,   430,   423,   411,   259,   260,   260,   422,   421,   127,
     146,   268,   269,   610,   411,   407,   423,    66,   180,   196,
     256,   259,   260,   267,   318,   321,   324,   335,   337,   339,
     340,   341,   342,   343,   344,   350,   353,   356,   368,   376,
     412,   501,   640,   358,   365,   644,   423,   421,   423,   407,
     421,   127,   268,   354,   421,   421,   283,   155,   421,   407,
      42,    66,    67,    87,   139,   166,   256,   259,   260,   267,
     318,   368,   385,   390,   391,   393,   394,   396,   412,   501,
     673,   407,   412,   569,   567,   596,     7,   410,   413,   596,
     596,   596,   596,   409,   409,   409,   413,   409,   408,   409,
     502,   503,   261,   261,   261,   148,   149,   146,   117,   138,
     140,   145,   160,   206,   505,   324,   421,   411,   423,   361,
     178,   179,   342,   378,   484,   127,   268,   354,   319,   423,
     379,   423,   421,   421,   421,   283,   421,   155,   421,   345,
     346,   347,   348,   349,   350,   351,   352,   377,   347,   421,
     369,   345,   407,   421,   407,   421,   421,   421,   324,   398,
      76,   421,   423,   424,   423,   361,   342,   378,   484,   127,
     148,   354,   399,   674,   319,   369,   345,   392,    76,    76,
     360,   421,   395,   397,   407,   409,   408,   572,   567,   579,
     409,   409,   409,   409,   573,   573,   412,   407,   422,   422,
     422,   148,   149,   421,    20,   429,   429,   146,   147,   506,
     138,   140,   138,   140,   412,   423,   645,   362,   363,   421,
     421,   421,   421,   421,   260,   423,   380,   421,   421,   423,
     423,   421,   423,   423,   423,   421,   421,   421,   421,   260,
     423,   421,   421,   421,   423,   423,   423,   596,   407,   407,
     407,   407,   409,   413,   502,   407,   407,   407,   148,   149,
     150,   151,   152,   148,   149,   150,   151,   152,   407,   429,
     429,   429,   429,   412,   424,   647,   360,   423,   360,   573,
     505,   505,   505,   505,   407,   407,   407,   407,   355,   646,
     413,   505,   505,   505,   505,   407,   573,   409
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 808 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 809 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 822 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 832 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 833 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 840 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000000; }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 841 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000; }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 842 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1; }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 850 "cf-parse.y"
    { (yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 851 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 852 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 853 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 854 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 855 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 862 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 869 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 870 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 874 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 882 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 886 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 890 "cf-parse.y"
    {
     (yyval.i) = ipa_masklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 897 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 906 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[(1) - (1)].s)).s;
   }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 913 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 914 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 920 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 929 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 930 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 934 "cf-parse.y"
    {
     struct rfile *rf = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!rf) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = rf->f;
   }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 939 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 940 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 944 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 945 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 949 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 950 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 954 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 955 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 956 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 957 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 958 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 959 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 960 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 961 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 962 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 968 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 969 "cf-parse.y"
    { add_tail(&new_config->mrt_table_dumps, &this_mrt_table_config->n); }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 970 "cf-parse.y"
    {
     struct rfile *rf = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!rf) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrt_proto_file = fileno(rf->f);
   }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 979 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 980 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 981 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 982 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 985 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 986 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 987 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 988 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 989 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){NULL, NULL, 0}; }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 990 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 1000 "cf-parse.y"
    { new_config->latency_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 1001 "cf-parse.y"
    { new_config->latency_limit = (yyvsp[(4) - (4)].i32); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 1002 "cf-parse.y"
    { new_config->watchdog_warning = (yyvsp[(3) - (3)].i32); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 1003 "cf-parse.y"
    { new_config->watchdog_timeout = ((yyvsp[(3) - (3)].i32) + 999999) TO_S; }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 1012 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 1015 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 1022 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 1025 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 1028 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 1031 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 1034 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 1039 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 1040 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 1041 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 1049 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 1054 "cf-parse.y"
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 1055 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) <= 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 1059 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 1060 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 1064 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 1071 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 1072 "cf-parse.y"
    { THIS_KRT->graceful_restart = (yyvsp[(3) - (3)].i); }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 1073 "cf-parse.y"
    {
      THIS_KRT->merge_paths = (yyvsp[(3) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[(3) - (4)].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 1085 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 1090 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1094 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 1108 "cf-parse.y"
    { THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i); }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 1109 "cf-parse.y"
    { THIS_KRT->sys.metric = (yyvsp[(2) - (2)].i); }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 1123 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1124 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1128 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1129 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1131 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 1138 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[(1) - (1)].s)).i;
#ifndef IPV6
     else if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[(1) - (1)].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 1160 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1161 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1162 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 1163 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1168 "cf-parse.y"
    { new_config->gr_wait = (yyvsp[(4) - (5)].i); }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1174 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1175 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1179 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1187 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 1193 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 1207 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1208 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1212 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1218 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1222 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[(2) - (2)].s)->class != SYM_TEMPLATE) && ((yyvsp[(2) - (2)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(2) - (2)].s)->def);
   }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1231 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1242 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1246 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1247 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1248 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1249 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1250 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1251 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1252 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1253 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1254 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1255 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1256 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1257 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1261 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1263 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 1264 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1268 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1269 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1270 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 1271 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 1272 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1276 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1282 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 1286 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1294 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1295 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1303 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 1311 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1312 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1313 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1317 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 1318 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 1332 "cf-parse.y"
    { iface_patt_check(); }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1334 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1346 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 1347 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1353 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1363 "cf-parse.y"
    { DIRECT_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 1367 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 1381 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 1382 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1383 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1388 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 1392 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1393 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 1394 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 1395 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1396 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 1397 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1403 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 1404 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1405 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1410 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1414 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1415 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1421 "cf-parse.y"
    {
   this_mrt_table_config = mrt_table_new_config();
 }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1432 "cf-parse.y"
    {
     if (this_mrt_table_config->c.filter != FILTER_ACCEPT)
       cf_error("Filter specified twice");
     this_mrt_table_config->c.filter = (yyvsp[(1) - (1)].f);
   }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 1437 "cf-parse.y"
    {
     if (this_mrt_table_config->c.filter != FILTER_ACCEPT)
       cf_error("Filter specified twice");
     this_mrt_table_config->c.filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1451 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].r)->name; }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1452 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1456 "cf-parse.y"
    { this_mrt_table_config->c.period = (yyvsp[(2) - (2)].i); }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1457 "cf-parse.y"
    { this_mrt_table_config->c.filename_fmt = (yyvsp[(2) - (2)].t); }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1458 "cf-parse.y"
    { this_mrt_table_config->rtable_wildcard_name = (yyvsp[(2) - (2)].t); }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1480 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->length = strlen((yyvsp[(2) - (2)].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1500 "cf-parse.y"
    { }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1501 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1502 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1503 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1504 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1505 "cf-parse.y"
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[(2) - (4)].time); }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1506 "cf-parse.y"
    { this_p_item->gento = this_p_item->accto = (yyvsp[(2) - (4)].time); }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1507 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1508 "cf-parse.y"
    { this_p_item->alg = (yyvsp[(2) - (4)].i); }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1512 "cf-parse.y"
    { (yyval.i) = ALG_MD5; }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1513 "cf-parse.y"
    { (yyval.i) = ALG_SHA1; }
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1514 "cf-parse.y"
    { (yyval.i) = ALG_SHA256; }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1515 "cf-parse.y"
    { (yyval.i) = ALG_SHA384; }
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1516 "cf-parse.y"
    { (yyval.i) = ALG_SHA512; }
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1517 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_MD5; }
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1518 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA1; }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1519 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA256; }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1520 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA384; }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1521 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA512; }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1528 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1531 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1534 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1537 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1541 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1545 "cf-parse.y"
    { if_show(); }
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1548 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1552 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1555 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1560 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1566 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1573 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1578 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1583 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1588 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1592 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1596 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1600 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1609 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1617 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1621 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1628 "cf-parse.y"
    { (yyval.i) = RSEM_PREEXPORT; }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1629 "cf-parse.y"
    { (yyval.i) = RSEM_EXPORT; }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1630 "cf-parse.y"
    { (yyval.i) = RSEM_NOEXPORT; }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1636 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1639 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1646 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1653 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1657 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1665 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1666 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1667 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1673 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1676 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1679 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1680 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1681 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1682 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1683 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1684 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1685 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1690 "cf-parse.y"
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1695 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1704 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1711 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1718 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1726 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1728 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1730 "cf-parse.y"
    { io_log_dump(); cli_msg(0, ""); }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1732 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1734 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1736 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 1738 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1740 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1743 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 1746 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1752 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1753 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1754 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1758 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 1759 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1766 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1768 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1770 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1772 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 1774 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 1776 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 1780 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1784 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1788 "cf-parse.y"
    {
  this_mrt_table_config->c.cli = this_cli;
  this_mrt_table_config->c.config = NULL;
  mrt_table_cli_cmd(this_mrt_table_config);
}
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 1805 "cf-parse.y"
    { this_mrt_table_config->rtable_wildcard_name = (yyvsp[(2) - (2)].t); }
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 1806 "cf-parse.y"
    { this_mrt_table_config->c.filename_fmt = (yyvsp[(2) - (2)].t); }
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 1811 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 1814 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 1815 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 1816 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 1820 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 1821 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 1822 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 1830 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 1831 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 1840 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 1844 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 1845 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 321:
/* Line 1792 of yacc.c  */
#line 1846 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 1847 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 1848 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 1849 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 1850 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 1851 "cf-parse.y"
    { (yyval.i) = T_LC; }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 1852 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 1853 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 1854 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 1855 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 1856 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 1857 "cf-parse.y"
    { (yyval.i) = T_LCLIST; }
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 1858 "cf-parse.y"
    {
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 1880 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 1891 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 1892 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 1899 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 1900 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 1907 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 1916 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 1924 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 1948 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 1949 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 1953 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 1966 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 1969 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name);
     cf_pop_scope();
   }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 1982 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 1983 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 1986 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 1987 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 1991 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 1994 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 2003 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 2016 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 2017 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 2018 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 2019 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 2020 "cf-parse.y"
    {
     (yyval.v) = f_eval((yyvsp[(2) - (3)].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 2024 "cf-parse.y"
    {
     if (!cf_symbol_is_constant((yyvsp[(1) - (1)].s))) cf_error("%s: constant expected", (yyvsp[(1) - (1)].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[(1) - (1)].s)))) cf_error("%s: set-incompatible type", (yyvsp[(1) - (1)].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[(1) - (1)].s)->def);
   }
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 2032 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 2033 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 2034 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 2035 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 2036 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 2040 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); }
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 2045 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), 0, CC_ALL); }
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 2046 "cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 2047 "cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 2048 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, CC_ALL); }
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 2049 "cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); }
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 2050 "cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 2051 "cf-parse.y"
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 2053 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (11)].i32), (yyvsp[(8) - (11)].i32), (yyvsp[(4) - (11)].i32), (yyvsp[(10) - (11)].i32)); }
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 2057 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 2058 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 2059 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 2060 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 2064 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 2065 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 2066 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 2070 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2071 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 2072 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, LC_ALL); }
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 2073 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), 0, LC_ALL); }
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2074 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), 0, LC_ALL, 0, LC_ALL); }
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 2075 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), 0, LC_ALL, 0, LC_ALL); }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 2076 "cf-parse.y"
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2078 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (15)].i32), (yyvsp[(10) - (15)].i32), (yyvsp[(4) - (15)].i32), (yyvsp[(12) - (15)].i32), (yyvsp[(6) - (15)].i32), (yyvsp[(14) - (15)].i32)); }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 2085 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 2086 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2093 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2094 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 2099 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 2104 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 2108 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2115 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2116 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2117 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2118 "cf-parse.y"
    {
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2125 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2126 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2129 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2130 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2137 "cf-parse.y"
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2149 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2150 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2154 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2155 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2159 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2160 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(4) - (4)].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[(1) - (4)].i); (yyval.h)->val2 = (yyvsp[(3) - (4)].i); }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2161 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; }
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2162 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2163 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2164 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2168 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2169 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; }
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2170 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2174 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2175 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2176 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2177 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2178 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2179 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2180 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2181 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2182 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2183 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2184 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2188 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2189 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 2190 "cf-parse.y"
    { (yyval.x) = f_generate_lc((yyvsp[(2) - (7)].x), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2204 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2227 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2241 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2242 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2243 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2244 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2245 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2246 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 2247 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 2248 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 2249 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 2250 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 2254 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 2255 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 2256 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 2257 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 2258 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 2259 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 2260 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 463:
/* Line 1792 of yacc.c  */
#line 2261 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 2262 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 465:
/* Line 1792 of yacc.c  */
#line 2263 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 2264 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 2265 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 2266 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 2267 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 2268 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','~');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 2269 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 2270 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 2272 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 2273 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 2274 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 2276 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 2278 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 2280 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 2282 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 2283 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 2284 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 2285 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 2286 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 2287 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','L'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 2297 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 2298 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 2299 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 2300 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_LCLIST; }
    break;

  case 489:
/* Line 1792 of yacc.c  */
#line 2301 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 2302 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 2303 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 2304 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 2306 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 2307 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 2312 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 2335 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 2336 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 2337 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 2338 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 2339 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 2340 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 2344 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 2347 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 2348 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 2349 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 2357 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 2364 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 2373 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 2374 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 510:
/* Line 1792 of yacc.c  */
#line 2378 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 2384 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 512:
/* Line 1792 of yacc.c  */
#line 2394 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 513:
/* Line 1792 of yacc.c  */
#line 2403 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 2409 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 515:
/* Line 1792 of yacc.c  */
#line 2414 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 2421 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 2426 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 2432 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 2433 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 2434 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 2442 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 2443 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 2444 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 2445 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 2446 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 2453 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[(1) - (2)].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 2480 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 2494 "cf-parse.y"
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 2514 "cf-parse.y"
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[(2) - (2)].i32); }
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 2515 "cf-parse.y"
    { BFD_IFACE->min_rx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 2516 "cf-parse.y"
    { BFD_IFACE->min_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 2517 "cf-parse.y"
    { BFD_IFACE->idle_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 2518 "cf-parse.y"
    { BFD_IFACE->multiplier = (yyvsp[(2) - (2)].i); }
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 2519 "cf-parse.y"
    { BFD_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 2520 "cf-parse.y"
    { BFD_IFACE->auth_type = (yyvsp[(2) - (2)].i); }
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 2521 "cf-parse.y"
    {}
    break;

  case 544:
/* Line 1792 of yacc.c  */
#line 2525 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_NONE; }
    break;

  case 545:
/* Line 1792 of yacc.c  */
#line 2526 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_SIMPLE; }
    break;

  case 546:
/* Line 1792 of yacc.c  */
#line 2527 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 2528 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 2529 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 2530 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 2548 "cf-parse.y"
    { BFD_CFG->multihop = BFD_IFACE; }
    break;

  case 556:
/* Line 1792 of yacc.c  */
#line 2552 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 557:
/* Line 1792 of yacc.c  */
#line 2553 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 2554 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 2558 "cf-parse.y"
    { (yyval.a) = IPA_NONE; }
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 2559 "cf-parse.y"
    { (yyval.a) = (yyvsp[(2) - (2)].a); }
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 2563 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 562:
/* Line 1792 of yacc.c  */
#line 2564 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 563:
/* Line 1792 of yacc.c  */
#line 2568 "cf-parse.y"
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[(1) - (4)].a);
  BFD_NEIGHBOR->local = (yyvsp[(3) - (4)].a);
  BFD_NEIGHBOR->iface = (yyvsp[(2) - (4)].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[(4) - (4)].i);

  if ((yyvsp[(4) - (4)].i) && (yyvsp[(2) - (4)].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[(4) - (4)].i) && ipa_zero((yyvsp[(3) - (4)].a)))
    cf_error("Multihop neighbor requires specified local address");
}
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 2587 "cf-parse.y"
    { bfd_show_sessions(proto_get_named((yyvsp[(4) - (5)].s), &proto_bfd)); }
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 2592 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[(1) - (2)].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->setkey = 1;
 }
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 2619 "cf-parse.y"
    { BGP_CFG->remote_port = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Invalid port number");  }
    break;

  case 568:
/* Line 1792 of yacc.c  */
#line 2620 "cf-parse.y"
    { BGP_CFG->remote_as = (yyvsp[(3) - (3)].i); }
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 2626 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 2627 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 574:
/* Line 1792 of yacc.c  */
#line 2629 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     if ((yyvsp[(4) - (6)].iface)) BGP_CFG->iface = (yyvsp[(4) - (6)].iface);
   }
    break;

  case 575:
/* Line 1792 of yacc.c  */
#line 2635 "cf-parse.y"
    { BGP_CFG->iface = if_get_by_name((yyvsp[(3) - (4)].t)); }
    break;

  case 576:
/* Line 1792 of yacc.c  */
#line 2636 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 577:
/* Line 1792 of yacc.c  */
#line 2637 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 578:
/* Line 1792 of yacc.c  */
#line 2638 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 579:
/* Line 1792 of yacc.c  */
#line 2639 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 2640 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 2641 "cf-parse.y"
    { BGP_CFG->multihop = 0; }
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 2642 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 583:
/* Line 1792 of yacc.c  */
#line 2643 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 2644 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 585:
/* Line 1792 of yacc.c  */
#line 2645 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 2646 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 2647 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 588:
/* Line 1792 of yacc.c  */
#line 2648 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 2649 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 2650 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 2651 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 2652 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 2653 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 2654 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 2655 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 2656 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 2657 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 2658 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 2659 "cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 2660 "cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 2661 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 2662 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 2663 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 2664 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 2665 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 2666 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 2667 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 2668 "cf-parse.y"
    { BGP_CFG->enable_extended_messages = (yyvsp[(5) - (6)].i); }
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 2669 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 2670 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 2671 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 2672 "cf-parse.y"
    { BGP_CFG->setkey = (yyvsp[(3) - (4)].i); }
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 2673 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 2679 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 615:
/* Line 1792 of yacc.c  */
#line 2680 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 616:
/* Line 1792 of yacc.c  */
#line 2681 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 617:
/* Line 1792 of yacc.c  */
#line 2682 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_RX; }
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 2683 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_TX; }
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 2684 "cf-parse.y"
    { BGP_CFG->add_path = (yyvsp[(4) - (5)].i) ? ADD_PATH_FULL : 0; }
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 2685 "cf-parse.y"
    { BGP_CFG->allow_local_as = -1; }
    break;

  case 621:
/* Line 1792 of yacc.c  */
#line 2686 "cf-parse.y"
    { BGP_CFG->allow_local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 2687 "cf-parse.y"
    { BGP_CFG->gr_mode = (yyvsp[(4) - (5)].i); }
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 2688 "cf-parse.y"
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 2689 "cf-parse.y"
    { BGP_CFG->gr_time = (yyvsp[(5) - (6)].i); }
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 2690 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 2691 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 2692 "cf-parse.y"
    { BGP_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 2693 "cf-parse.y"
    { BGP_CFG->bfd = (yyvsp[(3) - (4)].i); cf_check_bfd((yyvsp[(3) - (4)].i)); }
    break;

  case 629:
/* Line 1792 of yacc.c  */
#line 2704 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 2720 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 2721 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 635:
/* Line 1792 of yacc.c  */
#line 2722 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 636:
/* Line 1792 of yacc.c  */
#line 2723 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 637:
/* Line 1792 of yacc.c  */
#line 2724 "cf-parse.y"
    { OSPF_CFG->merge_external = (yyvsp[(3) - (3)].i); }
    break;

  case 638:
/* Line 1792 of yacc.c  */
#line 2725 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 2726 "cf-parse.y"
    { OSPF_CFG->instance_id = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<0) || ((yyvsp[(3) - (3)].i)>255)) cf_error("Instance ID must be in range 0-255"); }
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 2730 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 2745 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 2754 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 2755 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 647:
/* Line 1792 of yacc.c  */
#line 2756 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 648:
/* Line 1792 of yacc.c  */
#line 2757 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 649:
/* Line 1792 of yacc.c  */
#line 2758 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 650:
/* Line 1792 of yacc.c  */
#line 2759 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 2760 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 652:
/* Line 1792 of yacc.c  */
#line 2761 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 653:
/* Line 1792 of yacc.c  */
#line 2762 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 654:
/* Line 1792 of yacc.c  */
#line 2763 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 656:
/* Line 1792 of yacc.c  */
#line 2764 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 2776 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 2790 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 2791 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 2792 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 2796 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 670:
/* Line 1792 of yacc.c  */
#line 2797 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 674:
/* Line 1792 of yacc.c  */
#line 2806 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 675:
/* Line 1792 of yacc.c  */
#line 2807 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); }
    break;

  case 676:
/* Line 1792 of yacc.c  */
#line 2808 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 677:
/* Line 1792 of yacc.c  */
#line 2809 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); }
    break;

  case 678:
/* Line 1792 of yacc.c  */
#line 2810 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 679:
/* Line 1792 of yacc.c  */
#line 2811 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 680:
/* Line 1792 of yacc.c  */
#line 2812 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
    break;

  case 681:
/* Line 1792 of yacc.c  */
#line 2813 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
    break;

  case 682:
/* Line 1792 of yacc.c  */
#line 2814 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 2815 "cf-parse.y"
    { ospf_check_auth(); }
    break;

  case 684:
/* Line 1792 of yacc.c  */
#line 2819 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
    break;

  case 685:
/* Line 1792 of yacc.c  */
#line 2838 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 686:
/* Line 1792 of yacc.c  */
#line 2839 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 687:
/* Line 1792 of yacc.c  */
#line 2840 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 688:
/* Line 1792 of yacc.c  */
#line 2841 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); }
    break;

  case 689:
/* Line 1792 of yacc.c  */
#line 2842 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); }
    break;

  case 690:
/* Line 1792 of yacc.c  */
#line 2843 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 691:
/* Line 1792 of yacc.c  */
#line 2844 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 692:
/* Line 1792 of yacc.c  */
#line 2845 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 693:
/* Line 1792 of yacc.c  */
#line 2846 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 694:
/* Line 1792 of yacc.c  */
#line 2847 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 695:
/* Line 1792 of yacc.c  */
#line 2848 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 696:
/* Line 1792 of yacc.c  */
#line 2849 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 697:
/* Line 1792 of yacc.c  */
#line 2850 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 2851 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 2852 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 2853 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 701:
/* Line 1792 of yacc.c  */
#line 2854 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
    break;

  case 702:
/* Line 1792 of yacc.c  */
#line 2855 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 703:
/* Line 1792 of yacc.c  */
#line 2856 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 2857 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 705:
/* Line 1792 of yacc.c  */
#line 2858 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 706:
/* Line 1792 of yacc.c  */
#line 2859 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 707:
/* Line 1792 of yacc.c  */
#line 2860 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 708:
/* Line 1792 of yacc.c  */
#line 2861 "cf-parse.y"
    { OSPF_PATT->link_lsa_suppression = (yyvsp[(4) - (4)].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
    break;

  case 710:
/* Line 1792 of yacc.c  */
#line 2863 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 2864 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
    break;

  case 712:
/* Line 1792 of yacc.c  */
#line 2865 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
    break;

  case 713:
/* Line 1792 of yacc.c  */
#line 2866 "cf-parse.y"
    { OSPF_PATT->rx_buffer = 0; }
    break;

  case 714:
/* Line 1792 of yacc.c  */
#line 2867 "cf-parse.y"
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 2868 "cf-parse.y"
    { OSPF_PATT->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 2869 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 717:
/* Line 1792 of yacc.c  */
#line 2870 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 718:
/* Line 1792 of yacc.c  */
#line 2871 "cf-parse.y"
    { OSPF_PATT->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 719:
/* Line 1792 of yacc.c  */
#line 2872 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 720:
/* Line 1792 of yacc.c  */
#line 2873 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 721:
/* Line 1792 of yacc.c  */
#line 2874 "cf-parse.y"
    { OSPF_PATT->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 722:
/* Line 1792 of yacc.c  */
#line 2875 "cf-parse.y"
    { OSPF_PATT->bsd_secondary = (yyvsp[(2) - (2)].i); }
    break;

  case 723:
/* Line 1792 of yacc.c  */
#line 2876 "cf-parse.y"
    { ospf_check_auth(); }
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 2887 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 729:
/* Line 1792 of yacc.c  */
#line 2897 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 730:
/* Line 1792 of yacc.c  */
#line 2898 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 733:
/* Line 1792 of yacc.c  */
#line 2907 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 734:
/* Line 1792 of yacc.c  */
#line 2908 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 735:
/* Line 1792 of yacc.c  */
#line 2912 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 736:
/* Line 1792 of yacc.c  */
#line 2921 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 2944 "cf-parse.y"
    { OSPF_PATT->instance_id = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Instance ID must be in range 0-255"); }
    break;

  case 739:
/* Line 1792 of yacc.c  */
#line 2948 "cf-parse.y"
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
    break;

  case 745:
/* Line 1792 of yacc.c  */
#line 2962 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 747:
/* Line 1792 of yacc.c  */
#line 2967 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 748:
/* Line 1792 of yacc.c  */
#line 2973 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 749:
/* Line 1792 of yacc.c  */
#line 2976 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 750:
/* Line 1792 of yacc.c  */
#line 2979 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 751:
/* Line 1792 of yacc.c  */
#line 2984 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 752:
/* Line 1792 of yacc.c  */
#line 2987 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 753:
/* Line 1792 of yacc.c  */
#line 2992 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 754:
/* Line 1792 of yacc.c  */
#line 2995 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 755:
/* Line 1792 of yacc.c  */
#line 2999 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 756:
/* Line 1792 of yacc.c  */
#line 3002 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 757:
/* Line 1792 of yacc.c  */
#line 3005 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 758:
/* Line 1792 of yacc.c  */
#line 3006 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 759:
/* Line 1792 of yacc.c  */
#line 3007 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 760:
/* Line 1792 of yacc.c  */
#line 3008 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 761:
/* Line 1792 of yacc.c  */
#line 3009 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 762:
/* Line 1792 of yacc.c  */
#line 3010 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 763:
/* Line 1792 of yacc.c  */
#line 3011 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 764:
/* Line 1792 of yacc.c  */
#line 3012 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 765:
/* Line 1792 of yacc.c  */
#line 3018 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 768:
/* Line 1792 of yacc.c  */
#line 3027 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 769:
/* Line 1792 of yacc.c  */
#line 3032 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 770:
/* Line 1792 of yacc.c  */
#line 3033 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 771:
/* Line 1792 of yacc.c  */
#line 3040 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[(1) - (2)].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
    break;

  case 773:
/* Line 1792 of yacc.c  */
#line 3053 "cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (2)].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 774:
/* Line 1792 of yacc.c  */
#line 3054 "cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 775:
/* Line 1792 of yacc.c  */
#line 3055 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(2) - (2)].i); }
    break;

  case 780:
/* Line 1792 of yacc.c  */
#line 3069 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
    break;

  case 781:
/* Line 1792 of yacc.c  */
#line 3092 "cf-parse.y"
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
    break;

  case 782:
/* Line 1792 of yacc.c  */
#line 3122 "cf-parse.y"
    { RIP_IFACE->metric = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Metric must be in range 1-255"); }
    break;

  case 783:
/* Line 1792 of yacc.c  */
#line 3123 "cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
    break;

  case 784:
/* Line 1792 of yacc.c  */
#line 3124 "cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
    break;

  case 785:
/* Line 1792 of yacc.c  */
#line 3125 "cf-parse.y"
    { RIP_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 786:
/* Line 1792 of yacc.c  */
#line 3126 "cf-parse.y"
    { RIP_IFACE->address = (yyvsp[(2) - (2)].a); }
    break;

  case 787:
/* Line 1792 of yacc.c  */
#line 3127 "cf-parse.y"
    { RIP_IFACE->port = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid port number"); }
    break;

  case 788:
/* Line 1792 of yacc.c  */
#line 3128 "cf-parse.y"
    { RIP_IFACE->version = (yyvsp[(2) - (2)].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[(2) - (2)].i) != RIP_V1) && ((yyvsp[(2) - (2)].i) != RIP_V2)) cf_error("Unsupported version");
			}
    break;

  case 789:
/* Line 1792 of yacc.c  */
#line 3132 "cf-parse.y"
    { RIP_IFACE->version_only = (yyvsp[(3) - (3)].i); }
    break;

  case 790:
/* Line 1792 of yacc.c  */
#line 3133 "cf-parse.y"
    { RIP_IFACE->split_horizon = (yyvsp[(3) - (3)].i); }
    break;

  case 791:
/* Line 1792 of yacc.c  */
#line 3134 "cf-parse.y"
    { RIP_IFACE->poison_reverse = (yyvsp[(3) - (3)].i); }
    break;

  case 792:
/* Line 1792 of yacc.c  */
#line 3135 "cf-parse.y"
    { RIP_IFACE->check_zero = (yyvsp[(3) - (3)].i); }
    break;

  case 793:
/* Line 1792 of yacc.c  */
#line 3136 "cf-parse.y"
    { RIP_IFACE->update_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Update time must be positive"); }
    break;

  case 794:
/* Line 1792 of yacc.c  */
#line 3137 "cf-parse.y"
    { RIP_IFACE->timeout_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Timeout time must be positive"); }
    break;

  case 795:
/* Line 1792 of yacc.c  */
#line 3138 "cf-parse.y"
    { RIP_IFACE->garbage_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Garbage time must be positive"); }
    break;

  case 796:
/* Line 1792 of yacc.c  */
#line 3139 "cf-parse.y"
    { RIP_IFACE->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 797:
/* Line 1792 of yacc.c  */
#line 3140 "cf-parse.y"
    { RIP_IFACE->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("RX length must be in range 256-65535"); }
    break;

  case 798:
/* Line 1792 of yacc.c  */
#line 3141 "cf-parse.y"
    { RIP_IFACE->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 799:
/* Line 1792 of yacc.c  */
#line 3142 "cf-parse.y"
    { RIP_IFACE->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 800:
/* Line 1792 of yacc.c  */
#line 3143 "cf-parse.y"
    { RIP_IFACE->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 801:
/* Line 1792 of yacc.c  */
#line 3144 "cf-parse.y"
    { RIP_IFACE->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 802:
/* Line 1792 of yacc.c  */
#line 3145 "cf-parse.y"
    { RIP_IFACE->ttl_security = 2; }
    break;

  case 803:
/* Line 1792 of yacc.c  */
#line 3146 "cf-parse.y"
    { RIP_IFACE->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 804:
/* Line 1792 of yacc.c  */
#line 3147 "cf-parse.y"
    { RIP_IFACE->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 805:
/* Line 1792 of yacc.c  */
#line 3148 "cf-parse.y"
    { RIP_IFACE->auth_type = (yyvsp[(2) - (2)].i); if ((yyvsp[(2) - (2)].i)) rip_check_auth(); }
    break;

  case 806:
/* Line 1792 of yacc.c  */
#line 3149 "cf-parse.y"
    { rip_check_auth(); }
    break;

  case 807:
/* Line 1792 of yacc.c  */
#line 3153 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_NONE; }
    break;

  case 808:
/* Line 1792 of yacc.c  */
#line 3154 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_PLAIN; }
    break;

  case 809:
/* Line 1792 of yacc.c  */
#line 3155 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; }
    break;

  case 810:
/* Line 1792 of yacc.c  */
#line 3156 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; }
    break;

  case 816:
/* Line 1792 of yacc.c  */
#line 3177 "cf-parse.y"
    { rip_show_interfaces(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); }
    break;

  case 817:
/* Line 1792 of yacc.c  */
#line 3180 "cf-parse.y"
    { rip_show_neighbors(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); }
    break;

  case 818:
/* Line 1792 of yacc.c  */
#line 3186 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 821:
/* Line 1792 of yacc.c  */
#line 3195 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 822:
/* Line 1792 of yacc.c  */
#line 3196 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 823:
/* Line 1792 of yacc.c  */
#line 3197 "cf-parse.y"
    { static_route_finish(); }
    break;

  case 824:
/* Line 1792 of yacc.c  */
#line 3200 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
    break;

  case 825:
/* Line 1792 of yacc.c  */
#line 3210 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
    break;

  case 826:
/* Line 1792 of yacc.c  */
#line 3219 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 827:
/* Line 1792 of yacc.c  */
#line 3223 "cf-parse.y"
    {
     this_srt_nh->use_bfd = (yyvsp[(3) - (3)].i); cf_check_bfd((yyvsp[(3) - (3)].i));
   }
    break;

  case 828:
/* Line 1792 of yacc.c  */
#line 3229 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 829:
/* Line 1792 of yacc.c  */
#line 3230 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 830:
/* Line 1792 of yacc.c  */
#line 3234 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 831:
/* Line 1792 of yacc.c  */
#line 3239 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 832:
/* Line 1792 of yacc.c  */
#line 3245 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 833:
/* Line 1792 of yacc.c  */
#line 3248 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 834:
/* Line 1792 of yacc.c  */
#line 3253 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 835:
/* Line 1792 of yacc.c  */
#line 3254 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 836:
/* Line 1792 of yacc.c  */
#line 3255 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 837:
/* Line 1792 of yacc.c  */
#line 3256 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 838:
/* Line 1792 of yacc.c  */
#line 3257 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 839:
/* Line 1792 of yacc.c  */
#line 3261 "cf-parse.y"
    { *this_srt_last_cmd = (yyvsp[(1) - (1)].x); this_srt_last_cmd = &((yyvsp[(1) - (1)].x)->next); }
    break;

  case 840:
/* Line 1792 of yacc.c  */
#line 3262 "cf-parse.y"
    { this_srt->use_bfd = (yyvsp[(2) - (3)].i); cf_check_bfd((yyvsp[(2) - (3)].i)); }
    break;

  case 845:
/* Line 1792 of yacc.c  */
#line 3277 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 916:
/* Line 1792 of yacc.c  */
#line 3285 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 917:
/* Line 1792 of yacc.c  */
#line 3285 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 928:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 929:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 930:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 931:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 932:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
    break;

  case 933:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
    break;

  case 934:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
    break;

  case 935:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
    break;

  case 936:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
    break;

  case 937:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
    break;

  case 938:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
    break;

  case 939:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
    break;

  case 940:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
    break;

  case 941:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
    break;

  case 942:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
    break;

  case 943:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
    break;

  case 944:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
    break;

  case 945:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
    break;

  case 946:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
    break;

  case 947:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
    break;

  case 948:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
    break;

  case 949:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
    break;

  case 950:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
    break;

  case 951:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
    break;

  case 952:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
    break;

  case 953:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
    break;

  case 954:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
    break;

  case 955:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
    break;

  case 956:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
    break;

  case 957:
/* Line 1792 of yacc.c  */
#line 3288 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
    break;

  case 958:
/* Line 1792 of yacc.c  */
#line 3289 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 959:
/* Line 1792 of yacc.c  */
#line 3289 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 960:
/* Line 1792 of yacc.c  */
#line 3290 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 961:
/* Line 1792 of yacc.c  */
#line 3291 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 962:
/* Line 1792 of yacc.c  */
#line 3292 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 963:
/* Line 1792 of yacc.c  */
#line 3293 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 964:
/* Line 1792 of yacc.c  */
#line 3294 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 965:
/* Line 1792 of yacc.c  */
#line 3295 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 966:
/* Line 1792 of yacc.c  */
#line 3296 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 967:
/* Line 1792 of yacc.c  */
#line 3297 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 968:
/* Line 1792 of yacc.c  */
#line 3298 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 969:
/* Line 1792 of yacc.c  */
#line 3299 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 970:
/* Line 1792 of yacc.c  */
#line 3300 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 971:
/* Line 1792 of yacc.c  */
#line 3301 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
    break;

  case 972:
/* Line 1792 of yacc.c  */
#line 3301 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 973:
/* Line 1792 of yacc.c  */
#line 3301 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 974:
/* Line 1792 of yacc.c  */
#line 3301 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 975:
/* Line 1792 of yacc.c  */
#line 3301 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 976:
/* Line 1792 of yacc.c  */
#line 3301 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 977:
/* Line 1792 of yacc.c  */
#line 3301 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;


/* Line 1792 of yacc.c  */
#line 9970 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 3303 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

